/*
  $RCSfile: moclrslu.c,v $       $Revision: 1.9 $
  $State: V7_0 $                  $Date: 2003/10/01 14:03:37 $
*/
#include "utmemryu.h"
#include "utlarryu.h"
#include "utfilesu.h"
#include "utstrngu.h"
#include "utsysclu.h"

#include "moclrslu.h"
#include "modefltw.h"
#include "momessgc.h"

static Colormap moclrslColorMap;
static pSarray  moclrslColors = NULL;
static pLarray  moclrslColorIdentifiers = NULL;
static int      moclrslMaxColorRGBValue;

#ifdef __STDC__
utLogical moLoadColorData()
#else
utLogical moLoadColorData()
#endif
{
   utLogical  colorDataLoaded = utTrue;
/*
   Display   *display = moGetDefaultDisplay();
   FILE      *fp;
   int        i1,nColors;
   char      *colorsFileName;
   char      *dataDirectory = utGetBAT_DATAPath();
   char      *errorMessage;

   colorsFileName = utMakeFileName(dataDirectory,
                                   COLORSFILENAME,
                                   COLORSFILEEXTENSION);
   if((fp = utFileOpen(colorsFileName,FileOpenStatusRead)) != NULL) {
      moclrslColors = utLoadSarray(fp);
      utFileClose(fp);
      nColors = utGetCountSarray(moclrslColors);
      moclrslColorIdentifiers = utCreateLarrayOfSize(nColors);
      for(i1=0 ; i1<nColors ; i1++)
         utSetLongAtPositionInLarray(moclrslColorIdentifiers,i1,(long)NOCOLORID);

      moclrslColorMap = DefaultColormapOfScreen(DefaultScreenOfDisplay(display));
   } else {
      errorMessage = utCatStringPlusString("Could not open colors file:",
                                           " ",colorsFileName);
      moSendError(errorMessage);
      utFreeBytes((pVoid)errorMessage);
      moclrslColors = utCreateSarrayOfSize(0);
      colorDataLoaded = utFalse;
   }
   utFreeBytes((pVoid)colorsFileName);
   utFreeBytes((pVoid)dataDirectory);
*/

   return(colorDataLoaded);
}


#ifdef __STDC__
void moFreeColorData()
#else
void moFreeColorData()
#endif
{
   Display *display = moGetDefaultDisplay();

   if(moclrslColors != NULL)
      XFreeColormap(display,moclrslColorMap);

   utFreeSarray(&moclrslColors);
}


#ifdef __STDC__
pSarray moGetColors()
#else
pSarray moGetColors()
#endif
{
   utLogical colorDataLoaded;

   if(moclrslColors == NULL)
      colorDataLoaded = moLoadColorData();

   return(moclrslColors);
}


#ifdef __STDC__
char *moGetColor(ColorIdentifier colorIdentifier)
#else
char *moGetColor(colorIdentifier)
ColorIdentifier colorIdentifier;
#endif
{
   char      *color = WHITE;
   return(color);
}


#ifdef __STDC__
ColorIdentifier moGetColorIdentifier(char *color)
#else
ColorIdentifier moGetColorIdentifier(color)
char *color;
#endif
{
   Display         *display = moGetDefaultDisplay();
   ColorIdentifier  colorIdentifier = 2;
   int              colorIndex;
   Status           allocationStatus;
   XColor           colorCell;
   XColor           colorDB;
   utLogical        colorDataLoaded;

/*
   if(moclrslColors == NULL)
      colorDataLoaded = moLoadColorData();

   colorIndex = utStringPositionInSarray(color,moclrslColors);
   if(colorIndex >= 0) {
      colorIdentifier = utGetLongAtPositionInLarray(moclrslColorIdentifiers,colorIndex);
      if(colorIdentifier == NOCOLORID) {
         allocationStatus = XAllocNamedColor(display,moclrslColorMap,
                                             color,
                                             &colorCell,&colorDB);
         if(allocationStatus != 0) {
            colorIdentifier = (ColorIdentifier)colorCell.pixel;
            utSetLongAtPositionInLarray(moclrslColorIdentifiers,
                                        colorIndex,
                                        (long)colorIdentifier);
         }
      }
   }
*/

   return(colorIdentifier);
}


#ifdef __STDC__
void moGetColorIdentifierRGB(ColorIdentifier colorIdentifier,
                             int *red,
                             int *green,
                             int *blue)
#else
void moGetColorIdentifierRGB(colorIdentifier,
                             red,
                             green,
                             blue)
ColorIdentifier  colorIdentifier;
int             *red;
int             *green;
int             *blue;
#endif
{
   Display   *display = moGetDefaultDisplay();
   XColor     colorCell;
   utLogical  colorDataLoaded;

   if(moclrslColors == NULL)
      colorDataLoaded = moLoadColorData();

   colorCell.pixel = colorIdentifier;
   XQueryColor(display,moclrslColorMap,&colorCell);

   *red   = colorCell.red;
   *green = colorCell.green;
   *blue  = colorCell.blue;
}


#ifdef __STDC__
int moGetMaxColorRGBValue()
#else
int moGetMaxColorRGBValue()
#endif
{
   return(moclrslMaxColorRGBValue);
}


#ifdef __STDC__
void moSetMaxColorRGBValue()
#else
void moSetMaxColorRGBValue()
#endif
{
   ColorIdentifier colorIdentifier = moGetColorIdentifier(WHITE);
   int             red   = 1;
   int             green = 1;
   int             blue  = 1;

   if(colorIdentifier >= 0)
      moGetColorIdentifierRGB(colorIdentifier,
                              &red,
                              &green,
                              &blue);
   moclrslMaxColorRGBValue = red;
}


