/*
  $RCSfile: modefltw.c,v $       $Revision: 1.7 $
  $State: V7_1 $                  $Date: 2004/11/04 17:49:03 $
*/
#include <assert.h>

#include <Xm/MenuShell.h>

#include "modefltw.h"
#include "modefltp.h"
#include "momotifu.h"

/* to take care of lprintf */
#ifdef BPTPC
#define LPRNTF
#endif
#include "utprntfu.h"

#ifdef __STDC__
void moSetDefaultAppContext(XtAppContext appContext)
#else
void moSetDefaultAppContext(appContext)
XtAppContext appContext;
#endif
{
   assert(appContext != NULL);

   moDefaultAppContext = appContext;
}


XtAppContext moGetDefaultAppContext()
{
   assert(moDefaultAppContext != NULL);

   return(moDefaultAppContext);
}


Widget moGetDefaultParentWidget()
{
   assert(moDefaultParent != NULL);

   return(moDefaultParent);
}


#ifdef __STDC__
void moSetDefaultParentWidget(Widget parent)
#else
void moSetDefaultParentWidget(parent)
Widget parent;
#endif
{
   Widget menuParent;

   assert(parent != NULL);

   if(!XmIsMenuShell(parent)) {
      moDefaultParent = parent;
#ifdef DEBUGDefaultParent
      utConsolePrint(" Default parent set to %s\n",moGetWidgetName(parent));
#endif
   } else {
      menuParent = XtParent(parent);
      if(menuParent != NULL) {
         moDefaultParent = menuParent;
#ifdef DEBUGDefaultParent
         utConsolePrint(" Default parent set to %s\n",moGetWidgetName(menuParent));
#endif
      } else {
#ifdef DEBUGDefaultParent
         utConsolePrint(" Default parent not set to %s\n",moGetWidgetName(parent));
#endif
      }
   }
}


Display *moGetDefaultDisplay()
{
   Display *display = NULL;

   if(moDefaultParent != NULL)
      display = XtDisplay(moDefaultParent);

   return(display);
}


Screen *moGetDefaultScreen()
{
   Screen *screen = NULL;

   if(moDefaultParent != NULL)
      screen = XtScreen(moDefaultParent);

   return(screen);
}


