/*
  $RCSfile: molistw.h,v $       $Revision: 1.12 $
  $State: V7_1 $                  $Date: 2005/01/14 17:55:42 $
*/
#ifndef _MOLISTW_H
#define _MOLISTW_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <Xm/List.h>

#include "uttypesu.h"
#include "utsarryu.h"
#include "utiarryu.h"

#include "moclrslu.h"

typedef enum {
   ListOperationAdd,
   ListOperationInsert,
   ListOperationChange,
   ListOperationDelete,
   ListOperationCopy,
   ListOperationPaste,
   ListOperationCut,
   ListOperationClear,
   ListOperationReplace,
   ListOperationAddFile,
   ListOperationInsertFile
} ListOperation;

#ifdef __STDC__
   extern int moGetCountLS(Widget wList);
   extern pSarray moGetSarrayFromLS(Widget wList);
   extern pIarray moGetIarrayFromLS(Widget wList);
   extern int moGetSelectedPositionLS(Widget wList);
   extern pIarray moGetSelectedPositionsLS(Widget wList);
   extern utLogical moIsAnyItemSelectedInLS(Widget wList);
   extern void moClearLS(Widget wList);
   extern void moDeleteFromLS(Widget wList,
                              int position);
   extern void moDeleteSelectedItemsFromLS(Widget wList);
   extern void moAddCstringToLS(Widget wList,
                                char *cstring);
   extern void moAddCstringToLSAtPosition(Widget wList,
                                          char *string,
                                          int position);
   extern void moAddCstringSortedInLS(Widget wList,
                                      char* newCstring,
                                      utCaseType caseType);
   extern void moAddSarrayToLS(Widget wList,
                               pSarray listItems);
   extern void moAddSarrayToLSAtPosition(Widget wList,
                                         pSarray listItems,
                                         int position);
   extern void moAddSarraySortedInLS(Widget wList,
                                     pSarray listItems,
                                     utCaseType caseType);
   extern void moInsertCstringInLSAtPosition(Widget wList,
                                             char *cstring,
                                             int position);
   extern void moInsertSarrayInLSAtPosition(Widget wList,
                                            pSarray sarray,
                                            int position);
   extern void moChangeCstringInLSAtPosition(Widget wList,
                                             char *cstring,
                                             int position);
   extern void moLoadSarrayToLS(Widget wList,
                                pSarray listItems);
   extern void moDeselectAllItemsInLS(Widget wList);
   extern utLogical moIsInLS(Widget wList,
                             char *string);
   extern pSarray moGetColumn1FromLS(Widget wList,
                                     int columnWidth);
   extern utLogical moIsInColumn1OfLS(Widget wList,
                                      int columnWidth,
                                      char *string);
   extern pSarray moGetColumn2FromLS(Widget wList,
                                     int offset,
                                     int columnWidth);
   extern utLogical moIsInColumn2OfLS(Widget wList,
                                      int offset,
                                      int columnWidth,
                                      char *string);
   extern pSarray moGetSelectedItemsInLS(Widget wList);
   extern char *moGetSelectedItemInLS(Widget wList);
   extern int moGetSelectedItemsCountInLS(Widget wList);
   extern utLogical moItemExistsInLS(Widget wList,
                                     char *item);
   extern void moSetBrowseSelectionForLS(Widget wList);
   extern void moSetExtendedSelectionForLS(Widget wList);
   extern int moGetVisibleItemCountLS(Widget wList);
   extern void moSetVisibleItemCountLS(Widget wList,
                                       int count);
   extern void moDisableInputLS(Widget wList,
                                utLogical disableScrollBars);
   extern void moEnableInputLS(Widget wList);
   extern utLogical moIsEmptyLS(Widget wList);
   extern void moSelectItemAtPositionInLS(Widget wList,
                                          int position);
   extern void moSelectItemInLS(Widget wList,
                                char *item);
   extern void moSelectItemsInLS(Widget wList,
                                 pSarray items);
   extern ColorIdentifier moGetSubformColorIdentifier();
   extern void moSetSubformForegroundColorLS(Widget wList);
   extern void moReplaceSelectedItemInLS(Widget wList,
                                         char *item);
   extern void moHighlightItemInLS(Widget wList,
                                   char *item);
   extern void moHighlightItemAtPositionInLS(Widget wList,
                                             int position);
   extern void moSetListActionFunctions(Widget wList,
                                        char *f2Function,
                                        void rightClickFunction(Widget w));
#else
   extern int moGetCountLS();
   extern pSarray moGetSarrayFromLS();
   extern pIarray moGetIarrayFromLS();
   extern int moGetSelectedPositionLS();
   extern pIarray moGetSelectedPositionsLS();
   extern utLogical moIsAnyItemSelectedInLS();
   extern void moClearLS();
   extern void moDeleteFromLS();
   extern void moDeleteSelectedItemsFromLS();
   extern void moAddCstringToLS();
   extern void moAddCstringToLSAtPosition();
   extern void moAddCstringSortedInLS();
   extern void moAddSarrayToLS();
   extern void moAddSarrayToLSAtPosition();
   extern void moAddSarraySortedInLS();
   extern void moInsertCstringInLSAtPosition();
   extern void moInsertSarrayInLSAtPosition();
   extern void moChangeCstringInLSAtPosition();
   extern void moLoadSarrayToLS();
   extern void moDeselectAllItemsInLS();
   extern utLogical moIsInLS();
   extern pSarray moGetColumn1FromLS();
   extern utLogical moIsInColumn1OfLS();
   extern pSarray moGetColumn2FromLS();
   extern utLogical moIsInColumn2OfLS();
   extern pSarray moGetSelectedItemsInLS();
   extern char *moGetSelectedItemInLS();
   extern int moGetSelectedItemsCountInLS();
   extern utLogical moItemExistsInLS();
   extern void moSetBrowseSelectionForLS();
   extern void moSetExtendedSelectionForLS();
   extern int moGetVisibleItemCountLS();
   extern void moSetVisibleItemCountLS();
   extern void moDisableInputLS();
   extern void moEnableInputLS();
   extern utLogical moIsEmptyLS();
   extern void moSelectItemAtPositionInLS();
   extern void moSelectItemInLS();
   extern void moSelectItemsInLS();
   extern ColorIdentifier moGetSubformColorIdentifier();
   extern void moSetSubformForegroundColorLS();
   extern void moReplaceSelectedItemInLS();
   extern void moHighlightItemInLS();
   extern void moHighlightItemAtPositionInLS();
   extern void moSetListActionFunctions();
#endif

#ifdef __cplusplus
   }
#endif

#endif
