/*
  $RCSfile: mosbutnc.c,v $       $Revision: 1.10 $
  $State: V7_0 $                  $Date: 2004/02/13 17:00:10 $
*/
#include "utmemryu.h"
#include "utstrcvu.h"
#include "utstrngu.h"
#include "utprntfu.h"

#include "momotifu.h"
#include "modefltw.h"
#include "molistw.h"
#include "motextfw.h"
#include "mosbutnc.h"
#include "mosbutnu.h"

static unsigned int lastButtonPressButton = 0;
static Time         lastButtonPressTime   = 0;
static utLogical    mosbutnButtonPressFirstTime = utTrue;
static Time         mosbutnMultiClickTime;

#ifdef __STDC__
void mosbutnBtprAnyDoubleClick(Widget w,
                               XtPointer client_data,
                               XEvent *genericEvent,
                               Boolean *continueDispatch)
#else
void mosbutnBtprAnyDoubleClick(w,
                               client_data,
                               genericEvent,
                               continueDispatch)
Widget     w;
XtPointer  client_data;
XEvent    *genericEvent;
Boolean   *continueDispatch;
#endif
{
   XButtonPressedEvent        *event = (XButtonPressedEvent *)genericEvent;
   pSButtonFunctionParameters  sButtonFunctionParameters = (pSButtonFunctionParameters)client_data;
   unsigned int                button     = event->button;
   unsigned int                controlMod = event->state & ControlMask;
   utLogical                   isDoubleClick = utFalse;
   Display                    *display;
   Cardinal                    nParameters;
   char                       *multiClickTime;

   if(mosbutnButtonPressFirstTime) {
      multiClickTime = moGetResourceValue("BATCHES","SButtonDoubleClickTime");
      if(!utHasAllBlanks(multiClickTime))
         mosbutnMultiClickTime = (Time)utStringToInt(multiClickTime);
      else {
         display = moGetDefaultDisplay();
         mosbutnMultiClickTime = XtGetMultiClickTime(display);
      }
      utFreeBytes((pVoid)multiClickTime);
      mosbutnButtonPressFirstTime = utFalse;
   }

   if(event->state == 0) {
      if(button == lastButtonPressButton) {
         if       (event->time-lastButtonPressTime <= mosbutnMultiClickTime) {
            isDoubleClick = utTrue;
         } else {
/*          utConsolePrint("Took too long(%ld) to double click - %ld\n",mosbutnMultiClickTime,
                                                                        event->time-lastButtonPressTime);   */
         }
      }
      lastButtonPressButton = button;
      lastButtonPressTime   = event->time;
   }

   if(isDoubleClick) {
      switch(button) {
         case Button1:
            nParameters = (Cardinal)utGetCountSarray(sButtonFunctionParameters->Parameters);
            (sButtonFunctionParameters->ActionFunction)(w,
                                                        genericEvent,
                                                        sButtonFunctionParameters->Parameters->strings,
                                                        &nParameters);
            break;
         case Button2:
#ifdef DEBUGButtons
            utConsolePrint("TextField DoubleButton2 Pressed Event %d\n",event->type);
#endif
            break;
         case Button3:
#ifdef DEBUGButtons
            utConsolePrint("TextField DoubleButton3 Pressed Event %d\n",event->type);
#endif
            break;
      }
      lastButtonPressButton = 0;
   } else {
      if(controlMod) {
         if(XmIsTextField(w))
            if(sButtonFunctionParameters->FieldIsBlankable)
               moClearTF(w);
      }
   }
}


#ifdef __STDC__
void mosbutnBtrlAnyButton(Widget w,
                          XtPointer client_data,
                          XEvent *genericEvent,
                          Boolean *continueDispatch)
#else
void mosbutnBtrlAnyButton(w,
                          client_data,
                          genericEvent,
                          continueDispatch)
Widget     w;
XtPointer  client_data;
XEvent    *genericEvent;
Boolean   *continueDispatch;
#endif
{
   XButtonReleasedEvent       *event = (XButtonReleasedEvent *)genericEvent;
   pSButtonFunctionParameters  sButtonFunctionParameters = (pSButtonFunctionParameters)client_data;
   unsigned int                button = event->button;
   Cardinal                    nParameters;

   if(button == Button3) {
      if(event->state == Button3Mask) {
         nParameters = (Cardinal)utGetCountSarray(sButtonFunctionParameters->Parameters);
         (sButtonFunctionParameters->ActionFunction)(w,
                                                     genericEvent,
                                                     sButtonFunctionParameters->Parameters->strings,
                                                     &nParameters);
      }
   } else {
#ifdef DEBUGButtons
      utConsolePrint("mosbutnBtrlAnyButton button %d pressed\n",button);
#endif
   }
}


#ifdef __STDC__
void mosbutnBrwsAnyLS(Widget w,
                      XtPointer client_data,
                      XtPointer xt_call_data)
#else
void mosbutnBrwsAnyLS(w,
                      client_data,
                      xt_call_data)
Widget    w;
XtPointer client_data;
XtPointer xt_call_data;
#endif
{
}


#ifdef __STDC__
void mosbutnDestroySButton(Widget w,
                           XtPointer client_data,
                           XtPointer xt_call_data)
#else
void mosbutnDestroySButton(w, client_data, call_data)
Widget    w;
XtPointer client_data;
XtPointer call_data;
#endif
{
   pSButtonFunctionParameters sButtonFunctionParameters = (pSButtonFunctionParameters)client_data;

   moRemoveSBtnFuncParamFromList(sButtonFunctionParameters);
}


