/*
  $RCSfile: mosbutnu.c,v $       $Revision: 1.16 $
  $State: V7_1 $                  $Date: 2004/11/04 17:49:22 $
*/
#include "utmemryu.h"
#include "utstrngu.h"
#include "utmapspu.h"
#include "utlistpu.h"
#include "utiarryu.h"

#include "modefltw.h"
#include "momotifu.h"
#include "motextfw.h"
#include "molistw.h"
#include "mosbutnc.h"
#include "mosbutnu.h"

/*  lprintf gets included because of other includes.  */
#ifdef BPTPC
#define LPRNTF
#endif
#include "utprntfu.h"

static pMapStrToPtr  mosbutnSbuttonFunctionMap = NULL;
static pListOfPtrs   mosbutnSbuttonParameterList = NULL;
static char         *sButtonBackgroundColor = WHEAT;
static long          mosbutnDefaultTextFieldSbuttonColor = -1;

#ifdef __STDC__
void moRegisterSbuttonFunctions(XtActionList actionList,
                                Cardinal nActions)
#else
void moRegisterSbuttonFunctions(actionList,
                                nActions)
XtActionList actionList;
Cardinal     nActions;
#endif
{
   int          i1;
   pVoid        actionFunction;
   XtAppContext appContext = moGetDefaultAppContext();

/*
   if(mosbutnSbuttonFunctionMap == NULL)
      mosbutnSbuttonFunctionMap = utCreateMapStrToPtr(DEFAULT_NHASHBUCKET,
                                                      DEFAULT_HASHBUCKETSIZE);

   for(i1=0 ; i1<(int)nActions ; i1++) {
      if(!utLookupMapStrToPtr(mosbutnSbuttonFunctionMap,
                              actionList[i1].string,
                              &actionFunction)) {
         utSetMapStrToPtr(mosbutnSbuttonFunctionMap,
                          actionList[i1].string,
                          (pVoid)actionList[i1].proc);
         XtAppAddActions(appContext,
                         &actionList[i1],1);
      }
   }
*/
}


#ifdef __STDC__
pSButtonFunctionParameters moCreateSButtonFunctParameters(Widget field,
                                                          char *sButtonFunction)
#else
pSButtonFunctionParameters moCreateSButtonFunctParameters(field,
                                                          sButtonFunction)
Widget  field;
char   *sButtonFunction;
#endif
{
   pSButtonFunctionParameters  newSButtonFunctionParameters = NULL;
   char                       *functionName = NULL;
   pVoid                       actionFunction;
   int                         fieldNumber = 1;
   char                       *parameter;
   char                       *parameters;
   size_t                      parameterLength;
   pIarray                     parenLocations;
   int                         openParenLocation;
   int                         closeParenLocation;
   int                         nParens;
/*
   functionName = utGetDelimitedField(sButtonFunction,"(",1);
   if(utLookupMapStrToPtr(mosbutnSbuttonFunctionMap,
                          functionName,
                          &actionFunction)) {
      newSButtonFunctionParameters = (pSButtonFunctionParameters)utGetBytes(sizeof(SButtonFunctionParameters));
      newSButtonFunctionParameters->StructType       = STRUCTTYPE_SBUTTONFUNCTIONPARAMETERS;
      newSButtonFunctionParameters->Field            = field;
      newSButtonFunctionParameters->FieldIsBlankable = utTrue;
      newSButtonFunctionParameters->SButtonFunction  = utAssignString(sButtonFunction);
      newSButtonFunctionParameters->ActionFunction   = (XtActionProc)actionFunction;
      newSButtonFunctionParameters->Parameters       = utCreateSarray();

      parenLocations = utLocateCharacterInString(sButtonFunction,'(');
      openParenLocation = utGetIntAtPositionInIarray(parenLocations,0);
      utFreeIarray(&parenLocations);
      parenLocations = utLocateCharacterInString(sButtonFunction,')');
      nParens = utGetCountIarray(parenLocations);
      closeParenLocation = utGetIntAtPositionInIarray(parenLocations,nParens-1);
      utFreeIarray(&parenLocations);

      parameters = utExtractString(sButtonFunction,openParenLocation+1,closeParenLocation-1);
      if(!utIsNullString(parameters)) {
         parameter = utGetDelimitedField(parameters,",",fieldNumber);
         while(!utIsNullString(parameter)) {
            parameterLength = utStringLength(parameter);
            parameter[parameterLength-1] = '\0';
            utAddToSarray(newSButtonFunctionParameters->Parameters,&parameter[1]);
            utFreeBytes((pVoid)parameter);
            fieldNumber++;
            parameter = utGetDelimitedField(parameters,",",fieldNumber);
         }
      }
      utFreeBytes((pVoid)parameters);
   } else
      utConsolePrint("SButtonFunction not Registered : %s\n",sButtonFunction);

   utFreeBytes((pVoid)functionName);

*/
   return(newSButtonFunctionParameters);
}


#ifdef __STDC__
void moFreeSButtonFunctionParameters(pSButtonFunctionParameters *sButtonFunctionParameters)
#else
void moFreeSButtonFunctionParameters(sButtonFunctionParameters)
pSButtonFunctionParameters *sButtonFunctionParameters;
#endif
{
   if(*sButtonFunctionParameters == NULL)
      return;

   utFreeBytes((pVoid)(*sButtonFunctionParameters)->SButtonFunction);
   utFreeSarray(&(*sButtonFunctionParameters)->Parameters);

   utFreeBytes((pVoid)*sButtonFunctionParameters);
   *sButtonFunctionParameters = NULL;
}


#ifdef __STDC__
void moAddSButtonFuncParameterToList(pSButtonFunctionParameters sButtonFunctionParameters)
#else
void moAddSButtonFuncParameterToList(sButtonFunctionParameters)
pSButtonFunctionParameters sButtonFunctionParameters;
#endif
{
   if(mosbutnSbuttonParameterList == NULL)
      mosbutnSbuttonParameterList = utCreateListOfPtrs(DEFAULT_BLOCK_SIZE);

   utAddTailListOfPtrs(mosbutnSbuttonParameterList,
                       (pVoid)sButtonFunctionParameters);
}


#ifdef __STDC__
void moRemoveSBtnFuncParamFromList(pSButtonFunctionParameters sButtonFunctionParameters)
#else
void moRemoveSBtnFuncParamFromList(sButtonFunctionParameters)
pSButtonFunctionParameters sButtonFunctionParameters;
#endif
{
   utLogical wasRemoved;

   wasRemoved = utRemoveItemListOfPtrs(mosbutnSbuttonParameterList,(pVoid)sButtonFunctionParameters);
   if(wasRemoved)
      moFreeSButtonFunctionParameters(&sButtonFunctionParameters);
}


#ifdef __STDC__
void moDestroySButtonFunctionLists()
#else
void moDestroySButtonFunctionLists()
#endif
{
   int                        i1,nList;
   pSButtonFunctionParameters sButtonFunctionParameters;

   if(mosbutnSbuttonFunctionMap != NULL) {
      mosbutnSbuttonFunctionMap = NULL;
   }

   if(mosbutnSbuttonParameterList != NULL) {
      nList = utGetCountListOfPtrs(mosbutnSbuttonParameterList);
      for(i1=0 ; i1<nList ; i1++) {
         sButtonFunctionParameters = (pSButtonFunctionParameters)utGetPtrAtPositionInListOfPtrs(mosbutnSbuttonParameterList,i1);
         moFreeSButtonFunctionParameters(&sButtonFunctionParameters);
      }
      utDestroyListOfPtrs(mosbutnSbuttonParameterList);
   }
}


#ifdef __STDC__
void moSetTextFieldSbuttonFunction(Widget textField,
                                   utLogical editable,
                                   char *sButtonFunction)
#else
void moSetTextFieldSbuttonFunction(textField,
                                   editable,
                                   sButtonFunction)
Widget     textField;
utLogical  editable;
char      *sButtonFunction;
#endif
{
   char                       *translationString;
   XrmValue                    fromValue,toValue;
   static XmTextScanType       sButtonScanTypeArray[] = { XmSELECT_POSITION };
   static XmTextScanType       textFieldScanTypeArray[] = { XmSELECT_POSITION , XmSELECT_WORD , XmSELECT_LINE };
   int                         ac;
   Arg                         al[2];
   XtTranslations              translations;
   Boolean                     convertOk;
   pSButtonFunctionParameters  sButtonFunctionParameters;
   int                         i1,nList;
   utLogical                   widgetFunctionExists = utFalse;

   assert(XmIsTextField(textField));

   if(!utIsNullString(sButtonFunction)) {
      moEnableInputTF(textField);

      ac = 0;
      XtSetArg(al[ac],XmNselectionArrayCount,1); ac++;
      XtSetArg(al[ac],XmNselectionArray,sButtonScanTypeArray); ac++;
      XtSetValues(textField,al,ac);

      translationString = utCatStringPlusString("<Key>F2:"," ",sButtonFunction);
      translations = XtParseTranslationTable(translationString);
      XtOverrideTranslations(textField,translations);
      utFreeBytes((pVoid)translationString);

      /* Check for previous establishment of this widget/sButtonFunction combination */

      if(mosbutnSbuttonParameterList != NULL) {
         nList = utGetCountListOfPtrs(mosbutnSbuttonParameterList);
         for(i1=0 ; i1<nList ; i1++) {
            sButtonFunctionParameters = (pSButtonFunctionParameters)utGetPtrAtPositionInListOfPtrs(mosbutnSbuttonParameterList,i1);
            if(textField == sButtonFunctionParameters->Field) {
               if(utEqualStrings(sButtonFunction,sButtonFunctionParameters->SButtonFunction)) {
                  widgetFunctionExists = utTrue;
               } else {
                  XtRemoveEventHandler(textField,ButtonPressMask,FALSE,
                                                 mosbutnBtprAnyDoubleClick,(XtPointer)sButtonFunctionParameters);
                  XtRemoveEventHandler(textField,ButtonReleaseMask,FALSE,
                                                 mosbutnBtrlAnyButton,(XtPointer)sButtonFunctionParameters);
                  moRemoveSBtnFuncParamFromList(sButtonFunctionParameters);
               }
               break;
            }
         }
      }

      if(!widgetFunctionExists) {
         sButtonFunctionParameters = moCreateSButtonFunctParameters(textField,sButtonFunction);
         XtAddEventHandler(textField,ButtonPressMask,FALSE,
                                     mosbutnBtprAnyDoubleClick,(XtPointer)sButtonFunctionParameters);
         XtAddEventHandler(textField,ButtonReleaseMask,FALSE,
                                     mosbutnBtrlAnyButton,(XtPointer)sButtonFunctionParameters);
         XtAddCallback(textField,XmNdestroyCallback,mosbutnDestroySButton,(XtPointer)sButtonFunctionParameters);
         moAddSButtonFuncParameterToList(sButtonFunctionParameters);
         mosbutnDefaultTextFieldSbuttonColor = (long)moGetBackgroundPixel(textField);
      }

      fromValue.addr = sButtonBackgroundColor;
      fromValue.size = utStringLength(fromValue.addr)+1;
      toValue.addr = NULL;
      convertOk = XtConvertAndStore(textField,XmRString,&fromValue,XmRPixel,&toValue);
      if(convertOk)
         moSetBackgroundPixel(textField,(Pixel)*(unsigned int *)toValue.addr);
      else
         utConsolePrint("Sbutton color conversion failed\n");
   } else {
      if(mosbutnSbuttonParameterList != NULL) {
         nList = utGetCountListOfPtrs(mosbutnSbuttonParameterList);
         for(i1=0 ; i1<nList ; i1++) {
            sButtonFunctionParameters = (pSButtonFunctionParameters)utGetPtrAtPositionInListOfPtrs(mosbutnSbuttonParameterList,i1);
            if(textField == sButtonFunctionParameters->Field) {
               XtRemoveEventHandler(textField,ButtonPressMask,FALSE,
                                              mosbutnBtprAnyDoubleClick,(XtPointer)sButtonFunctionParameters);
               XtRemoveEventHandler(textField,ButtonReleaseMask,FALSE,
                                              mosbutnBtrlAnyButton,(XtPointer)sButtonFunctionParameters);
               moRemoveSBtnFuncParamFromList(sButtonFunctionParameters);
               widgetFunctionExists = utTrue;
               break;
            }
         }
      }

      if(widgetFunctionExists) {
         ac = 0;
         XtSetArg(al[ac],XmNselectionArrayCount,3); ac++;
         XtSetArg(al[ac],XmNselectionArray,textFieldScanTypeArray); ac++;
         XtSetValues(textField,al,ac);

         translations = XtParseTranslationTable("<Key>F2:");
         XtOverrideTranslations(textField,translations);

         if(mosbutnDefaultTextFieldSbuttonColor >= 0)
            moSetBackgroundPixel(textField,(Pixel)mosbutnDefaultTextFieldSbuttonColor);
      }
   }

   if(editable) {
      if(utIsNullString(sButtonFunction))
         moEnableInputTF(textField);
      moSetEditableTF(textField);
      moSetCursorVisibleOnTF(textField);
   } else {
      if(utIsNullString(sButtonFunction))
         moDisableInputTF(textField);
      moSetUneditableTF(textField);
      moSetCursorVisibleOffTF(textField);
   }
}


#ifdef __STDC__
void moResetTextFieldSbuttonFunction(Widget textField,
                                     utLogical editable,
                                     char *sButtonFunction)
#else
void moResetTextFieldSbuttonFunction(textField,
                                     editable,
                                     sButtonFunction)
Widget     textField;
utLogical  editable;
char      *sButtonFunction;
#endif
{
   char                       *translationString;
   XtTranslations              translations;
   pSButtonFunctionParameters  sButtonFunctionParameters;
   int                         i1,nList;
   utLogical                   widgetFunctionExists = utFalse;

   assert(XmIsTextField(textField));

   translationString = utCatStringPlusString("<Key>F2:"," ",sButtonFunction);
   translations = XtParseTranslationTable(translationString);
   XtOverrideTranslations(textField,translations);
   utFreeBytes((pVoid)translationString);

   /* Check for previous establishment of this widget/sButtonFunction combination */

   if(mosbutnSbuttonParameterList != NULL) {
      nList = utGetCountListOfPtrs(mosbutnSbuttonParameterList);
      for(i1=0 ; i1<nList ; i1++) {
         sButtonFunctionParameters = (pSButtonFunctionParameters)utGetPtrAtPositionInListOfPtrs(mosbutnSbuttonParameterList,i1);
         if(textField == sButtonFunctionParameters->Field) {
            if(utEqualStrings(sButtonFunction,sButtonFunctionParameters->SButtonFunction)) {
               widgetFunctionExists = utTrue;
            } else {
               XtRemoveEventHandler(textField,ButtonPressMask,FALSE,
                                              mosbutnBtprAnyDoubleClick,(XtPointer)sButtonFunctionParameters);
               XtRemoveEventHandler(textField,ButtonReleaseMask,FALSE,
                                              mosbutnBtrlAnyButton,(XtPointer)sButtonFunctionParameters);
               moRemoveSBtnFuncParamFromList(sButtonFunctionParameters);
            }
            break;
         }
      }
   }

   if(!widgetFunctionExists) {
      sButtonFunctionParameters = moCreateSButtonFunctParameters(textField,sButtonFunction);
      XtAddEventHandler(textField,ButtonPressMask,FALSE,
                                  mosbutnBtprAnyDoubleClick,(XtPointer)sButtonFunctionParameters);
      XtAddEventHandler(textField,ButtonReleaseMask,FALSE,
                                  mosbutnBtrlAnyButton,(XtPointer)sButtonFunctionParameters);
      XtAddCallback(textField,XmNdestroyCallback,mosbutnDestroySButton,(XtPointer)sButtonFunctionParameters);
      moAddSButtonFuncParameterToList(sButtonFunctionParameters);
   }

   if(editable) {
      if(utIsNullString(sButtonFunction))
         moEnableInputTF(textField);
      moSetEditableTF(textField);
      moSetCursorVisibleOnTF(textField);
   } else {
      if(utIsNullString(sButtonFunction))
         moDisableInputTF(textField);
      moSetUneditableTF(textField);
      moSetCursorVisibleOffTF(textField);
   }
}


#ifdef __STDC__
utLogical moIsSbuttonWidget(Widget w)
#else
utLogical moIsSbuttonWidget(w)
Widget w;
#endif
{
   utLogical                  isSbuttonWidget = utFalse;
   pSButtonFunctionParameters sButtonFunctionParameters;
   int                        i1,nList;

   if(mosbutnSbuttonParameterList != NULL) {
      nList = utGetCountListOfPtrs(mosbutnSbuttonParameterList);
      for(i1=0 ; i1<nList ; i1++) {
         sButtonFunctionParameters = (pSButtonFunctionParameters)utGetPtrAtPositionInListOfPtrs(mosbutnSbuttonParameterList,i1);
         if(w == sButtonFunctionParameters->Field) {
            isSbuttonWidget = utTrue;
            break;
         }
      }
   }

   return(isSbuttonWidget);
}


#ifdef __STDC__
ColorIdentifier moGetSbuttonColorIdentifier()
#else
ColorIdentifier moGetSbuttonColorIdentifier()
#endif
{
   ColorIdentifier colorIdentifier = moGetColorIdentifier(sButtonBackgroundColor);

   return(colorIdentifier);
}


#ifdef __STDC__
void moSetListSbuttonFunction(Widget list,
                              char *sButtonFunction)
#else
void moSetListSbuttonFunction(list,
                              sButtonFunction)
Widget  list;
char   *sButtonFunction;
#endif
{
   char                       *translationString;
   XrmValue                    fromValue,toValue;
   int                         ac;
   Arg                         al[2];
   XtTranslations              translations;
   Boolean                     convertOk;
   pSButtonFunctionParameters  sButtonFunctionParameters;
   int                         i1,nList;
   utLogical                   widgetFunctionExists = utFalse;

   assert(XmIsList(list));

   if(!utIsNullString(sButtonFunction)) {
      /* moEnableInputLS(list);*/

      ac = 0;
      XtSetArg(al[ac],XmNlistMarginWidth,2); ac++;
      XtSetArg(al[ac],XmNautomaticSelection,TRUE); ac++;
      XtSetValues(list,al,ac);

      translationString = utCatStringPlusString("<Key>F2:"," ",sButtonFunction);
      translations = XtParseTranslationTable(translationString);
      XtOverrideTranslations(list,translations);
      utFreeBytes((pVoid)translationString);

      /* Check for previous establishment of this widget/sButtonFunction combination */

      if(mosbutnSbuttonParameterList != NULL) {
         nList = utGetCountListOfPtrs(mosbutnSbuttonParameterList);
         for(i1=0 ; i1<nList ; i1++) {
            sButtonFunctionParameters = (pSButtonFunctionParameters)utGetPtrAtPositionInListOfPtrs(mosbutnSbuttonParameterList,i1);
            if(list == sButtonFunctionParameters->Field) {
               if(utEqualStrings(sButtonFunction,sButtonFunctionParameters->SButtonFunction)) {
                  widgetFunctionExists = utTrue;
               } else {
                  XtRemoveEventHandler(list,ButtonPressMask,FALSE,
                                            mosbutnBtprAnyDoubleClick,(XtPointer)sButtonFunctionParameters);
                  XtRemoveEventHandler(list,ButtonReleaseMask,FALSE,
                                            mosbutnBtrlAnyButton,(XtPointer)sButtonFunctionParameters);
                  XtRemoveCallback(list,XmNbrowseSelectionCallback,mosbutnBrwsAnyLS,NULL);
                  moRemoveSBtnFuncParamFromList(sButtonFunctionParameters);
               }
               break;
            }
         }
      }

      if(!widgetFunctionExists) {
         sButtonFunctionParameters = moCreateSButtonFunctParameters(list,sButtonFunction);
         XtAddEventHandler(list,ButtonPressMask,FALSE,
                                mosbutnBtprAnyDoubleClick,(XtPointer)sButtonFunctionParameters);
         XtAddEventHandler(list,ButtonReleaseMask,FALSE,
                                mosbutnBtrlAnyButton,(XtPointer)sButtonFunctionParameters);
         XtAddCallback(list,XmNbrowseSelectionCallback,mosbutnBrwsAnyLS,NULL);
         XtAddCallback(list,XmNdestroyCallback,mosbutnDestroySButton,(XtPointer)sButtonFunctionParameters);
         moAddSButtonFuncParameterToList(sButtonFunctionParameters);
      }

      fromValue.addr = sButtonBackgroundColor;
      fromValue.size = utStringLength(fromValue.addr)+1;
      toValue.addr = NULL;
      convertOk = XtConvertAndStore(list,XmRString,&fromValue,XmRPixel,&toValue);
      if(convertOk)
         moSetBackgroundPixel(list,(Pixel)*(unsigned int *)toValue.addr);
      else
         utConsolePrint("Sbutton color conversion failed\n");
   }
}


#ifdef __STDC__
void moSetSbuttonWidgetBlankability(Widget w,
                                    utLogical isBlankable)
#else
void moSetSbuttonWidgetBlankability(w,
                                    isBlankable)
Widget    w;
utLogical isBlankable;
#endif
{
   pSButtonFunctionParameters sButtonFunctionParameters;
   int                        i1,nList;

   if(mosbutnSbuttonParameterList != NULL) {
      nList = utGetCountListOfPtrs(mosbutnSbuttonParameterList);
      for(i1=0 ; i1<nList ; i1++) {
         sButtonFunctionParameters = (pSButtonFunctionParameters)utGetPtrAtPositionInListOfPtrs(mosbutnSbuttonParameterList,i1);
         if(w == sButtonFunctionParameters->Field) {
            sButtonFunctionParameters->FieldIsBlankable = isBlankable;
            break;
         }
      }
   }
}


