/*
  $RCSfile: mosprshc.c,v $       $Revision: 1.3 $
  $State: V7_1 $                  $Date: 2004/11/04 17:49:33 $
*/
#include "utmacrou.h"

#include "momotifu.h"
#include "moscrbrw.h"
#include "mosprshp.h"
#include "mosprshc.h"

#ifdef __STDC__
void mosprshChngSshhSB(Widget w,
                       XtPointer client_data,
                       XtPointer xt_call_data)
#else
void mosprshChngSshhSB(w,
                       client_data,
                       xt_call_data)
Widget    w;
XtPointer client_data;
XtPointer xt_call_data;
#endif
{
   XmScrollBarCallbackStruct *call_data = (XmScrollBarCallbackStruct *) xt_call_data;

   mosprshSetTableHorizontalScroll(w);
}


#ifdef __STDC__
void mosprshChngSshvSB(Widget w,
                       XtPointer client_data,
                       XtPointer xt_call_data)
#else
void mosprshChngSshvSB(w,
                       client_data,
                       xt_call_data)
Widget    w;
XtPointer client_data;
XtPointer xt_call_data;
#endif
{
   XmScrollBarCallbackStruct *call_data = (XmScrollBarCallbackStruct *) xt_call_data;

   mosprshSetTableVerticalScroll(w);
}


#ifdef __STDC__
static void mosprshGetTableVRowColumnSize(Widget tableWidget,
                                          double *tableWidth,
                                          double *tableHeight)
#else
static void mosprshGetTableVRowColumnSize(tableWidget,
                                          tableWidth,
                                          tableHeight)
Widget  tableWidget;
double *tableWidth;
double *tableHeight;
#endif
{
   Widget variableRowsAndColumnsWidget;
   double widthWidget,heightWidget;

   variableRowsAndColumnsWidget = XtNameToWidget(tableWidget,
                                                 "*.VariableRowsAndColumns");

   moGetSizeOfWidget(variableRowsAndColumnsWidget,
                     &widthWidget,
                     &heightWidget);

   *tableWidth  = widthWidget;
   *tableHeight = heightWidget;
}


#ifdef __STDC__
static void mosprshGetTableVisibleSize(Widget tableWidget,
                                       double *tableVisibleWidth,
                                       double *tableVisibleHeight)
#else
static void mosprshGetTableVisibleSize(tableWidget,
                                       tableVisibleWidth,
                                       tableVisibleHeight)
Widget  tableWidget;
double *tableVisibleWidth;
double *tableVisibleHeight;
#endif
{
   double widthWidget,heightWidget;
   Widget variableRowsAndColumnsViewWidget;

   variableRowsAndColumnsViewWidget = XtNameToWidget(tableWidget,
                                                     "VariableRowsAndColumnsView");
   moGetSizeOfWidget(variableRowsAndColumnsViewWidget,
                     &widthWidget,
                     &heightWidget);

   *tableVisibleWidth  = widthWidget;
   *tableVisibleHeight = heightWidget;
}


#ifdef __STDC__
void mosprshSetScrollBars(Widget spreadSheetWidget)
#else
void mosprshSetScrollBars(spreadSheetWidget)
Widget spreadSheetWidget;
#endif
{
   Widget tableWidget;
   double tableWidth,tableHeight;
   double tableVisibleWidth,tableVisibleHeight;
   Widget horizontalScrollBar;
   Widget verticalScrollBar;
   double xLeft,xRight,yTop,yBottom;
   double increment;
   double pageIncrement;
   double sliderSize;
   double sliderValue;

   tableWidget = XtNameToWidget(spreadSheetWidget,
                                "*.Table");
   horizontalScrollBar = XtNameToWidget(tableWidget,
                                        "HorizontalScrollBar");
   verticalScrollBar = XtNameToWidget(tableWidget,
                                      "VerticalScrollBar");

   mosprshGetTableVRowColumnSize(tableWidget,
                                 &tableWidth,
                                 &tableHeight);
   mosprshGetTableVisibleSize(tableWidget,
                              &tableVisibleWidth,
                              &tableVisibleHeight);
   xLeft  = 0.;
   xRight = MAX(tableWidth,tableVisibleWidth);
   increment     = (xRight-xLeft)*SPREADSHEETINCREMENT;
   pageIncrement = (xRight-xLeft)*SPREADSHEETPAGEINCREMENT;
   
   moGetSliderValueSB(horizontalScrollBar,&sliderValue);
   sliderValue = MAX(sliderValue,xLeft);
   sliderValue = MIN(sliderValue,xRight);
   sliderSize  = tableVisibleWidth-1.;

   if(pageIncrement > sliderSize) {
      pageIncrement = sliderSize;
      increment     = sliderSize*SPREADSHEETINCREMENT/SPREADSHEETPAGEINCREMENT;
   }

   moSetValuesSB(horizontalScrollBar,
                 xLeft,
                 xRight,
                 increment,
                 pageIncrement,
                 sliderSize,
                 sliderValue);

   yTop    = 0.;
   yBottom = MAX(tableHeight,tableVisibleHeight);
   increment     = (yBottom-yTop)*SPREADSHEETINCREMENT;
   pageIncrement = (yBottom-yTop)*SPREADSHEETPAGEINCREMENT;

   moGetSliderValueSB(verticalScrollBar,&sliderValue);
   sliderValue = MAX(sliderValue,yTop);
   sliderValue = MIN(sliderValue,yBottom);
   sliderSize  = tableVisibleHeight-1.;

   if(pageIncrement > sliderSize) {
      pageIncrement = sliderSize;
      increment     = sliderSize*SPREADSHEETINCREMENT/SPREADSHEETPAGEINCREMENT;
   }

   moSetValuesSB(verticalScrollBar,
                 yTop,
                 yBottom,
                 increment,
                 pageIncrement,
                 sliderSize,
                 sliderValue);
}


#ifdef __STDC__
static void mosprshSetTableHorizontalScroll(Widget horizontalScrollBar)
#else
static void mosprshSetTableHorizontalScroll(horizontalScrollBar)
Widget horizontalScrollBar;
#endif
{
   Widget   tableWidget;
   Widget   verticalScrollBar;
   Widget   variableRowsAndColumnsWidget;
   Widget   fixedRowWidget;
   double   horizontalSliderValue;
   double   verticalSliderValue;
   Position xWidget,yWidget;

   tableWidget = XtParent(horizontalScrollBar);
   verticalScrollBar = XtNameToWidget(tableWidget,
                                      "VerticalScrollBar");
   variableRowsAndColumnsWidget = XtNameToWidget(tableWidget,
                                                 "*.VariableRowsAndColumns");
   fixedRowWidget = XtNameToWidget(tableWidget,
                                   "*.FixedRow");

   moGetSliderValueSB(horizontalScrollBar,&horizontalSliderValue);
   moGetSliderValueSB(verticalScrollBar,&verticalSliderValue);

   xWidget = -(Position)horizontalSliderValue;
   yWidget = -(Position)verticalSliderValue;
   
   XtMoveWidget(variableRowsAndColumnsWidget,xWidget,yWidget);
   XtMoveWidget(fixedRowWidget,xWidget,(Position)0);
}


#ifdef __STDC__
static void mosprshSetTableVerticalScroll(Widget verticalScrollBar)
#else
static void mosprshSetTableVerticalScroll(verticalScrollBar)
Widget verticalScrollBar;
#endif
{
   Widget   tableWidget;
   Widget   horizontalScrollBar;
   Widget   variableRowsAndColumnsWidget;
   Widget   fixedColumnWidget;
   double   horizontalSliderValue;
   double   verticalSliderValue;
   Position xWidget,yWidget;

   tableWidget = XtParent(verticalScrollBar);
   horizontalScrollBar = XtNameToWidget(tableWidget,
                                        "HorizontalScrollBar");
   variableRowsAndColumnsWidget = XtNameToWidget(tableWidget,
                                                 "*.VariableRowsAndColumns");
   fixedColumnWidget = XtNameToWidget(tableWidget,
                                      "*.FixedColumn");

   moGetSliderValueSB(horizontalScrollBar,&horizontalSliderValue);
   moGetSliderValueSB(verticalScrollBar,&verticalSliderValue);

   xWidget = -(Position)horizontalSliderValue;
   yWidget = -(Position)verticalSliderValue;
   
   XtMoveWidget(variableRowsAndColumnsWidget,xWidget,yWidget);
   XtMoveWidget(fixedColumnWidget,(Position)0,yWidget);
}


#ifdef __STDC__
void mosprshSetResizeScrollBarsFunc(Widget spreadSheetWidget)
#else
void mosprshSetResizeScrollBarsFunc(spreadSheetWidget)
Widget spreadSheetWidget;
#endif
{
   Widget tableWidget;
   Widget variableRowsAndColumnsViewWidget;

   tableWidget = XtNameToWidget(spreadSheetWidget,
                                "*.Table");

   variableRowsAndColumnsViewWidget = XtNameToWidget(tableWidget,
                                                     "VariableRowsAndColumnsView");
   XtAddEventHandler(variableRowsAndColumnsViewWidget,
                     StructureNotifyMask,
                     FALSE,
                     mosprshResizeScrollBarsFunc,
                     NULL);
}


#ifdef __STDC__
void mosprshResizeScrollBarsFunc(Widget variableRowsAndColumnsViewWidget,
                                 XtPointer client_data,
                                 XEvent *genericEvent,
                                 Boolean *continueDispatch)
#else
void mosprshResizeScrollBarsFunc(variableRowsAndColumnsViewWidget,
                                 client_data,
                                 genericEvent,
                                 continueDispatch)
Widget     variableRowsAndColumnsViewWidget;
XtPointer  client_data;
XEvent    *genericEvent;
Boolean   *continueDispatch;
#endif
{
   XConfigureEvent *event = (XConfigureEvent *)genericEvent;
   Widget tableWidget = XtParent(variableRowsAndColumnsViewWidget);
   Widget spreadSheetWidget = XtParent(tableWidget);
   Widget horizontalScrollBar;
   Widget verticalScrollBar;

   mosprshSetScrollBars(spreadSheetWidget);

   horizontalScrollBar = XtNameToWidget(tableWidget,
                                        "HorizontalScrollBar");
   verticalScrollBar = XtNameToWidget(tableWidget,
                                      "VerticalScrollBar");
   mosprshSetTableHorizontalScroll(horizontalScrollBar);
   mosprshSetTableVerticalScroll(verticalScrollBar);
}


