/*
  $RCSfile: mosprshu.c,v $       $Revision: 1.4 $
  $State: V7_0 $                  $Date: 2003/06/27 10:32:22 $
*/
#include <Xm/Form.h>

#include "utmemryu.h"
#include "utmacrou.h"
#include "utstrcvu.h"
#include "utstrngu.h"

#include "momotifu.h"
#include "motextfw.h"
#include "mosbutnu.h"
#include "mosprshc.h"
#include "mosprshu.h"
#include "mosprshx.h"

#ifdef __STDC__
static Widget moGetSpreadSheetTFWidget(Widget parentFM,
                                       int rowNumber,
                                       int columnNumber)
#else
static Widget moGetSpreadSheetTFWidget(parentFM,
                                       rowNumber,
                                       columnNumber)
Widget parentFM;
int    rowNumber;
int    columnNumber;
#endif
{
   char   widgetName[MAX_STRING_LENGTH+1];
   Widget textFieldWidget;
   Widget spreadSheetWidget = moGetSpreadsheetForm(parentFM);

   assert(XmIsForm(parentFM));

   sprintf(widgetName,"*.column%drow%d",columnNumber,rowNumber);
   textFieldWidget = XtNameToWidget(spreadSheetWidget,widgetName);

   return(textFieldWidget);
}


#ifdef __STDC__
char *moGetSpreadsheetValue(Widget parentFM,
                            int rowNumber,
                            int columnNumber)
#else
char *moGetSpreadsheetValue(parentFM,
                            rowNumber,
                            columnNumber)
Widget  parentFM;
int     rowNumber;
int     columnNumber;
#endif
{
   Widget  textFieldWidget;
   char   *value;

   textFieldWidget = moGetSpreadSheetTFWidget(parentFM,
                                              rowNumber,
                                              columnNumber);

   value = moGetCstringFromTF(textFieldWidget);

   return(value);
}


#ifdef __STDC__
void moSetSpreadsheetValue(Widget parentFM,
                           int rowNumber,
                           int columnNumber,
                           char *value)
#else
void moSetSpreadsheetValue(parentFM,
                           rowNumber,
                           columnNumber,
                           value)
Widget  parentFM;
int     rowNumber;
int     columnNumber;
char   *value;
#endif
{
   Widget textFieldWidget;

   textFieldWidget = moGetSpreadSheetTFWidget(parentFM,
                                              rowNumber,
                                              columnNumber);

   moSetCstringToTF(textFieldWidget, value);
}


#ifdef __STDC__
void moClearSpreadsheetValue(Widget parentFM,
                             int rowNumber,
                             int columnNumber)
#else
void moClearSpreadsheetValue(parentFM,
                             rowNumber,
                             columnNumber)
Widget  parentFM;
int     rowNumber;
int     columnNumber;
#endif
{
   Widget textFieldWidget;

   textFieldWidget = moGetSpreadSheetTFWidget(parentFM,
                                              rowNumber,
                                              columnNumber);

   moClearTF(textFieldWidget);
}


#ifdef __STDC__
double moGetSpreadsheetDouble(Widget parentFM,
                              int rowNumber,
                              int columnNumber)
#else
double moGetSpreadsheetDouble(parentFM,
                              rowNumber,
                              columnNumber)
Widget  parentFM;
int     rowNumber;
int     columnNumber;
#endif
{
   double  value;
   char   *string;

   string = moGetSpreadsheetValue(parentFM,
                                  rowNumber,
                                  columnNumber);

   value = utStringToDouble(string);
   utFreeBytes((pVoid)string);

   return(value);
}


#ifdef __STDC__
void moSetSpreadsheetDouble(Widget parentFM,
                            int rowNumber,
                            int columnNumber,
                            double value)
#else
void moSetSpreadsheetDouble(parentFM,
                            rowNumber,
                            columnNumber,
                            value)
Widget parentFM;
int    rowNumber;
int    columnNumber;
double value;
#endif
{
   char *string = utDoubleToString(value);

   moSetSpreadsheetValue(parentFM,
                         rowNumber,
                         columnNumber,
                         string);

   utFreeBytes((pVoid)string);
}


#ifdef __STDC__
int moGetSpreadsheetInt(Widget parentFM,
                        int rowNumber,
                        int columnNumber)
#else
int moGetSpreadsheetInt(parentFM,
                        rowNumber,
                        columnNumber)
Widget parentFM;
int    rowNumber;
int    columnNumber;
#endif
{
   int   value;
   char *string = moGetSpreadsheetValue(parentFM,
                                        rowNumber,
                                        columnNumber);

   value = utStringToInt(string);
   utFreeBytes((pVoid)string);

   return(value);
}


#ifdef __STDC__
void moSetSpreadsheetInt(Widget parentFM,
                         int rowNumber,
                         int columnNumber,
                         int value)
#else
void moSetSpreadsheetInt(parentFM,
                         rowNumber,
                         columnNumber,
                         value)
Widget parentFM;
int    rowNumber;
int    columnNumber;
int    value;
#endif
{
   char *string = utIntToString(value);

   moSetSpreadsheetValue(parentFM,
                         rowNumber,
                         columnNumber,
                         string);

   utFreeBytes((pVoid)string);
}


#ifdef __STDC__
long moGetSpreadsheetLong(Widget parentFM,
                          int rowNumber,
                          int columnNumber)
#else
long moGetSpreadsheetLong(parentFM,
                          rowNumber,
                          columnNumber)
Widget parentFM;
int    rowNumber;
int    columnNumber;
#endif
{
   long  value;
   char *string = moGetSpreadsheetValue(parentFM,
                                        rowNumber,
                                        columnNumber);

   value = utStringToLong(string);
   utFreeBytes((pVoid)string);

   return(value);
}


#ifdef __STDC__
void moSetSpreadsheetLong(Widget parentFM,
                          int rowNumber,
                          int columnNumber,
                          long value)
#else
void moSetSpreadsheetLong(parentFM,
                          rowNumber,
                          columnNumber,
                          value)
Widget parentFM;
int    rowNumber;
int    columnNumber;
long   value;
#endif
{
   char *string = utLongToString(value);

   moSetSpreadsheetValue(parentFM,
                         rowNumber,
                         columnNumber,
                         string);

   utFreeBytes((pVoid)string);
}


#ifdef __STDC__
void moSetSpreadsheetSbuttonFunction(Widget parentFM,
                                     int rowNumber,
                                     int columnNumber,
                                     utLogical editable,
                                     char *sButtonFunction)
#else
void moSetSpreadsheetSbuttonFunction(parentFM,
                                     rowNumber,
                                     columnNumber,
                                     editable,
                                     sButtonFunction)
Widget     parentFM;
int        rowNumber;
int        columnNumber;
utLogical  editable;
char      *sButtonFunction;
#endif
{
   Widget textFieldWidget;

   textFieldWidget = moGetSpreadSheetTFWidget(parentFM,
                                              rowNumber,
                                              columnNumber);

   moSetTextFieldSbuttonFunction(textFieldWidget,
                                 editable,
                                 sButtonFunction);
}


#ifdef __STDC__
void moAddSpreadsheetVchgCallback(Widget parentFM,
                                  int rowNumber,
                                  int columnNumber,
                                  void valueChangedCallback(Widget w,
                                                            XtPointer client_data,
                                                            XtPointer xt_call_data))
#else
void moAddSpreadsheetVchgCallback(parentFM,
                                  rowNumber,
                                  columnNumber,
                                  valueChangedCallback)
Widget        parentFM;
int           rowNumber;
int           columnNumber;
pVoidFunction valueChangedCallback;
#endif
{
   Widget textFieldWidget;

   textFieldWidget = moGetSpreadSheetTFWidget(parentFM,
                                              rowNumber,
                                              columnNumber);

   moAddTextFieldVchgCallback(textFieldWidget,
                              valueChangedCallback);
}


#ifdef __STDC__
void moDisableSpreadsheetInput(Widget parentFM,
                               int rowNumber,
                               int columnNumber)
#else
void moDisableSpreadsheetInput(parentFM,
                               rowNumber,
                               columnNumber)
Widget parentFM;
int    rowNumber;
int    columnNumber;
#endif
{
   Widget textFieldWidget;

   textFieldWidget = moGetSpreadSheetTFWidget(parentFM,
                                              rowNumber,
                                              columnNumber);

   moDisableInputTF(textFieldWidget);
}


#ifdef __STDC__
void moEnableSpreadsheetInput(Widget parentFM,
                              int rowNumber,
                              int columnNumber)
#else
void moEnableSpreadsheetInput(parentFM,
                              rowNumber,
                              columnNumber)
Widget parentFM;
int    rowNumber;
int    columnNumber;
#endif
{
   Widget textFieldWidget;

   textFieldWidget = moGetSpreadSheetTFWidget(parentFM,
                                              rowNumber,
                                              columnNumber);

   moEnableInputTF(textFieldWidget);
}


#ifdef __STDC__
pSarray moGetSpreadsheetFixedRowNames(Widget parentFM)
#else
pSarray moGetSpreadsheetFixedRowNames(parentFM)
Widget parentFM;
#endif
{
   Widget   spreadSheetWidget = moGetSpreadsheetForm(parentFM);
   int      nRows,nColumns;
   pSarray  columnNames;
   char     widgetName[MAX_STRING_LENGTH+1];
   Widget   textFieldWidget;
   int      i1;
   char    *columnName;

   moGetSpreadsheetNrowAndNcolumn(parentFM,
                                  &nRows,
                                  &nColumns);
   columnNames = utCreateSarrayOfSize(nColumns);
   for(i1=0 ; i1<nColumns ; i1++) {
      sprintf(widgetName,"*.fixedRowColumn%d",i1);
      textFieldWidget = XtNameToWidget(spreadSheetWidget,widgetName);
      columnName = moGetCstringFromTF(textFieldWidget);
      utAddToSarray(columnNames,columnName);
      utFreeBytes((pVoid)columnName);
   }

   return(columnNames);
}


#ifdef __STDC__
void moSetSpreadsheetFixedRowNames(Widget parentFM,
                                   pSarray columnNames)
#else
void moSetSpreadsheetFixedRowNames(parentFM,
                                   columnNames)
Widget  parentFM;
pSarray columnNames;
#endif
{
   Widget  spreadSheetWidget = moGetSpreadsheetForm(parentFM);
   char    widgetName[MAX_STRING_LENGTH+1];
   Widget  textFieldWidget;
   int     i1;
   int     nColumns = utGetCountSarray(columnNames);
   char   *columnName;

   for(i1=0 ; i1<nColumns ; i1++) {
      sprintf(widgetName,"*.fixedRowColumn%d",i1);
      textFieldWidget = XtNameToWidget(spreadSheetWidget,widgetName);
      columnName = utGetCstringAtPositionInSarray(columnNames,i1);
      moSetCstringToTF(textFieldWidget,columnName);
   }
}


#ifdef __STDC__
pSarray moGetSpreadsheetFixColumnNames(Widget parentFM)
#else
pSarray moGetSpreadsheetFixColumnNames(parentFM)
Widget parentFM;
#endif
{
   Widget   spreadSheetWidget = moGetSpreadsheetForm(parentFM);
   int      nRows,nColumns;
   pSarray  rowNames;
   char     widgetName[MAX_STRING_LENGTH+1];
   Widget   textFieldWidget;
   int      i1;
   char    *rowName;

   moGetSpreadsheetNrowAndNcolumn(parentFM,
                                  &nRows,
                                  &nColumns);
   rowNames = utCreateSarrayOfSize(nRows);
   for(i1=0 ; i1<nRows ; i1++) {
      sprintf(widgetName,"*.fixedColumnRow%d",i1);
      textFieldWidget = XtNameToWidget(spreadSheetWidget,widgetName);
      rowName = moGetCstringFromTF(textFieldWidget);
      utAddToSarray(rowNames,rowName);
      utFreeBytes((pVoid)rowName);
   }

   return(rowNames);
}


#ifdef __STDC__
void moSetSpreadsheetFixColumnNames(Widget parentFM,
                                    pSarray rowNames)
#else
void moSetSpreadsheetFixColumnNames(parentFM,
                                    rowNames)
Widget  parentFM;
pSarray rowNames;
#endif
{
   Widget  spreadSheetWidget = moGetSpreadsheetForm(parentFM);
   char    widgetName[MAX_STRING_LENGTH+1];
   Widget  textFieldWidget;
   int     i1;
   int     nRows = utGetCountSarray(rowNames);
   char   *rowName;

   for(i1=0 ; i1<nRows ; i1++) {
      sprintf(widgetName,"*.fixedColumnRow%d",i1);
      textFieldWidget = XtNameToWidget(spreadSheetWidget,widgetName);
      rowName = utGetCstringAtPositionInSarray(rowNames,i1);
      moSetCstringToTF(textFieldWidget,rowName);
   }
}


#ifdef __STDC__
void moSetSpreadsheetScrollBars(Widget parentFM)
#else
void moSetSpreadsheetScrollBars(parentFM)
Widget parentFM;
#endif
{
   Widget spreadSheetWidget = moGetSpreadsheetForm(parentFM);

   mosprshSetScrollBars(spreadSheetWidget);
   mosprshSetResizeScrollBarsFunc(spreadSheetWidget);
}


#ifdef __STDC__
void moDisableSpreadsheetRowInput(Widget parentFM,
                                  int rowNumber)
#else
void moDisableSpreadsheetRowInput(parentFM,
                                  rowNumber)
Widget parentFM;
int    rowNumber;
#endif
{
   int    nRows,nColumns;
   Widget textFieldWidget;
   int    j1;

   moGetSpreadsheetNrowAndNcolumn(parentFM,
                                  &nRows,
                                  &nColumns);
   for(j1=0 ; j1<nColumns ; j1++) {
      textFieldWidget = moGetSpreadSheetTFWidget(parentFM,
                                                 rowNumber,
                                                 j1);
      moDisableInputTF(textFieldWidget);
   }
}


#ifdef __STDC__
void moDisableSpreadsheetColumnInput(Widget parentFM,
                                     int columnNumber)
#else
void moDisableSpreadsheetColumnInput(parentFM,
                                     columnNumber)
Widget parentFM;
int    columnNumber;
#endif
{
   int    nRows,nColumns;
   Widget textFieldWidget;
   int    i1;

   moGetSpreadsheetNrowAndNcolumn(parentFM,
                                  &nRows,
                                  &nColumns);
   for(i1=0 ; i1<nRows ; i1++) {
      textFieldWidget = moGetSpreadSheetTFWidget(parentFM,
                                                 i1,
                                                 columnNumber);
      moDisableInputTF(textFieldWidget);
   }
}


#ifdef __STDC__
void moBuildSpreadsheetFromTable(Widget parentFM,
                                 char *spreadSheetTitle,
                                 pTable table,
                                 char *ignoreValue,
                                 void mosprshCheckButtonCallback(Widget w,
                                                                 XtPointer client_data,
                                                                 XtPointer xt_call_data))
#else
void moBuildSpreadsheetFromTable(parentFM,
                                 spreadSheetTitle,
                                 table,
                                 ignoreValue,
                                 mosprshCheckButtonCallback)
Widget         parentFM;
char          *spreadSheetTitle;
pTable         table;
char          *ignoreValue;
pVoidFunction  mosprshCheckButtonCallback;
#endif
{
   int        nRows    = utGetCountSarray(table->RowNames);
   int        nColumns = utGetCountSarray(table->ColumnNames);
   int        i1,j1;
   char      *cellValue;
   utLogical  showIt;

   moCreateSpreadsheet(parentFM,
                       spreadSheetTitle,
                       table->RowNames,
                       table->ColumnNames,
                       mosprshCheckButtonCallback);

   for(j1=0 ; j1<nColumns ; j1++) {
      for(i1=0 ; i1<nRows ; i1++) {
         cellValue = utGetTableCellValue(table,i1,j1);
         showIt = utTrue;
         if(ignoreValue != NULL)
            if(utEqualStrings(cellValue,ignoreValue))
               showIt = utFalse;
         if(showIt)
            moSetSpreadsheetValue(parentFM,i1,j1,cellValue);
         else
            moClearSpreadsheetValue(parentFM,i1,j1);
      }
   }
}


#ifdef __STDC__
pTable moGetTableFromSpreadsheet(Widget parentFM,
                                 utLogical stripNames)
#else
pTable moGetTableFromSpreadsheet(parentFM,
                                 stripNames)
Widget    parentFM;
utLogical stripNames;
#endif
{
   pTable   spreadSheetValues = NULL;
   pSarray  fixedRowNames = moGetSpreadsheetFixedRowNames(parentFM);
   pSarray  fixedColumnNames = moGetSpreadsheetFixColumnNames(parentFM);
   int      nRows    = utGetCountSarray(fixedColumnNames);
   int      nColumns = utGetCountSarray(fixedRowNames);
   int      i1,j1;
   char    *cellValue;
   char    *rowName;
   char    *columnName;

   if(stripNames) {
      for(j1=0 ; j1<nColumns ; j1++) {
         columnName = utGetCstringAtPositionInSarray(fixedRowNames,j1);
         utStripBlanks(columnName);
      }
      for(i1=0 ; i1<nRows ; i1++) {
         rowName = utGetCstringAtPositionInSarray(fixedColumnNames,i1);
         utStripBlanks(rowName);
      }
   }

   spreadSheetValues = utCreateTableWithNames(fixedColumnNames,
                                              fixedRowNames);

   for(j1=0 ; j1<nColumns ; j1++) {
      for(i1=0 ; i1<nRows ; i1++) {
         cellValue = moGetSpreadsheetValue(parentFM,i1,j1);
         utSetTableCellValue(spreadSheetValues,
                             i1,
                             j1,
                             cellValue);
         utFreeBytes((pVoid)cellValue);
      }
   }
   utFreeSarray(&fixedRowNames);
   utFreeSarray(&fixedColumnNames);

   return(spreadSheetValues);
}


#ifdef __STDC__
void moDisableSpreadsheetTableInput(Widget parentFM,
                                    pTable table,
                                    char *ignoreValue)
#else
void moDisableSpreadsheetTableInput(parentFM,
                                    table,
                                    ignoreValue)
Widget  parentFM;
pTable  table;
char   *ignoreValue;
#endif
{
   int        nRows    = utGetCountSarray(table->RowNames);
   int        nColumns = utGetCountSarray(table->ColumnNames);
   int        i1,j1;
   char      *cellValue;
   utLogical  showIt;

   for(j1=0 ; j1<nColumns ; j1++) {
      for(i1=0 ; i1<nRows ; i1++) {
         cellValue = utGetTableCellValue(table,i1,j1);
         showIt = utTrue;
         if(ignoreValue != NULL)
            if(utEqualStrings(cellValue,ignoreValue))
               showIt = utFalse;
         if(!showIt)
            moDisableSpreadsheetInput(parentFM,
                                      i1,
                                      j1);
      }
   }
}


#ifdef __STDC__
void moGetSpreadsheetTFRowAndColumn(Widget textField,
                                    int *rowNumber,
                                    int *columnNumber)
#else
void moGetSpreadsheetTFRowAndColumn(textField,
                                    rowNumber,
                                    columnNumber)
Widget  textField;
int    *rowNumber;
int    *columnNumber;
#endif
{
   char *widgetName;

   assert(XmIsTextField(textField));

   widgetName = moGetWidgetName(textField);
   sscanf(widgetName,"column%drow%d",columnNumber,rowNumber);
}


#ifdef __STDC__
char *moGetSpreadsheetColumnName(Widget parentFM,
                                 int columnNumber)
#else
char *moGetSpreadsheetColumnName(parentFM,
                                 columnNumber)
Widget parentFM;
int    columnNumber;
#endif
{
   char   *columnName;
   Widget  spreadSheetWidget = moGetSpreadsheetForm(parentFM);
   char    widgetName[MAX_STRING_LENGTH+1];
   Widget  textFieldWidget;

   sprintf(widgetName,"*.fixedRowColumn%d",columnNumber);
   textFieldWidget = XtNameToWidget(spreadSheetWidget,widgetName);
   columnName = moGetCstringFromTF(textFieldWidget);

   return(columnName);
}


#ifdef __STDC__
char *moGetSpreadsheetRowName(Widget parentFM,
                              int rowNumber)
#else
char *moGetSpreadsheetRowName(parentFM,
                              rowNumber)
Widget parentFM;
int    rowNumber;
#endif
{
   char   *rowName;
   Widget  spreadSheetWidget = moGetSpreadsheetForm(parentFM);
   char    widgetName[MAX_STRING_LENGTH+1];
   Widget  textFieldWidget;

   sprintf(widgetName,"*.fixedColumnRow%d",rowNumber);
   textFieldWidget = XtNameToWidget(spreadSheetWidget,widgetName);
   rowName = moGetCstringFromTF(textFieldWidget);

   return(rowName);
}


#ifdef __STDC__
void moSetSpreadsheetInsensitive(Widget parentFM,
                                 int rowNumber,
                                 int columnNumber)
#else
void moSetSpreadsheetInsensitive(parentFM,
                                 rowNumber,
                                 columnNumber)
Widget parentFM;
int    rowNumber;
int    columnNumber;
#endif
{
   Widget textFieldWidget;

   textFieldWidget = moGetSpreadSheetTFWidget(parentFM,
                                              rowNumber,
                                              columnNumber);

   moSetInsensitive(textFieldWidget);
}


#ifdef __STDC__
void moSetSpreadsheetSensitive(Widget parentFM,
                               int rowNumber,
                               int columnNumber)
#else
void moSetSpreadsheetSensitive(parentFM,
                               rowNumber,
                               columnNumber)
Widget parentFM;
int    rowNumber;
int    columnNumber;
#endif
{
   Widget textFieldWidget;

   textFieldWidget = moGetSpreadSheetTFWidget(parentFM,
                                              rowNumber,
                                              columnNumber);

   moSetSensitive(textFieldWidget);
}


