/*
  $RCSfile: mosprshx.c,v $       $Revision: 1.4 $
  $State: V7_0 $                  $Date: 2003/06/27 10:06:37 $
*/
#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/ScrollBar.h>
#include <Xm/Separator.h>
#include <Xm/TextF.h>

#include "utmacrou.h"
#include "utmemryu.h"
#include "uttypesu.h"
#include "utstrngu.h"

#include "momotifu.h"
#include "mosprshx.h"
#include "mosprshc.h"
#include "mosprshu.h"

#define              check_width  16
#define              check_height 16
static unsigned char check_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x00, 0xf0, 0x00, 0xf8,
   0x00, 0x7c, 0x07, 0x1e, 0x0f, 0x07, 0x9e, 0x03, 0xfc, 0x01, 0xf8, 0x00,
   0x70, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00};

static char *spreadSheetFont = "-adobe-courier-medium-r-normal--12-120-75-75-m-70-iso8859-1";

#ifdef __STDC__
static void mosprshCreateCheckMarkPixmap(Widget pushButton)
#else
static void mosprshCreateCheckMarkPixmap(pushButton)
Widget pushButton;
#endif
{
   Arg        al[4];
   int        ac;
   Pixmap     bitmap,pixmap16;
   GC         gc;
   XGCValues  gcv;
   Screen    *screenPtr = XtScreen(pushButton);
   Display   *dsp = XtDisplay(pushButton);
   Window     window = RootWindowOfScreen(screenPtr);

  /* Create a GC for foreground and background colors */

   gcv.background = moGetBackgroundPixel(pushButton);
   gcv.foreground = moGetForegroundPixel(pushButton);

   gc = XCreateGC(dsp,window,
                  GCForeground | GCBackground,&gcv);

  /* Create bitmap from data (Depth = 1) */

   bitmap = XCreateBitmapFromData(dsp,
                                  window,
                                  check_bits,
                                  check_width,
                                  check_height);

  /* Create a pixmap of the same depth as the default screen */

   pixmap16 = XCreatePixmap(dsp,
                            window,
                            check_width,
                            check_height,
                            DefaultDepthOfScreen(screenPtr));

  /* Copy contents of plane 1 of the bitmap to the pixmap
     Using widgets foreground & background colors */

   XCopyPlane(dsp,bitmap,pixmap16,gc,0,0,
              check_width,check_height,0,0,1);

   XFreePixmap(dsp,bitmap);

   ac = 0;
   XtSetArg(al[ac],XmNlabelType,XmPIXMAP); ac++;
   XtSetArg(al[ac],XmNlabelPixmap,pixmap16); ac++;
   XtSetValues(pushButton,al,ac);

   XFreeGC(dsp,gc);
}


#ifdef __STDC__
static void moInitializeSpreadSheetSize(pSpreadSheetSize newSpreadSheetSize,
                                        int nRows,
                                        int nColumns)
#else
static void moInitializeSpreadSheetSize(newSpreadSheetSize,
                                        nRows,
                                        nColumns)
pSpreadSheetSize newSpreadSheetSize;
int              nRows;
int              nColumns;
#endif
{
   newSpreadSheetSize->StructType = STRUCTTYPE_SPREADSHEETSIZE;
   newSpreadSheetSize->Nrows      = nRows;
   newSpreadSheetSize->Ncolumns   = nColumns;
}


#ifdef __STDC__
static pSpreadSheetSize moCreateSpreadSheetSize(int nRows,
                                                int nColumns)
#else
static pSpreadSheetSize moCreateSpreadSheetSize(nRows,
                                                nColumns)
int nRows;
int nColumns;
#endif
{
   pSpreadSheetSize newSpreadSheetSize;

   newSpreadSheetSize = (pSpreadSheetSize)utGetBytes(sizeof(SpreadSheetSize));
   moInitializeSpreadSheetSize(newSpreadSheetSize,
                               nRows,
                               nColumns);

   return(newSpreadSheetSize);
}


#ifdef __STDC__
static void moFreeSpreadSheetSize(pSpreadSheetSize *spreadSheetSize)
#else
static void moFreeSpreadSheetSize(spreadSheetSize)
pSpreadSheetSize *spreadSheetSize;
#endif
{
   utFreeBytes((pVoid)*spreadSheetSize);
   *spreadSheetSize = NULL;
}


#ifdef __STDC__
static void mosprshCreateSpreadsheet(Widget parentFM,
                                     char *spreadSheetTitle,
                                     pSarray rowNames,
                                     pSarray columnNames,
                                     int cellSize,
                                     void mosprshCheckButtonCallback(
							Widget w,
                                                        XtPointer client_data,
                                                        XtPointer xt_call_data))
#else
static void mosprshCreateSpreadsheet(parentFM,
                                     spreadSheetTitle,
                                     rowNames,
                                     columnNames,
                                     cellSize,
                                     mosprshCheckButtonCallback)
Widget         parentFM;
char          *spreadSheetTitle;
pSarray        rowNames;
pSarray        columnNames;
int            cellSize;
pVoidFunction  mosprshCheckButtonCallback;
#endif
{
   Widget            children[10];
   Arg               al[64];
   int               ac;
   XrmValue          fromValue,toValue;
   XmString          xmstring;
   Widget            spreadSheet                = (Widget)NULL;
   Widget            table                      = (Widget)NULL;
   Widget            fixedColumnView            = (Widget)NULL;
   Widget            fixedColumn                = (Widget)NULL;
   Widget            fixedRowView               = (Widget)NULL;
   Widget            fixedRow                   = (Widget)NULL;
   Widget            leftVerticalSeparator      = (Widget)NULL;
   Widget            topHorizontalSeparator     = (Widget)NULL;
   Widget            variableRowsAndColumnsView = (Widget)NULL;
   Widget            variableRowsAndColumns     = (Widget)NULL;
   Widget            lowerHorizontalSeparator   = (Widget)NULL;
   Widget            horizontalScrollBar        = (Widget)NULL;
   Widget            rightVerticalSeparator     = (Widget)NULL;
   Widget            verticalScrollBar          = (Widget)NULL;
   Widget            checkMark                  = (Widget)NULL;
   Widget            title                      = (Widget)NULL;
   Widget            frame                      = (Widget)NULL;
   int               nRows = utGetCountSarray(rowNames);
   int               nColumns = utGetCountSarray(columnNames);
   WidgetList        fixedColumnTF = (WidgetList)utGetBytes(nRows*sizeof(Widget));
   WidgetList        fixedRowTF = (WidgetList)utGetBytes(nColumns*sizeof(Widget));
   WidgetList        variableColumnFM = (WidgetList)utGetBytes(nColumns*sizeof(Widget));
   WidgetList        variableRowAndColumnTF = (WidgetList)utGetBytes(nRows*nColumns*sizeof(Widget));
   WidgetList        tempColumnTF           = (WidgetList)utGetBytes(nRows*sizeof(Widget));
   int               i1,j1,loc;
   char              widgetName[MAX_STRING_LENGTH+1];
   Boolean           isParentManaged = XtIsManaged(parentFM);
   Pixel             background = moGetBackgroundPixel(parentFM);
   char             *rowName;
   char             *columnName;
   int               longestFixedColumnSize = utGetLongestStringSizeInSarray(rowNames);
   pSpreadSheetSize  spreadSheetSize = moCreateSpreadSheetSize(nRows,nColumns);

   assert(XmIsForm(parentFM));

   if(isParentManaged)
      XtUnmanageChild(parentFM);

   fromValue.addr = spreadSheetFont;
   fromValue.size = utStringLength(fromValue.addr) + 1;
   toValue.addr = NULL;
   XtConvertAndStore(parentFM,XmRString,&fromValue,XmRFontList,&toValue);

   ac = 0;
   XtSetArg(al[ac],XmNuserData,(XtPointer)spreadSheetSize); ac++;
   spreadSheet = XmCreateForm(parentFM,"SpreadSheet",al,ac);

   ac = 0;
   table = XmCreateForm(spreadSheet,"Table",al,ac);

   ac = 0;
   fixedColumnView = XmCreateForm(table,"FixedColumnView",al,ac);
   fixedColumn = XmCreateForm(fixedColumnView,"FixedColumn",al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNhighlightThickness,1); ac++;
   XtSetArg(al[ac],XmNshadowThickness,0); ac++;
   XtSetArg(al[ac],XmNeditable,FALSE); ac++;
   XtSetArg(al[ac],XmNcursorPositionVisible,FALSE); ac++;
   XtSetArg(al[ac],XmNbackground,background); ac++;
   if(XmVersion > 1001) {
      XtSetArg(al[ac],XmNtraversalOn,FALSE); ac++;
   }
   XtSetArg(al[ac],XmNcolumns,longestFixedColumnSize+1); ac++;
   if(toValue.addr) {
      XtSetArg(al[ac],XmNfontList,*(unsigned int *)toValue.addr); ac++;
   }
   for(i1=0 ; i1<nRows ; i1++) {
      sprintf(widgetName,"fixedColumnRow%d",i1);
      fixedColumnTF[i1] = XmCreateTextField(fixedColumn,widgetName,al,ac);
      rowName = utGetCstringAtPositionInSarray(rowNames,i1);
      XmTextFieldSetString(fixedColumnTF[i1],rowName);
   }

   ac = 0;
   XtSetArg(al[ac],XmNorientation,XmVERTICAL); ac++;
   leftVerticalSeparator = XmCreateSeparator(table,"leftVerticalSeparator",al,ac);

   ac = 0;
   fixedRowView = XmCreateForm(table,"FixedRowView",al,ac);
   fixedRow = XmCreateForm(fixedRowView,"FixedRow",al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNhighlightThickness,1); ac++;
   XtSetArg(al[ac],XmNshadowThickness,0); ac++;
   XtSetArg(al[ac],XmNeditable,FALSE); ac++;
   XtSetArg(al[ac],XmNcursorPositionVisible,FALSE); ac++;
   XtSetArg(al[ac],XmNbackground,background); ac++;
   if(XmVersion > 1001) {
      XtSetArg(al[ac],XmNtraversalOn,FALSE); ac++;
   }
   if(cellSize > 0) {
      XtSetArg(al[ac],XmNcolumns,cellSize); ac++;
   }
   if(toValue.addr) {
      XtSetArg(al[ac],XmNfontList,*(unsigned int *)toValue.addr); ac++;
   }
   for(j1=0 ; j1<nColumns ; j1++) {
      sprintf(widgetName,"fixedRowColumn%d",j1);
      fixedRowTF[j1] = XmCreateTextField(fixedRow,widgetName,al,ac);
      columnName = utGetCstringAtPositionInSarray(columnNames,j1);
      XmTextFieldSetString(fixedRowTF[j1],columnName);
   }

   ac = 0;
   topHorizontalSeparator = XmCreateSeparator(table,"topHorizontalSeparator",al,ac);

   ac = 0;
   variableRowsAndColumnsView = XmCreateForm(table,"VariableRowsAndColumnsView",al,ac);
   variableRowsAndColumns = XmCreateForm(variableRowsAndColumnsView,"VariableRowsAndColumns",al,ac);

   loc = 0;
   for(j1=0 ; j1<nColumns ; j1++) {
      ac = 0;
      sprintf(widgetName,"column%d",j1);
      variableColumnFM[j1] = XmCreateForm(variableRowsAndColumns,widgetName,al,ac);
      for(i1=0 ; i1<nRows ; i1++) {
         ac = 0;
         XtSetArg(al[ac],XmNhighlightThickness,1); ac++;
         XtSetArg(al[ac],XmNshadowThickness,0); ac++;
         if(cellSize > 0) {
            XtSetArg(al[ac],XmNcolumns,cellSize); ac++;
            XtSetArg(al[ac],XmNmaxLength,cellSize); ac++;
         }
         if(toValue.addr) {
            XtSetArg(al[ac],XmNfontList,*(unsigned int *)toValue.addr); ac++;
         }
         sprintf(widgetName,"column%drow%d",j1,i1);
         variableRowAndColumnTF[loc] = XmCreateTextField(variableColumnFM[j1],widgetName,al,ac); loc++;
      }
   }

   ac = 0;
   lowerHorizontalSeparator = XmCreateSeparator(table,"lowerHorizontalSeparator",al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNheight,19); ac++;
   XtSetArg(al[ac],XmNorientation,XmHORIZONTAL); ac++;
   horizontalScrollBar = XmCreateScrollBar(table,"HorizontalScrollBar",al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNorientation,XmVERTICAL); ac++;
   rightVerticalSeparator = XmCreateSeparator(table,"rightVerticalSeparator",al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNwidth,19); ac++;
   verticalScrollBar = XmCreateScrollBar(table,"VerticalScrollBar",al,ac);

   if(mosprshCheckButtonCallback != NULL) {
      ac = 0;
      XtSetArg(al[ac],XmNlabelType,XmPIXMAP); ac++;
      checkMark = XmCreatePushButton(table,"Check Mark",al,ac);
      mosprshCreateCheckMarkPixmap(checkMark);
   }

   ac = 0;
   xmstring = XmStringCreateLtoR(spreadSheetTitle,(XmStringCharSet)XmFONTLIST_DEFAULT_TAG);
   XtSetArg(al[ac],XmNlabelString,xmstring); ac++;
   title = XmCreateLabel(spreadSheet,"Title",al,ac);
   XmStringFree(xmstring);

   ac = 0;
   frame = XmCreateFrame(spreadSheet,"frame",al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNtopOffset,25); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNbottomOffset,10); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNleftOffset,10); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNrightOffset,10); ac++;
   XtSetValues(table,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNtopOffset,5); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_NONE); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNleftOffset,15); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_NONE); ac++;
   XtSetValues(title,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNtopOffset,15); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNbottomOffset,5); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNleftOffset,5); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNrightOffset,5); ac++;
   XtSetValues(frame,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_WIDGET); ac++;
   XtSetArg(al[ac],XmNtopOffset,1); ac++;
   XtSetArg(al[ac],XmNtopWidget,topHorizontalSeparator); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_WIDGET); ac++;
   XtSetArg(al[ac],XmNbottomOffset,1); ac++;
   XtSetArg(al[ac],XmNbottomWidget,lowerHorizontalSeparator); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNleftOffset,1); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_NONE); ac++;
   XtSetValues(fixedColumnView,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNtopOffset,1); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNbottomOffset,1); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_WIDGET); ac++;
   XtSetArg(al[ac],XmNleftOffset,1); ac++;
   XtSetArg(al[ac],XmNleftWidget,fixedColumnView); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_NONE); ac++;
   XtSetValues(leftVerticalSeparator,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNtopOffset,0); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_NONE); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_WIDGET); ac++;
   XtSetArg(al[ac],XmNleftOffset,1); ac++;
   XtSetArg(al[ac],XmNleftWidget,leftVerticalSeparator); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_WIDGET); ac++;
   XtSetArg(al[ac],XmNrightOffset,1); ac++;
   XtSetArg(al[ac],XmNrightWidget,rightVerticalSeparator); ac++;
   XtSetValues(fixedRowView,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNtopOffset,30); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_NONE); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNleftOffset,1); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNrightOffset,1); ac++;
   XtSetValues(topHorizontalSeparator,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_WIDGET); ac++;
   XtSetArg(al[ac],XmNtopOffset,1); ac++;
   XtSetArg(al[ac],XmNtopWidget,topHorizontalSeparator); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_WIDGET); ac++;
   XtSetArg(al[ac],XmNbottomOffset,1); ac++;
   XtSetArg(al[ac],XmNbottomWidget,lowerHorizontalSeparator); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_WIDGET); ac++;
   XtSetArg(al[ac],XmNleftOffset,1); ac++;
   XtSetArg(al[ac],XmNleftWidget,leftVerticalSeparator); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_WIDGET); ac++;
   XtSetArg(al[ac],XmNrightOffset,1); ac++;
   XtSetArg(al[ac],XmNrightWidget,rightVerticalSeparator); ac++;
   XtSetValues(variableRowsAndColumnsView,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_NONE); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNbottomOffset,30); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNleftOffset,1); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNrightOffset,1); ac++;
   XtSetValues(lowerHorizontalSeparator,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_NONE); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNbottomOffset,5); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_WIDGET); ac++;
   XtSetArg(al[ac],XmNleftOffset,1); ac++;
   XtSetArg(al[ac],XmNleftWidget,leftVerticalSeparator); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_WIDGET); ac++;
   XtSetArg(al[ac],XmNrightOffset,1); ac++;
   XtSetArg(al[ac],XmNrightWidget,rightVerticalSeparator); ac++;
   XtSetValues(horizontalScrollBar,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNtopOffset,1); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNbottomOffset,1); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_NONE); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNrightOffset,30); ac++;
   XtSetValues(rightVerticalSeparator,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_WIDGET); ac++;
   XtSetArg(al[ac],XmNtopOffset,1); ac++;
   XtSetArg(al[ac],XmNtopWidget,topHorizontalSeparator); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_WIDGET); ac++;
   XtSetArg(al[ac],XmNbottomOffset,1); ac++;
   XtSetArg(al[ac],XmNbottomWidget,lowerHorizontalSeparator); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_NONE); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNrightOffset,5); ac++;
   XtSetValues(verticalScrollBar,al,ac);

   if(mosprshCheckButtonCallback != NULL) {
      ac = 0;
      XtSetArg(al[ac],XmNtopAttachment,XmATTACH_NONE); ac++;
      XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_FORM); ac++;
      XtSetArg(al[ac],XmNbottomOffset,1); ac++;
      XtSetArg(al[ac],XmNleftAttachment,XmATTACH_NONE); ac++;
      XtSetArg(al[ac],XmNrightAttachment,XmATTACH_FORM); ac++;
      XtSetArg(al[ac],XmNrightOffset,1); ac++;
      XtSetValues(checkMark,al,ac);
   }

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
   XtSetValues(fixedColumn,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_NONE); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_NONE); ac++;
   XtSetValues(fixedColumnTF[0],al,ac);
   for(i1=1 ; i1<nRows ; i1++) {
      ac = 0;
      XtSetArg(al[ac],XmNtopAttachment,XmATTACH_WIDGET); ac++;
      XtSetArg(al[ac],XmNtopWidget,fixedColumnTF[i1-1]); ac++;
      XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_NONE); ac++;
      XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
      XtSetArg(al[ac],XmNrightAttachment,XmATTACH_NONE); ac++;
      XtSetValues(fixedColumnTF[i1],al,ac);
   }
   XtManageChildren(fixedColumnTF,nRows);
   XtManageChild(fixedColumn);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
   XtSetValues(fixedRow,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_NONE); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_NONE); ac++;
   XtSetValues(fixedRowTF[0],al,ac);
   for(j1=1 ; j1<nColumns ; j1++) {
      ac = 0;
      XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
      XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_NONE); ac++;
      XtSetArg(al[ac],XmNleftAttachment,XmATTACH_WIDGET); ac++;
      XtSetArg(al[ac],XmNleftWidget,fixedRowTF[j1-1]); ac++;
      XtSetArg(al[ac],XmNrightAttachment,XmATTACH_NONE); ac++;
      XtSetValues(fixedRowTF[j1],al,ac);
   }
   XtManageChildren(fixedRowTF,nColumns);
   XtManageChild(fixedRow);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
   XtSetValues(variableRowsAndColumns,al,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_NONE); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_NONE); ac++;
   XtSetValues(variableColumnFM[0],al,ac);
   for(j1=1 ; j1<nColumns ; j1++) {
      ac = 0;
      XtSetArg(al[ac],XmNtopAttachment,XmATTACH_OPPOSITE_WIDGET); ac++;
      XtSetArg(al[ac],XmNtopOffset,0); ac++;
      XtSetArg(al[ac],XmNtopWidget,variableColumnFM[j1-1]); ac++;
      XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET); ac++;
      XtSetArg(al[ac],XmNbottomOffset,0); ac++;
      XtSetArg(al[ac],XmNbottomWidget,variableColumnFM[j1-1]); ac++;
      XtSetArg(al[ac],XmNleftAttachment,XmATTACH_WIDGET); ac++;
      XtSetArg(al[ac],XmNleftWidget,variableColumnFM[j1-1]); ac++;
      XtSetArg(al[ac],XmNrightAttachment,XmATTACH_NONE); ac++;
      XtSetValues(variableColumnFM[j1],al,ac);
   }

   loc = 0;
   for(j1=0 ; j1<nColumns ; j1++) {
      ac = 0;
      XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
      XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_NONE); ac++;
      XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
      XtSetArg(al[ac],XmNrightAttachment,XmATTACH_NONE); ac++;
      XtSetValues(variableRowAndColumnTF[loc],al,ac);
      tempColumnTF[0] = variableRowAndColumnTF[loc]; loc++;
      for(i1=1 ; i1<nRows ; i1++) {
         ac = 0;
         XtSetArg(al[ac],XmNtopAttachment,XmATTACH_WIDGET); ac++;
         XtSetArg(al[ac],XmNtopWidget,variableRowAndColumnTF[loc-1]); ac++;
         XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_NONE); ac++;
         XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
         XtSetArg(al[ac],XmNrightAttachment,XmATTACH_NONE); ac++;
         XtSetValues(variableRowAndColumnTF[loc],al,ac);
         tempColumnTF[i1] = variableRowAndColumnTF[loc]; loc++;
      }
      XtManageChildren(tempColumnTF,nRows);
   }
   XtManageChildren(variableColumnFM,nColumns);
   XtManageChild(variableRowsAndColumns);

   XtAddCallback (horizontalScrollBar,XmNvalueChangedCallback,mosprshChngSshhSB,NULL);
   XtAddCallback (horizontalScrollBar,XmNpageIncrementCallback,mosprshChngSshhSB,NULL);
   XtAddCallback (horizontalScrollBar,XmNpageDecrementCallback,mosprshChngSshhSB,NULL);
   XtAddCallback (horizontalScrollBar,XmNincrementCallback,mosprshChngSshhSB,NULL);
   XtAddCallback (horizontalScrollBar,XmNdragCallback,mosprshChngSshhSB,NULL);
   XtAddCallback (horizontalScrollBar,XmNdecrementCallback,mosprshChngSshhSB,NULL);

   XtAddCallback (verticalScrollBar,XmNvalueChangedCallback,mosprshChngSshvSB,NULL);
   XtAddCallback (verticalScrollBar,XmNpageIncrementCallback,mosprshChngSshvSB,NULL);
   XtAddCallback (verticalScrollBar,XmNpageDecrementCallback,mosprshChngSshvSB,NULL);
   XtAddCallback (verticalScrollBar,XmNincrementCallback,mosprshChngSshvSB,NULL);
   XtAddCallback (verticalScrollBar,XmNdragCallback,mosprshChngSshvSB,NULL);
   XtAddCallback (verticalScrollBar,XmNdecrementCallback,mosprshChngSshvSB,NULL);

   if(mosprshCheckButtonCallback != NULL)
      XtAddCallback (checkMark,XmNactivateCallback,mosprshCheckButtonCallback,NULL);
   ac = 0;
   children[ac++] = fixedColumnView;
   children[ac++] = leftVerticalSeparator;
   children[ac++] = fixedRowView;
   children[ac++] = topHorizontalSeparator;
   children[ac++] = variableRowsAndColumnsView;
   children[ac++] = lowerHorizontalSeparator;
   children[ac++] = horizontalScrollBar;
   children[ac++] = rightVerticalSeparator;
   children[ac++] = verticalScrollBar;
   if(mosprshCheckButtonCallback != NULL)
      children[ac++] = checkMark;
   XtManageChildren(children,ac);

   ac = 0;
   children[ac++] = table;
   children[ac++] = title;
   children[ac++] = frame;
   XtManageChildren(children,ac);

   ac = 0;
   XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNtopOffset,0); ac++;
   XtSetArg(al[ac],XmNbottomAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNbottomOffset,0); ac++;
   XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNleftOffset,0); ac++;
   XtSetArg(al[ac],XmNrightAttachment,XmATTACH_FORM); ac++;
   XtSetArg(al[ac],XmNrightOffset,0); ac++;
   XtSetValues(spreadSheet,al,ac);
   XtManageChild(spreadSheet);

   if(isParentManaged)
      XtManageChild(parentFM);

   ac = 0;
   XtSetArg(al[ac],XmNresizable,TRUE); ac++;
   XtSetValues(parentFM,al,ac);

   utFreeBytes((pVoid)fixedColumnTF);
   utFreeBytes((pVoid)fixedRowTF);
   utFreeBytes((pVoid)variableColumnFM);
   utFreeBytes((pVoid)variableRowAndColumnTF);
   utFreeBytes((pVoid)tempColumnTF);
}


#ifdef __STDC__
void moCreateSpreadsheet(Widget parentFM,
                         char *spreadSheetTitle,
                         pSarray rowNames,
                         pSarray columnNames,
                         void mosprshCheckButtonCallback(Widget w,
                                                        XtPointer client_data,
                                                        XtPointer xt_call_data))
#else
void moCreateSpreadsheet(parentFM,
                         spreadSheetTitle,
                         rowNames,
                         columnNames,
                         mosprshCheckButtonCallback)
Widget         parentFM;
char          *spreadSheetTitle;
pSarray        rowNames;
pSarray        columnNames;
pVoidFunction  mosprshCheckButtonCallback;
#endif
{
   mosprshCreateSpreadsheet(parentFM,
                            spreadSheetTitle,
                            rowNames,
                            columnNames,
                            0,
                            mosprshCheckButtonCallback);
}


#ifdef __STDC__
void moCreateSpreadsheetWithCellSize(Widget parentFM,
                                     char *spreadSheetTitle,
                                     pSarray rowNames,
                                     pSarray columnNames,
                                     int cellSize,
                                     void mosprshCheckButtonCallback(
                                                        Widget w,
                                                        XtPointer client_data,
                                                        XtPointer xt_call_data))
#else
void moCreateSpreadsheetWithCellSize(parentFM,
                                     spreadSheetTitle,
                                     rowNames,
                                     columnNames,
                                     cellSize,
                                     mosprshCheckButtonCallback)
Widget         parentFM;
char          *spreadSheetTitle;
pSarray        rowNames;
pSarray        columnNames;
int            cellSize;
pVoidFunction  mosprshCheckButtonCallback;
#endif
{
   mosprshCreateSpreadsheet(parentFM,
                            spreadSheetTitle,
                            rowNames,
                            columnNames,
                            cellSize,
                            mosprshCheckButtonCallback);
}


#ifdef __STDC__
static pSpreadSheetSize moGetSpreadSheetSize(Widget parentFM)
#else
static pSpreadSheetSize moGetSpreadSheetSize(parentFM)
Widget parentFM;
#endif
{
   Widget    spreadSheet;
   int       ac;
   Arg       al[1];
   XtPointer xtSpreadSheetSize = NULL;

   assert(XmIsForm(parentFM));

   spreadSheet = moGetSpreadsheetForm(parentFM);

   if(spreadSheet != NULL) {
      ac = 0;
      XtSetArg(al[ac],XmNuserData,&xtSpreadSheetSize); ac++;
      XtGetValues(spreadSheet,al,ac);
   }

   return((pSpreadSheetSize)xtSpreadSheetSize);
}


#ifdef __STDC__
void moDestroySpreadsheet(Widget parentFM)
#else
void moDestroySpreadsheet(parentFM)
Widget parentFM;
#endif
{
   Widget           spreadSheet;
   Widget           form;
   int              ac;
   Arg              al[1];
   pSpreadSheetSize spreadSheetSize;

   assert(XmIsForm(parentFM));

   spreadSheet = moGetSpreadsheetForm(parentFM);

   if(spreadSheet != NULL) {
      spreadSheetSize = moGetSpreadSheetSize(parentFM);
      moFreeSpreadSheetSize(&spreadSheetSize);

      form = XtParent(spreadSheet);
      ac = 0;
      XtSetArg(al[ac],XmNresizable,FALSE); ac++;
      XtSetValues(form,al,ac);

      XtUnmanageChild(spreadSheet);
      XtDestroyWidget(spreadSheet);
   }
}


#ifdef __STDC__
Widget moGetSpreadsheetForm(Widget parentFM)
#else
Widget moGetSpreadsheetForm(parentFM)
Widget parentFM;
#endif
{
   Widget     managedSpreadSheet = NULL;
   Cardinal   nChildren;
   WidgetList childWidgets;
   Arg        al[2];
   int        ac;
   int        i1;
   Boolean    isManaged;

   assert(XmIsForm(parentFM));

   ac = 0;
   XtSetArg(al[ac],XmNnumChildren,&nChildren); ac++;
   XtSetArg(al[ac],XmNchildren,&childWidgets); ac++;
   XtGetValues(parentFM,al,ac);

   for(i1=0 ; i1<(int)nChildren ; i1++) {
      isManaged = XtIsManaged(childWidgets[i1]);
      if(isManaged) {
         managedSpreadSheet = childWidgets[i1];
         break;
      }
   }

   return(managedSpreadSheet);
}


#ifdef __STDC__
void moManageSpreadsheet(Widget parentFM)
#else
void moManageSpreadsheet(Widget parentFM)
Widget parentFM;
#endif
{
   Cardinal   nChildren;
   WidgetList childWidgets;
   Arg        al[2];
   int        ac;
   int        i1;

   assert(XmIsForm(parentFM));

   ac = 0;
   XtSetArg(al[ac],XmNnumChildren,&nChildren); ac++;
   XtSetArg(al[ac],XmNchildren,&childWidgets); ac++;
   XtGetValues(parentFM,al,ac);

   for(i1=0 ; i1<(int)nChildren ; i1++)
      XtManageChild(childWidgets[i1]);
}


#ifdef __STDC__
void moUnmanageSpreadsheet(Widget parentFM)
#else
void moUnmanageSpreadsheet(Widget parentFM)
Widget parentFM;
#endif
{
   Cardinal   nChildren;
   WidgetList childWidgets;
   Arg        al[2];
   int        ac;
   int        i1;

   assert(XmIsForm(parentFM));

   ac = 0;
   XtSetArg(al[ac],XmNnumChildren,&nChildren); ac++;
   XtSetArg(al[ac],XmNchildren,&childWidgets); ac++;
   XtGetValues(parentFM,al,ac);

   for(i1=0 ; i1<(int)nChildren ; i1++)
      XtUnmanageChild(childWidgets[i1]);
}


#ifdef __STDC__
utLogical moIsSpreadsheetManaged(Widget parentFM)
#else
utLogical moIsSpreadsheetManaged(parentFM)
Widget parentFM;
#endif
{
   utLogical isSpreadsheetManaged = utFalse;
   Widget    managedSpreadSheet = moGetSpreadsheetForm(parentFM);
   Boolean   isFormManaged = XtIsManaged(parentFM);

   if(isFormManaged)
      if(managedSpreadSheet != NULL)
         isSpreadsheetManaged = utTrue;

   return(isSpreadsheetManaged);
}


#ifdef __STDC__
void moGetSpreadsheetNrowAndNcolumn(Widget parentFM,
                                    int *nRows,
                                    int *nColumns)
#else
void moGetSpreadsheetNrowAndNcolumn(parentFM,
                                    nRows,
                                    nColumns)
Widget  parentFM;
int    *nRows;
int    *nColumns;
#endif
{
   pSpreadSheetSize spreadSheetSize = moGetSpreadSheetSize(parentFM);

   if(spreadSheetSize != NULL) {
      *nRows    = spreadSheetSize->Nrows;
      *nColumns = spreadSheetSize->Ncolumns;
   } else {
      *nRows    = 0;
      *nColumns = 0;
   }
}


#ifdef __STDC__
char *moGetSpreadsheetFont()
#else
char *moGetSpreadsheetFont()
#endif
{
   return(spreadSheetFont);
}


