/*
  $RCSfile: motextfw.c,v $       $Revision: 1.15 $
  $State: V7_1 $                  $Date: 2004/11/04 17:49:34 $
*/
#include <Xm/Form.h>
#include <Xm/FileSB.h>

#include "utmemryu.h"
#include "utmacrou.h"
#include "utstrcvu.h"
#include "utstrngu.h"

#include "momotifu.h"
#include "motextfw.h"
#include "mosbutnu.h"
#include "moselctu.h"

#ifdef BPTPC
#define LPRNTF
#endif

#include "utprntfu.h"

#ifdef __STDC__
void moClearTF(Widget wTextField)
#else
void moClearTF(wTextField)
Widget wTextField;
#endif
{
   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   moSetCstringToTF(wTextField,"");
}


#ifdef __STDC__
void moSetCstringToTF(Widget wTextField,
                      char *string)
#else
void moSetCstringToTF(wTextField,
                      string)
Widget  wTextField;
char   *string;
#endif
{
   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   if(!utIsNullString(string))
      XmTextFieldSetString(wTextField,string);
   else
      XmTextFieldSetString(wTextField,"");
}


#ifdef __STDC__
void moCopyToCstringFromTF(Widget wTextField,
                           char *buf,
                           int bufSize)
#else
void moCopyToCstringFromTF(wTextField,
                           buf,
                           bufSize)
Widget  wTextField;
char   *buf;
int     bufSize;
#endif
{
  char *string;

  assert(wTextField != NULL);
  assert(XmIsTextField(wTextField));
  assert(buf != NULL);
  assert(bufSize > 0);

  string = moGetCstringFromTF(wTextField);
  assert(utStringLength(string) < (bufSize - 1));
  strncpy(buf,string,bufSize);
  utFreeBytes((pVoid)string);
}


#ifdef __STDC__
char *moGetCstringFromTF(Widget wTextField)
#else
char *moGetCstringFromTF(wTextField)
Widget wTextField;
#endif
{
   char *xts;
   char *textFieldString;

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   xts = XmTextFieldGetString(wTextField);
   textFieldString = utAssignString(xts);
   XtFree(xts);

   return(textFieldString);
}


#ifdef __STDC__
void moSetIntToTF(Widget wTextField,
                  int value)
#else
void moSetIntToTF(wTextField,
                  value)
Widget wTextField;
int    value;
#endif
{
   char *string;

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   string = utIntToString(value);
   moSetCstringToTF(wTextField,string);
   utFreeBytes((pVoid)string);
}


#ifdef __STDC__
void moSetLongToTF(Widget wTextField,
                   long value)
#else
void moSetLongToTF(wTextField,
                   value)
Widget wTextField;
long   value;
#endif
{
   char *string;

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   string = utLongToString(value);
   moSetCstringToTF(wTextField,string);
   utFreeBytes((pVoid)string);
}


#ifdef __STDC__
void moSetDoubleToTF(Widget wTextField,
                     double value)
#else
void moSetDoubleToTF(wTextField,
                     value)
Widget wTextField;
double value;
#endif
{
   char *string;

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   string = utDoubleToString(value);
   moSetCstringToTF(wTextField,string);
   utFreeBytes((pVoid)string);
}


#ifdef __STDC__
void moSetEditableTF(Widget wTextField)
#else
void moSetEditableTF(wTextField)
Widget wTextField;
#endif
{
   int ac = 0;
   Arg al[1];

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   XtSetArg(al[ac],XmNeditable,TRUE); ac++;
   XtSetValues(wTextField,al,ac);
}


#ifdef __STDC__
void moSetUneditableTF(Widget wTextField)
#else
void moSetUneditableTF(wTextField)
Widget wTextField;
#endif
{
   int ac = 0;
   Arg al[1];

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   XtSetArg(al[ac],XmNeditable,FALSE); ac++;
   XtSetValues(wTextField,al,ac);
}


#ifdef __STDC__
utLogical moIsEditableTF(Widget wTextField)
#else
utLogical moIsEditableTF(wTextField)
Widget wTextField;
#endif
{
   int     ac = 0;
   Arg     al[1];
   Boolean isEditable;

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   XtSetArg(al[ac],XmNeditable,&isEditable); ac++;
   XtGetValues(wTextField,al,ac);

   if(isEditable)
      return(utTrue);
   else
      return(utFalse);
}


#ifdef __STDC__
void moShowLastPositionTF(Widget wTextField)
#else
void moShowLastPositionTF(wTextField)
  Widget wTextField;
#endif
{
   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   XmTextFieldShowPosition(wTextField,XmTextFieldGetLastPosition(wTextField));
}


#ifdef __STDC__
int moGetMaxLengthTF(Widget wTextField)
#else
int moGetMaxLengthTF(wTextField)
Widget wTextField;
#endif
{
   int ac = 0;
   Arg al[1];
   int maxLength;

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   XtSetArg(al[ac],XmNmaxLength,&maxLength); ac++;
   XtGetValues(wTextField,al,ac);

   return(maxLength);
}


#ifdef __STDC__
void moSetMaxLengthTF(Widget wTextField,int maxLength)
#else
void moSetMaxLengthTF(wTextField,maxLength)
Widget wTextField;
int    maxLength;
#endif
{
   int ac;
   Arg al[1];

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   ac = 0;
   XtSetArg(al[ac],XmNmaxLength,maxLength); ac++;
   XtSetValues(wTextField,al,ac);
}


#ifdef __STDC__
void moSetCursorVisibleOnTF(Widget wTextField)
#else
void moSetCursorVisibleOnTF(wTextField)
Widget wTextField;
#endif
{
   int ac = 0;
   Arg al[1];

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   XtSetArg(al[ac],XmNcursorPositionVisible,TRUE); ac++;
   XtSetValues(wTextField,al,ac);
}


#ifdef __STDC__
void moSetCursorVisibleOffTF(Widget wTextField)
#else
void moSetCursorVisibleOffTF(wTextField)
Widget wTextField;
#endif
{
   int ac = 0;
   Arg al[1];

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   XtSetArg(al[ac],XmNcursorPositionVisible,FALSE); ac++;
   XtSetValues(wTextField,al,ac);
}


#ifdef __STDC__
utLogical moIsCursorVisibleTF(Widget wTextField)
#else
utLogical moIsCursorVisibleTF(wTextField)
Widget wTextField;
#endif
{
   int     ac = 0;
   Arg     al[1];
   Boolean isVisible;

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   XtSetArg(al[ac],XmNcursorPositionVisible,&isVisible); ac++;
   XtGetValues(wTextField,al,ac);

   if(isVisible)
      return(utTrue);
   else
      return(utFalse);
}


#ifdef __STDC__
utLogical moIsEmptyTF(Widget wTextField)
#else
utLogical moIsEmptyTF(wTextField)
Widget wTextField;
#endif
{
   utLogical  isEmptyTF = utFalse;
   char      *string;

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   string = moGetCstringFromTF(wTextField);
   if(utIsNullString(string))
      isEmptyTF = utTrue;
   else
      if(utHasAllBlanks(string))
         isEmptyTF = utTrue;

   utFreeBytes((pVoid)string);

   return(isEmptyTF);
}

static long motextfDefaultEventMask = -1;
static long motextfDefaultBackground = -1;
static long motextfInputMask = KeyPressMask | KeyReleaseMask |
                               ButtonPressMask | ButtonReleaseMask;

#ifdef __STDC__
void moDisableInputTF(Widget wTextField)
#else
void moDisableInputTF(wTextField)
Widget wTextField;
#endif
{
   Widget form;
   Pixel  background;
   long   eventMask;
   long   noInputMask = ~motextfInputMask;
   long   noInputEventMask;

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   eventMask = moGetEventMask(wTextField);
   noInputEventMask = eventMask & noInputMask;
   moSetEventMask(wTextField,noInputEventMask);
   if(motextfDefaultEventMask == -1)
      motextfDefaultEventMask = eventMask;

   moSetCursorVisibleOffTF(wTextField);
   
   form = XtParent(wTextField);
   while(!XmIsForm(form) && !XmIsFileSelectionBox(form))
      form = XtParent(form);
 
   if(motextfDefaultBackground == -1) {
      motextfDefaultBackground = (long)moGetBackgroundPixel(wTextField);
/*    utConsolePrint("Default text pixel = %ld, set by Disable(%s)\n",motextfDefaultBackground,
                                                                      moGetWidgetName(wTextField)); */
   }
   background = moGetBackgroundPixel(form);
   moSetBackgroundPixel(wTextField,background);
   moSetTraversalOff(wTextField);
}


#ifdef __STDC__
void moEnableInputTF(Widget wTextField)
#else
void moEnableInputTF(wTextField)
Widget wTextField;
#endif
{
   long            eventMask;
   long            inputEventMask;
   utLogical       isSbuttonWidget;
   ColorIdentifier sbuttonColorIdentifier;

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   isSbuttonWidget = moIsSbuttonWidget(wTextField);
   if(isSbuttonWidget) {
      if(motextfDefaultEventMask >= 0) {
         eventMask = moGetEventMask(wTextField);
         inputEventMask = eventMask | motextfInputMask;
         moSetEventMask(wTextField,inputEventMask);

         sbuttonColorIdentifier = moGetSbuttonColorIdentifier();
         moSetBackgroundPixel(wTextField,(Pixel)sbuttonColorIdentifier);
         moSetTraversalOn(wTextField);
      }
   } else {
      if((motextfDefaultEventMask >= 0) && (motextfDefaultBackground >= 0)) {
         eventMask = moGetEventMask(wTextField);
         inputEventMask = eventMask | motextfInputMask;
         moSetEventMask(wTextField,inputEventMask);

         moSetBackgroundPixel(wTextField,(Pixel)motextfDefaultBackground);
      } else {
         if(motextfDefaultBackground == -1) {
            motextfDefaultBackground = (long)moGetBackgroundPixel(wTextField);
/*          utConsolePrint("Default text pixel = %ld, set by Enable(%s)\n",motextfDefaultBackground,
                                                                           moGetWidgetName(wTextField)); */
         }
         if(motextfDefaultEventMask == -1)
            motextfDefaultEventMask = moGetEventMask(wTextField);
      }
      moSetTraversalOn(wTextField);
   }
   if(moIsEditableTF(wTextField))
      moSetCursorVisibleOnTF(wTextField);
}


#ifdef __STDC__
void moSetNumberOfColumnsTF(Widget wTextField,
                            int numberOfColumns)
#else
void moSetNumberOfColumnsTF(wTextField,
                            numberOfColumns)
Widget wTextField;
int    numberOfColumns;
#endif
{
   int ac = 0;
   Arg al[1];

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   XtSetArg(al[ac],XmNcolumns,numberOfColumns); ac++;
   XtSetValues(wTextField,al,ac);
}


#ifdef __STDC__
int moGetNumberOfColumnsTF(Widget wTextField)
#else
int moGetNumberOfColumnsTF(wTextField)
Widget wTextField;
#endif
{
   int ac = 0;
   Arg al[1];
   int numberOfColumns;

   assert(wTextField != NULL);
   assert(XmIsTextField(wTextField));

   XtSetArg(al[ac],XmNcolumns,&numberOfColumns); ac++;
   XtGetValues(wTextField,al,ac);

   return(numberOfColumns);
}


#ifdef __STDC__
void moAddTextFieldVchgCallback(Widget wTextField,
                                void valueChangedCallback(Widget w,
                                                          XtPointer client_data,
                                                          XtPointer xt_call_data))
#else
void moAddTextFieldVchgCallback(wTextField,
                                valueChangedCallback)
Widget        wTextField;
pVoidFunction valueChangedCallback;
#endif
{
   XtAddCallback(wTextField,XmNvalueChangedCallback,valueChangedCallback,NULL);
}


