#include <Xm/Xm.h>

#include "modefltw.h"
#include "momotifu.h"
#include "mosprshx.h"
#include "utsarryu.h"
#include "testc.h"
#include "testx.xh"
#include "ttsprshx.xh"

#ifdef __STDC__
void testInterface(unsigned int *argc,
         char **argv)
#else
void testInterface(argc,
         argv)
unsigned int  *argc;
char         **argv;
#endif
{
   Display         *display;
   XtAppContext     app_context;
   char            *appName;
   char            *errorMessage;
   char            *projectDirectory;
   char            *scenarioPathName;
   char            *scenarioReplicatePathName;

   XtToolkitInitialize();
   app_context = XtCreateApplicationContext();
   moSetDefaultAppContext(app_context);

   appName = "Test";
   display = XtOpenDisplay(app_context,NULL,
                           appName,"XApplication",
                           NULL,0,argc,argv);
   
   XtAddConverter(XmRString,XmRUnitType,XmCvtStringToUnitType,NULL,0);

   testCreateDB(*argc,argv,display);

   XtRealizeWidget(vtestDB);

   moWaitWhileManaged(vtestFM);
}

#include <Xm/Xm.h>
#include <Xm/Protocols.h>

#ifdef __STDC__
void testCreateDB(unsigned int argc,
                  char **argv,
                  Display *display)
#else
void testCreateDB(argc,
                  argv,
                  display)
unsigned int   argc;
char         **argv;
Display       *display;
#endif
{
   char *appName;
   Atom  WM_DELETE_WINDOW;

   appName = "Test2";
   create_vtestDB(display,appName,argc,argv);
   moSetDefaultParentWidget(vtestDB);

   WM_DELETE_WINDOW = XmInternAtom(display,"WM_DELETE_WINDOW",False);
   XmAddWMProtocolCallback(vtestDB,WM_DELETE_WINDOW,
                           testActExitPB,NULL);
}


#ifdef __STDC__
void testActOpenPB(Widget w,
                   XtPointer client_data,
                   XtPointer xt_call_data)
#else
void testActOpenPB(w,client_data,xt_call_data)
Widget    w;
XtPointer client_data;
XtPointer xt_call_data;
#endif
{
   XmPushButtonCallbackStruct *call_data = (XmPushButtonCallbackStruct *) xt_call_data;
   char                       *projectPathName;
   pSarray                    columnLabels = utCreateSarrayOfSize(1);
   pSarray                    rows = utCreateSarrayOfSize(2);

   create_vttmodalDB(vtestDB);
   utAddToSarray(columnLabels,"Measuring Unit Value");
   utAddToSarray(rows,"Mass");
   utAddToSarray(rows,"Volume");
   moCreateSpreadsheet(vttmodalFM,
                       "Measuring Unit Specification",
                       rows,
                       columnLabels,
                       NULL);

   XtManageChild(vttmodalFM);
}


#ifdef __STDC__
void testActExitPB(Widget w,
                   XtPointer client_data,
                   XtPointer xt_call_data)
#else
void testActExitPB(w,client_data,xt_call_data)
Widget    w;
XtPointer client_data;
XtPointer xt_call_data;
#endif
{
   XmPushButtonCallbackStruct *call_data = (XmPushButtonCallbackStruct *) xt_call_data;

   testExit();
}

#ifdef __STDC__
void testExit()
#else
void testExit()
#endif
{
   char      *projectPathName;
   char      *projectName;

   XtUnmanageChild(vtestFM);
}
