/*
  $RCSfile: utfilesu.c,v $       $Revision: 1.23 $
  $State: V7_1 $                  $Date: 2004/11/05 11:24:16 $
*/
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifdef BPTUNIX
#include <dirent.h>
#include <unistd.h>
#endif
#ifdef BPTVMS
#ifndef S_IRWXU
#define S_IRWXU 0000700
#endif
#ifndef S_IRGRP
#define S_IRGRP 0000040
#endif
#ifndef S_IXGRP
#define S_IXGRP 0000010
#endif
#ifndef S_IROTH
#define S_IROTH 0000004
#endif
#ifndef S_IXOTH
#define S_IXOTH 0000001
#endif
#ifndef S_ISDIR
#define S_ISDIR(m) (((m)& S_IFMT) == S_IFDIR)
#endif
#ifndef S_ISREG
#define S_ISREG(m) (((m)& S_IFMT) == S_IFREG)
#endif
#include <unixio.h>
#include <unixlib.h>
#ifndef BPTALPHA
typedef unsigned int mode_t;
#endif
#include <rmsdef.h>
#include <descrip.h>
#include <lib$routines.h>
#ifndef LIB$FIND_FILE
#define LIB$FIND_FILE lib$find_file
#endif
#ifndef LIB$FIND_FILE_END
#define LIB$FIND_FILE_END lib$find_file_end
#endif
#ifndef LIB$STOP
#define LIB$STOP lib$stop
#endif
#endif
#ifdef BPTPC
#define stat   _stat
#ifndef S_IFMT
#define S_IFMT   _S_IFMT
#endif
#ifndef S_IFDIR
#define S_IFDIR  _S_IFDIR
#endif
#ifndef S_IFCHR
#define S_IFCHR  _S_IFCHR
#endif
#ifndef S_IFREG
#define S_IFREG  _S_IFREG
#endif
#ifndef S_IREAD
#define S_IREAD  _S_IREAD
#endif
#ifndef S_IWRITE
#define S_IWRITE _S_IWRITE
#endif
#ifndef S_IEXEC
#define S_IEXEC  _S_IEXEC
#endif
#ifndef S_IRWXU
#define S_IRWXU 0000700
#endif
#ifndef S_IRGRP
#define S_IRGRP 0000040
#endif
#ifndef S_IXGRP
#define S_IXGRP 0000010
#endif
#ifndef S_IROTH
#define S_IROTH 0000004
#endif
#ifndef S_IXOTH
#define S_IXOTH 0000001
#endif
#ifndef S_ISDIR
#define S_ISDIR(m) (((m)& S_IFMT) == S_IFDIR)
#endif
#ifndef S_ISREG
#define S_ISREG(m) (((m)& S_IFMT) == S_IFREG)
#endif
#include <io.h>
#define R_OK    04
#define W_OK    02
#define X_OK    00
#define access  _access
#define write   _write
#define read    _read
#include <direct.h>
#define mkdir   _mkdir
#define getcwd  _getcwd
#define fileno  _fileno
#include <fcntl.h>
typedef unsigned int mode_t;
#endif

#include "uttypesu.h"
#include "utmacrou.h"
#include "utmemryu.h"
#include "utfilesu.h"
#include "utstrngu.h"
#include "utstrcvu.h"
#include "utstriou.h"
#include "utprntfu.h"
#include "utsysclu.h"

#ifdef BPTVMS
#ifdef __STDC__
static char *utGetDirectoryInFilenameFormat(char *dirname)
#else
static char *utGetDirectoryInFilenameFormat(dirname)
char *dirname;
#endif
{
   char   *dirPathName = NULL;
   size_t  lenDirname = utStringLength(dirname);
   char   *locDot;
   char   *node;
   char   *directory;

   if(dirname[lenDirname-1] == ']') {
      dirPathName = (char *)utGetBytes(lenDirname+5);
      strcpy(dirPathName,dirname);
      locDot = strrchr(dirPathName,'.');
      if(locDot != NULL) {
         *locDot = ']';
         dirPathName[lenDirname-1] = '\0';
         strcat(dirPathName,".DIR");
      } else {
         utFreeBytes((pVoid)dirPathName);
         node = utGetDelimitedField(dirname,"[]",1);
         directory = utGetDelimitedField(dirname,"[]",2);
         dirPathName = utCatCStringsWithDelimiter("",
                                                  node,
                                                  "[000000]",
                                                  directory,
                                                  ".DIR","");
         utFreeBytes((pVoid)directory);
         utFreeBytes((pVoid)node);
      }
   } else {
      dirPathName = utAssignString(dirname);
   }

   return(dirPathName);
}
#endif


#ifdef __STDC__
long utGetFileTime(char *fileName)
#else
long utGetFileTime(fileName)
char *fileName;
#endif
{
   struct stat statbuf;

   if(stat(fileName,&statbuf) == 0)
      return((long)statbuf.st_mtime);
   else
      return((long)-1);
}

/*
#ifdef BPTPC
#ifdef __STDC__
long utGetFileSize(char *fileName)
#else
long utGetFileSize(fileName)
char *fileName;
#endif
{
   struct _stat64 statbuf;

   if(_stat64(fileName,&statbuf) == 0) {
      printf(" -- utGetFileSize %s %d\n",fileName,(long)statbuf.st_size);
      return((long)statbuf.st_size);
   } else {
      return((long)-1);
   }
}
#else   */
#ifdef __STDC__
long utGetFileSize(char *fileName)
#else
long utGetFileSize(fileName)
char *fileName;
#endif
{
   struct stat statbuf;

   if(stat(fileName,&statbuf) == 0)
      return((long)statbuf.st_size);
   else
      return((long)-1);
}
/* #endif  */


#ifdef BPTUNIX
#ifdef __STDC__
utLogical utIsFileTypeDirectory(char *fileName)
#else
utLogical utIsFileTypeDirectory(fileName)
char *fileName;
#endif
{
   utLogical   isDirectory = utFalse;
   struct stat statbuf;

   if(stat(fileName,&statbuf) == 0) {
      if(S_ISDIR(statbuf.st_mode) != 0)
         isDirectory = utTrue;
   }
   return(isDirectory);
}
#endif


#ifdef BPTVMS
#ifdef __STDC__
utLogical utIsFileTypeDirectory(char *fileName)
#else
utLogical utIsFileTypeDirectory(fileName)
char *fileName;
#endif
{
   utLogical    isDirectory = utFalse;
   char        *dirPathName = utGetDirectoryInFilenameFormat(fileName);
   struct stat  statbuf;

   if(stat(dirPathName,&statbuf) == 0) {
      if(S_ISDIR(statbuf.st_mode) != 0)
         isDirectory = utTrue;
   }
   utFreeBytes((pVoid)dirPathName);

   return(isDirectory);
}
#endif

#ifdef BPTPC
#ifdef __STDC__
utLogical utIsFileTypeDirectory(char *fileName)
#else
utLogical utIsFileTypeDirectory(fileName)
char *fileName;
#endif
{
   utLogical   isDirectory = utFalse;
   struct stat statbuf;

   if(stat(fileName,&statbuf) == 0) {
      if(S_ISDIR(statbuf.st_mode) != 0)
         isDirectory = utTrue;
   }
   return(isDirectory);
}
#endif


#ifdef __STDC__
utLogical utIsFileTypeRegular(char *fileName)
#else
utLogical utIsFileTypeRegular(fileName)
char *fileName;
#endif
{
   struct stat statbuf;

   if(stat(fileName,&statbuf) == 0)
      if(S_ISREG(statbuf.st_mode) == 0)
         return(utFalse);
      else
         return(utTrue);
   else {
      return(utFalse);
   }
}


#ifdef __STDC__
char *utGetExtensionFromFile(char *fileName)
#else
char *utGetExtensionFromFile(fileName)
char *fileName;
#endif
{
   char *extension;

   extension = strrchr(fileName,'.');
   if(extension != NULL) extension++;

   return(extension);
}


#ifdef BPTUNIX
#ifdef __STDC__
char *utGetDirectoryFromFile(char *fileName)
#else
char *utGetDirectoryFromFile(fileName)
char *fileName;
#endif
{
   char *directory;
   char *slash;

   directory = utAssignString(fileName);
   slash = strrchr(directory,'/');
   if(slash != NULL) {
      *slash = '\0';
      if(utIsNullString(directory)) {
         utFreeBytes((pVoid)directory);
         directory = utAssignString("/");
      }
   } else {
      utFreeBytes((pVoid)directory);
      directory = NULL;
   }

   if(directory == NULL)
      directory = utGetCurrentWorkingDirectory();

   return(directory);
}
#endif

#ifdef BPTVMS
#ifdef __STDC__
char *utGetDirectoryFromFile(char *fileName)
#else
char *utGetDirectoryFromFile(fileName)
char *fileName;
#endif
{
   char *directory;
   char *bracket;
   char *colon;

   directory = utAssignString(fileName);
   bracket = strrchr(directory,']');
   if(bracket != NULL) {
      bracket++;
      *bracket = '\0';
   } else {
      colon = strrchr(directory,':');
      if(colon != NULL) {
         colon++;
         *colon = '\0';
      } else {
         utFreeBytes((pVoid)directory);
         directory = NULL;
      }
   }

   if(directory == NULL)
      directory = utGetCurrentWorkingDirectory();

   return(directory);
}
#endif

#ifdef BPTPC
#ifdef __STDC__
char *utGetDirectoryFromFile(char *fileName)
#else
char *utGetDirectoryFromFile(fileName)
char *fileName;
#endif
{
   char *directory;
   char *slash;

   directory = utAssignString(fileName);
   slash = strrchr(directory,'\\');
   if(slash != NULL) {
      *slash = '\0';
      if(utIsNullString(directory)) {
         utFreeBytes((pVoid)directory);
         directory = utAssignString("\\");
      }
   } else {
      utFreeBytes((pVoid)directory);
      directory = NULL;
   }

   if(directory == NULL)
      directory = utGetCurrentWorkingDirectory();

   return(directory);
}
#endif


#ifdef BPTUNIX
#ifdef __STDC__
char *utGetBaseWithExtensionFromFile(char *fileName)
#else
char *utGetBaseWithExtensionFromFile(fileName)
char *fileName;
#endif
{
   char *baseWithExtension;
   char *slash;

   baseWithExtension = (char *)utGetBytes(utStringLength(fileName)+1);
   slash = strrchr(fileName,'/');
   if(slash != NULL) {
      slash++;
      strcpy(baseWithExtension,slash);
   } else {
      strcpy(baseWithExtension,fileName);
   }

   return(baseWithExtension);
}
#endif

#ifdef BPTVMS
#ifdef __STDC__
char *utGetBaseWithExtensionFromFile(char *fileName)
#else
char *utGetBaseWithExtensionFromFile(fileName)
char *fileName;
#endif
{
   char *baseWithExtension;
   char *bracket;
   char *colon;

   baseWithExtension = (char *)utGetBytes(utStringLength(fileName)+1);
   bracket = strrchr(fileName,']');
   if(bracket != NULL) {
      bracket++;
      strcpy(baseWithExtension,bracket);
   } else {
      colon = strrchr(fileName,':');
      if(colon != NULL) {
         colon++;
         strcpy(baseWithExtension,colon);
      } else {
         strcpy(baseWithExtension,fileName);
      }
   }

   return(baseWithExtension);
}
#endif

#ifdef BPTPC
#ifdef __STDC__
char *utGetBaseWithExtensionFromFile(char *fileName)
#else
char *utGetBaseWithExtensionFromFile(fileName)
char *fileName;
#endif
{
   char *baseWithExtension;
   char *slash;

   baseWithExtension = (char *)utGetBytes(utStringLength(fileName)+1);
   slash = strrchr(fileName,'\\');
   if(slash != NULL) {
      slash++;
      strcpy(baseWithExtension,slash);
   } else {
      strcpy(baseWithExtension,fileName);
   }

   return(baseWithExtension);
}
#endif


#ifdef __STDC__
char *utGetBaseFromFile(char *fileName)
#else
char *utGetBaseFromFile(fileName)
char *fileName;
#endif
{
   char *baseName = NULL;
   char *extension;
   char *dot;

   if(!utIsNullString(fileName)) {
      baseName = utGetBaseWithExtensionFromFile(fileName);
      extension = utGetExtensionFromFile(fileName);
      if(extension != NULL) {
         if(utEqualStrings(extension,"Z")) {
            dot = strrchr(baseName,'.');
            *dot = '\0';
         }
      }
      dot = strrchr(baseName,'.');
      if(dot != NULL) *dot = '\0';
   }

   return(baseName);
}


#ifdef BPTUNIX
#ifdef __STDC__
char *utMakeFileName(char *directory,
                     char *basename,
                     char *extension)
#else
char *utMakeFileName(directory,
                     basename,
                     extension)
char *directory;
char *basename;
char *extension;
#endif
{
   char   *fileName;
   size_t  length;

   length = utStringLength(directory)+1+utStringLength(basename);
   if(!utIsNullString(extension))
      length = length+utStringLength(extension)+1;

   fileName = (char *)utGetBytes(length+1);
   utClearString(fileName);

   if(!utIsNullString(directory)) {
      strcat(fileName,directory);
      length = utStringLength(fileName);
      if(fileName[length-1] != '/')
         strcat(fileName,"/");
   }

   strcat(fileName,basename);

   if(!utIsNullString(extension)) {
      strcat(fileName,".");
      strcat(fileName,extension);
   }

   return(fileName);
}
#endif

#ifdef BPTVMS
#ifdef __STDC__
char *utMakeFileName(char *directory,
                     char *basename,
                     char *extension)
#else
char *utMakeFileName(directory,
                     basename,
                     extension)
char *directory;
char *basename;
char *extension;
#endif
{
   char   *fileName;
   size_t  length;

   length = utStringLength(directory)+utStringLength(basename);
   if(!utIsNullString(extension))
      length = length+utStringLength(extension)+1;

   fileName = (char *)utGetBytes(length+1);
   utClearString(fileName);

   if(!utIsNullString(directory))
      strcat(fileName,directory);

   strcat(fileName,basename);

   if(!utIsNullString(extension)) {
      strcat(fileName,".");
      strcat(fileName,extension);
   }

   return(fileName);
}
#endif

#ifdef BPTPC
#ifdef __STDC__
char *utMakeFileName(char *directory,
                     char *basename,
                     char *extension)
#else
char *utMakeFileName(directory,
                     basename,
                     extension)
char *directory;
char *basename;
char *extension;
#endif
{
   char   *fileName;
   size_t  length;

   length = utStringLength(directory)+1+utStringLength(basename);
   if(!utIsNullString(extension))
      length = length+utStringLength(extension)+1;

   fileName = (char *)utGetBytes(length+1);
   utClearString(fileName);

   if(!utIsNullString(directory)) {
      strcat(fileName,directory);
      length = utStringLength(fileName);
      if(fileName[length-1] != '\\')
         strcat(fileName,"\\");
   }

   strcat(fileName,basename);

   if(!utIsNullString(extension)) {
      strcat(fileName,".");
      strcat(fileName,extension);
   }

   return(fileName);
}
#endif


#ifdef BPTUNIX
#ifdef __STDC__
utLogical utRemoveFile(char *fileName)
#else
utLogical utRemoveFile(fileName)
char *fileName;
#endif
{
   utLogical removeOK = utTrue;
   int       status = unlink(fileName);

   if(status != 0) {
      perror(fileName);
      removeOK = utFalse;
   }

   return(removeOK);
}
#endif

#ifdef BPTVMS
#ifdef __STDC__
utLogical utRemoveFile(char *fileName)
#else
utLogical utRemoveFile(fileName)
char *fileName;
#endif
{
   utLogical removeOK = utTrue;
   int       status = remove(fileName);

   if(status != 0) {
      perror(fileName);
      removeOK = utFalse;
   }

   return(removeOK);
}
#endif

#ifdef BPTPC
#ifdef __STDC__
utLogical utRemoveFile(char *fileName)
#else
utLogical utRemoveFile(fileName)
char *fileName;
#endif
{
   utLogical removeOK = utTrue;
   int       status = _unlink(fileName);

   if(status != 0) {
      perror(fileName);
      removeOK = utFalse;
   }

   return(removeOK);
}
#endif


#ifdef BPTUNIX
#ifdef __STDC__
utLogical utRemoveDirectory(char *pathName)
#else
utLogical utRemoveDirectory(pathName)
char *pathName;
#endif
{
   utLogical removeOK = utTrue;
   int       status = rmdir(pathName);

   if(status != 0) {
      if(errno != EEXIST)
         perror(pathName);
      removeOK = utFalse;
   }

   return(removeOK);
}
#endif


#ifdef BPTVMS
#ifdef __STDC__
utLogical utRemoveDirectory(char *pathName)
#else
utLogical utRemoveDirectory(pathName)
char *pathName;
#endif
{
   utLogical  removeOK = utTrue;
   char      *dirPathName = utGetDirectoryInFilenameFormat(pathName);
   int        status;

   status = remove(dirPathName);
   utFreeBytes((pVoid)dirPathName);

   if(status != 0) {
      if(errno != EEXIST)
         perror(pathName);
      removeOK = utFalse;
   }

   return(removeOK);
}
#endif

#ifdef BPTPC
#ifdef __STDC__
utLogical utRemoveDirectory(char *pathName)
#else
utLogical utRemoveDirectory(pathName)
char *pathName;
#endif
{
   utLogical removeOK = utTrue;
   int       status = _rmdir(pathName);

   if(status != 0) {
      if(errno != EEXIST)
         perror(pathName);
      removeOK = utFalse;
   }

   return(removeOK);
}
#endif


#ifdef __STDC__
utLogical utFileExist(char *fileName)
#else
utLogical utFileExist(fileName)
char *fileName;
#endif
{
   utLogical fileExists = utFalse;

   if(utIsFileTypeRegular(fileName)) {
      if(access(fileName,R_OK) == 0)
         fileExists = utTrue;
   } else {
      fileExists = utIsDirectorySearchable(fileName);
   }

   return(fileExists);
}


#ifdef BPTUNIX
#ifdef __STDC__
utLogical utIsFileWriteable(char *fileName)
#else
utLogical utIsFileWriteable(fileName)
char *fileName;
#endif
{
   utLogical isFileWriteable = utFalse;

   if(access(fileName,W_OK) == 0)
      isFileWriteable = utTrue;

   return(isFileWriteable);
}
#endif

#ifdef BPTVMS
#ifdef __STDC__
utLogical utIsFileWriteable(char *fileName)
#else
utLogical utIsFileWriteable(fileName)
char *fileName;
#endif
{
   utLogical  isFileWriteable = utFalse;
   char      *dirPathName;

   if(utIsFileTypeDirectory(fileName)) {
      dirPathName = utGetDirectoryInFilenameFormat(fileName);
      if(access(dirPathName,W_OK) == 0)
         isFileWriteable = utTrue;
      utFreeBytes((pVoid)dirPathName);
   } else {
      if(access(fileName,W_OK) == 0)
         isFileWriteable = utTrue;
   }

   return(isFileWriteable);
}
#endif

#ifdef BPTPC
#ifdef __STDC__
utLogical utIsFileWriteable(char *fileName)
#else
utLogical utIsFileWriteable(fileName)
char *fileName;
#endif
{
   utLogical isFileWriteable = utFalse;

   if(access(fileName,W_OK) == 0)
      isFileWriteable = utTrue;

   return(isFileWriteable);
}
#endif


#ifdef BPTUNIX
#ifdef __STDC__
utLogical utIsDirectorySearchable(char *directory)
#else
utLogical utIsDirectorySearchable(directory)
char *directory;
#endif
{
   utLogical isDirectorySearchable = utFalse;

   if(access(directory,X_OK) == 0)
      isDirectorySearchable = utTrue;

   return(isDirectorySearchable);
}
#endif

#ifdef BPTVMS
#ifdef __STDC__
utLogical utIsDirectorySearchable(char *directory)
#else
utLogical utIsDirectorySearchable(directory)
char *directory;
#endif
{
   utLogical  isDirectorySearchable = utFalse;
   char      *dirPathName = utGetDirectoryInFilenameFormat(directory);

   if(access(dirPathName,X_OK) == 0)
      isDirectorySearchable = utTrue;
   utFreeBytes((pVoid)dirPathName);

   return(isDirectorySearchable);
}
#endif

#ifdef BPTPC
#ifdef __STDC__
utLogical utIsDirectorySearchable(char *directory)
#else
utLogical utIsDirectorySearchable(directory)
char *directory;
#endif
{
   utLogical isDirectorySearchable = utFalse;

   if(access(directory,X_OK) == 0)
      isDirectorySearchable = utTrue;

   return(isDirectorySearchable);
}
#endif


#ifdef BPTUNIX
#ifdef __STDC__
pSarray utDirectoryList(char *directory,
                        utFilePermission filePermission)
#else
pSarray utDirectoryList(directory,
                        filePermission)
char             *directory;
utFilePermission  filePermission;
#endif
{
   pSarray        dirList = utCreateSarray();
   struct stat    statbuf;
   DIR           *directoryList;
   struct dirent *directoryEntry;
   char          *pathName;

   if(!utIsNullString(directory)) {
      if(!utHasAllBlanks(directory)) {
         directoryList = opendir(directory);
         if(directoryList != NULL) {
            directoryEntry = readdir(directoryList);
            while(directoryEntry != NULL) {
               pathName = utMakeSubDirectoryName(directory,
                                                 directoryEntry->d_name);
               if       (utIsFileTypeDirectory(pathName)) {
                  if(utIsDirectorySearchable(pathName)) {
                     switch(filePermission) {
                        case FilePermissionReadOnly:
                           utAddToSarray(dirList,directoryEntry->d_name);
                           break;
                        case FilePermissionReadWrite:
                           if(utIsFileWriteable(pathName))
                              utAddToSarray(dirList,directoryEntry->d_name);
                           break;
                        default:
                           break;
                     }
                  }
               } else {
                  utFreeBytes((pVoid)pathName);
                  pathName = utMakeFileName(directory,
                                            directoryEntry->d_name,"");
                  if(utIsFileTypeRegular(pathName)) {
                     switch(filePermission) {
                        case FilePermissionReadOnly:
                           utAddToSarray(dirList,directoryEntry->d_name);
                           break;
                        case FilePermissionReadWrite:
                           if(utIsFileWriteable(pathName))
                              utAddToSarray(dirList,directoryEntry->d_name);
                           break;
                        default:
                           break;
                     }
                  }
               }
               utFreeBytes((pVoid)pathName);
               directoryEntry = readdir(directoryList);
            }
            closedir(directoryList);
         }
      }
   }
   utSortSarray(dirList);

   return(dirList);
}
#endif

#ifdef BPTVMS
#ifdef __STDC__
pSarray utDirectoryList(char *directory,
                        utFilePermission filePermission)
#else
pSarray utDirectoryList(directory,
                        filePermission)
char             *directory;
utFilePermission  filePermission;
#endif
{
   pSarray      dirList = utCreateSarray();
   static char  inputFileSpec[] = "*.*;*";
   static char  outputFileSpec[256];
   static char  defaultDirectory[256];
   $DESCRIPTOR(inputFileSpecDescr,inputFileSpec);
   $DESCRIPTOR(outputFileSpecDescr,outputFileSpec);
   $DESCRIPTOR(defaultDirectoryDescr,defaultDirectory);
   long         context = 0;
   int          conditionValue;
   utLogical    done = utFalse;
   char        *locSpace;
   char        *locBracket;
   utLogical    addName;

   strcpy(defaultDirectory,directory);
   defaultDirectoryDescr.dsc$w_length = utStringLength(directory);
   inputFileSpecDescr.dsc$w_length = utStringLength(inputFileSpec);
   while(!done) {
      conditionValue = LIB$FIND_FILE(&inputFileSpecDescr,
                                     &outputFileSpecDescr,
                                     &context,
                                     &defaultDirectoryDescr);
      if((conditionValue == RMS$_NMF) ||
         (conditionValue == RMS$_FNF)) {
         LIB$FIND_FILE_END(&context);
         done = utTrue;
      } else {
         if((conditionValue & 1) != 1)
            LIB$STOP(conditionValue);
         if(!utIsNullString(outputFileSpec)) {
            locSpace = strchr(outputFileSpec,' ');
            if(locSpace != NULL)
               *locSpace = '\0';  /* filename fills 256 length buffer with spaces*/
            if       (utIsFileTypeDirectory(outputFileSpec)) {
               addName = utIsDirectorySearchable(outputFileSpec);
               if(addName) {
                  switch(filePermission) {
                     case FilePermissionReadOnly:
                        addName = utTrue;
                        break;
                     case FilePermissionReadWrite:
                        addName = utIsFileWriteable(outputFileSpec);
                        break;
                     default:
                        addName = utFalse;
                        break;
                  }
               }
            } else if(utIsFileTypeRegular(outputFileSpec)) {
               switch(filePermission) {
                  case FilePermissionReadOnly:
                     addName = utTrue;
                     break;
                  case FilePermissionReadWrite:
                     addName = utIsFileWriteable(outputFileSpec);
                     break;
                  default:
                     addName = utFalse;
                     break;
               }
            } else
               addName = utFalse;
            if(addName) {
               locBracket = strchr(outputFileSpec,']');
               if(locBracket != NULL)
                  locBracket++;
               utAddToSarray(dirList,locBracket);
            }
         }
      }
   }
   utSortSarray(dirList);

   return(dirList);
}
#endif

#ifdef BPTPC
#ifdef __STDC__
pSarray utDirectoryList(char *directory,
                        utFilePermission filePermission)
#else
pSarray utDirectoryList(directory,
                        filePermission)
char             *directory;
utFilePermission  filePermission;
#endif
{
   pSarray      dirList = utCreateSarray();
   long         context;
   int          conditionValue;
   utLogical    done = utFalse;
   struct       _finddata_t fileInformation ;
   char        *fileSpecification = utMakeFileName(directory,ALLFILES,"");
   char        *pathName;

   if(!utIsNullString(directory)) {
      if(!utHasAllBlanks(directory)) {
         context = _findfirst(fileSpecification,&fileInformation);
         if(context >= 0) {
            while(!done) {
               pathName = utMakeSubDirectoryName(directory,
                                                 fileInformation.name);
               if       (utIsFileTypeDirectory(pathName)) {
                  if(utIsDirectorySearchable(pathName)) {
                     switch(filePermission) {
                        case FilePermissionReadOnly:
                           utAddToSarray(dirList,fileInformation.name);
                           break;
                        case FilePermissionReadWrite:
                           if(utIsFileWriteable(pathName))
                              utAddToSarray(dirList,fileInformation.name);
                           break;
                        default:
                           break;
                     }
                  }
               } else {
                  utFreeBytes((pVoid)pathName);
                  pathName = utMakeFileName(directory,
                                            fileInformation.name,"");
                  if(utIsFileTypeRegular(pathName)) {
                     switch(filePermission) {
                        case FilePermissionReadOnly:
                           utAddToSarray(dirList,fileInformation.name);
                           break;
                        case FilePermissionReadWrite:
                           if(utIsFileWriteable(pathName))
                              utAddToSarray(dirList,fileInformation.name);
                           break;
                        default:
                           break;
                     }
                  }
               }
               utFreeBytes((pVoid)pathName);
               conditionValue = _findnext(context,&fileInformation);
               if(conditionValue < 0)
                  done = utTrue;
            }
            _findclose(context);
         }
      }
   }
   utFreeBytes((pVoid)fileSpecification);
   utSortSarray(dirList);

   return(dirList);
}
#endif


#ifdef __STDC__
pSarray utDirectoryListDirectories(char *directory,
                                   utFilePermission filePermission)
#else
pSarray utDirectoryListDirectories(directory,
                                   filePermission)
char             *directory;
utFilePermission  filePermission;
#endif
{
   pSarray  dirList = utDirectoryList(directory,filePermission);
   pSarray  listOfDirectories = utCreateSarray();
   int      i1,nFiles;
   char    *fileName;
   char    *pathName;
#ifdef BPTVMS
   char    *baseName;
#endif

#ifdef BPTVMS
   utAddToSarray(listOfDirectories,".");
   utAddToSarray(listOfDirectories,"..");
#endif

   nFiles = utGetCountSarray(dirList);
   for(i1=0 ; i1<nFiles ; i1++) {
      fileName = utGetCstringAtPositionInSarray(dirList,i1);
      pathName = utMakeSubDirectoryName(directory,fileName);
      if(utIsFileTypeDirectory(pathName)) {
#ifdef BPTVMS
         baseName = utGetBaseFromFile(fileName);
         utAddToSarray(listOfDirectories,baseName);
         utFreeBytes((pVoid)baseName);
#else
         utAddToSarray(listOfDirectories,fileName);
#endif
      }
      utFreeBytes((pVoid)pathName);
   }
   utFreeSarray(&dirList);

   return(listOfDirectories);
}


#ifdef __STDC__
pSarray utDirectoryListRegularFiles(char *directory,
                                    utFilePermission filePermission)
#else
pSarray utDirectoryListRegularFiles(directory,
                                    filePermission)
char             *directory;
utFilePermission  filePermission;
#endif
{
   pSarray  dirList = utDirectoryList(directory,filePermission);
   pSarray  listOfFiles = utCreateSarray();
   int      i1,nFiles;
   char    *fileName;
   char    *pathName;

   nFiles = utGetCountSarray(dirList);
   for(i1=0 ; i1<nFiles ; i1++) {
      fileName = utGetCstringAtPositionInSarray(dirList,i1);
      pathName = utMakeFileName(directory,fileName,"");
      if(utIsFileTypeRegular(pathName))
         utAddToSarray(listOfFiles,fileName);
      utFreeBytes((pVoid)pathName);
   }
   utFreeSarray(&dirList);

   return(listOfFiles);
}


#ifdef __STDC__
pSarray utDirListPatternRegularFiles(char *directory,
                                     char *pattern,
                                     utLogical ignoreCase,
                                     utFilePermission filePermission)
#else
pSarray utDirListPatternRegularFiles(directory,
                                     pattern,
                                     ignoreCase,
                                     filePermission)
char             *directory;
char             *pattern;
utLogical         ignoreCase;
utFilePermission  filePermission;
#endif
{
   pSarray  dirList = utDirectoryListRegularFiles(directory,filePermission);
   pSarray  listOfFiles = utCreateSarray();
   int      i1,nFiles;
   char    *fileName;
   char    *compareName;
   char    *localPattern = utAssignString(pattern);
#ifdef BPTVMS
   char    *locSemicolon;
#endif

#ifdef BPTVMS
   utStringToUpper(localPattern);
#endif
   nFiles = utGetCountSarray(dirList);
   for(i1=0 ; i1<nFiles ; i1++) {
      fileName = utGetCstringAtPositionInSarray(dirList,i1);
      compareName = utAssignString(fileName);
#ifdef BPTVMS
      if(!utStringContainsSubstring(localPattern,";")) {
         locSemicolon = strchr(compareName,';');
         if(locSemicolon != NULL)
            *locSemicolon = '\0';
      }
#endif
      if(utDoesStringMatchPattern(compareName,localPattern,ignoreCase))
         utAddToSarray(listOfFiles,fileName);
      utFreeBytes((pVoid)compareName);
   }
   utFreeBytes((pVoid)localPattern);
   utFreeSarray(&dirList);

   return(listOfFiles);
}


#ifdef BPTUNIX
#ifdef __STDC__
char *utGetParentDirectory(char *directory)
#else
char *utGetParentDirectory(directory)
char *directory;
#endif
{
   char *parentDirectory = utAssignString(directory);
   char *slash;

   if(parentDirectory[utStringLength(directory)-1] == '/')
      parentDirectory[utStringLength(directory)-1] = '\0';

   if(utEqualStrings(parentDirectory,"/")) {
      utFreeBytes((pVoid)parentDirectory);
      parentDirectory = NULL;
   } else {
      slash = strrchr(parentDirectory,'/');
      if(slash != NULL) {
         *slash = '\0';
         if(utIsNullString(parentDirectory)) {
            utFreeBytes((pVoid)parentDirectory);
            parentDirectory = utAssignString("/");
         }
      } else {
         utFreeBytes((pVoid)parentDirectory);
         parentDirectory = NULL;
      }
   }

   return(parentDirectory);
}
#endif

#ifdef BPTVMS
#ifdef __STDC__
char *utGetParentDirectory(char *directory)
#else
char *utGetParentDirectory(directory)
char *directory;
#endif
{
   char *parentDirectory = utAssignString(directory);
   char *dot;
   char *node;

   dot = strrchr(parentDirectory,'.');
   if(dot != NULL) {
      *dot = ']';
      dot++;
      *dot = '\0';
   } else {
      utFreeBytes((pVoid)parentDirectory);
      node = utGetDelimitedField(directory,"[]",1);
      parentDirectory = utCatStringPlusString(node,"","[000000]");
      utFreeBytes((pVoid)node);
   }

   return(parentDirectory);
}
#endif

#ifdef BPTPC
#ifdef __STDC__
char *utGetParentDirectory(char *directory)
#else
char *utGetParentDirectory(directory)
char *directory;
#endif
{
   char *parentDirectory = utAssignString(directory);
   char *slash;
   int   parentLength;

   if(parentDirectory[utStringLength(directory)-1] == '\\')
      parentDirectory[utStringLength(directory)-1] = '\0';

   parentLength = utStringLength(parentDirectory);
   if((parentLength == 3) &&
      (parentDirectory[1] == ':') &&
      (parentDirectory[2] == '\\')) {
      utFreeBytes((pVoid)parentDirectory);
      parentDirectory = NULL;
   } else {
      slash = strrchr(parentDirectory,'\\');
      if(slash != NULL) {
         *slash = '\0';
         parentLength = utStringLength(parentDirectory);
         if((parentLength == 2) &&
            (parentDirectory[1] == ':')) {
            parentDirectory[2] = '\\';
            parentDirectory[3] = '\0';
         }
      } else {
         utFreeBytes((pVoid)parentDirectory);
         parentDirectory = NULL;
      }
   }

   return(parentDirectory);
}
#endif


#ifdef BPTUNIX
#ifdef __STDC__
char *utMakeSubDirectoryName(char *directory,
                             char *subDirectory)
#else
char *utMakeSubDirectoryName(directory,
                             subDirectory)
char *directory;
char *subDirectory;
#endif
{
   char   *pathName;
   size_t  length;

   length = utStringLength(directory)+1+utStringLength(subDirectory);

   pathName = (char *)utGetBytes(length+1);
   strcpy(pathName,directory);

   length = utStringLength(pathName);
   if(pathName[length-1] != '/')
      strcat(pathName,"/");
   strcat(pathName,subDirectory);

   return(pathName);
}
#endif


#ifdef BPTVMS
#ifdef __STDC__
char *utMakeSubDirectoryName(char *directory,
                             char *subDirectory)
#else
char *utMakeSubDirectoryName(directory,
                             subDirectory)
char *directory;
char *subDirectory;
#endif
{
   char   *cp;
   char   *pathName;
   size_t  size;
   size_t  lengthDirectory = utStringLength(directory);
   size_t  lengthSubDirectory = utStringLength(subDirectory);

   size = lengthDirectory+1+lengthSubDirectory;

   pathName = (char *)utGetBytes(size+1);
   strcpy(pathName,directory);
   pathName[lengthDirectory-1] = '.';

   if(lengthSubDirectory > 4) {
      cp = strrchr(subDirectory,'.');
      if(cp != NULL) {
         if(utStrNCmpNoCase(cp,".DIR",4) == 0) {
            strcat(pathName,subDirectory);
            cp = strrchr(pathName,'.');
            *cp = '\0';
         } else {
            strcat(pathName,subDirectory);
         }
      } else {
         strcat(pathName,subDirectory);
      }
   } else {
      strcat(pathName,subDirectory);
   }
   strcat(pathName,"]");

   return(pathName);
}
#endif

#ifdef BPTPC
#ifdef __STDC__
char *utMakeSubDirectoryName(char *directory,
                             char *subDirectory)
#else
char *utMakeSubDirectoryName(directory,
                             subDirectory)
char *directory;
char *subDirectory;
#endif
{
   char   *pathName;
   size_t  length;

   length = utStringLength(directory)+1+utStringLength(subDirectory);

   pathName = (char *)utGetBytes(length+1);
   strcpy(pathName,directory);

   length = utStringLength(pathName);
   if(pathName[length-1] != '\\')
      strcat(pathName,"\\");
   strcat(pathName,subDirectory);

   return(pathName);
}
#endif


#ifdef __STDC__
utLogical utCreateSubDirectory(char *parentDirectory,
                               char *subDirectory)
#else
utLogical utCreateSubDirectory(parentDirectory,
                               subDirectory)
char *parentDirectory;
char *subDirectory;
#endif
{
   utLogical  directoryCreated = utTrue;
   int        status;
   char      *pathName = NULL;
   mode_t     mode = S_IRWXU|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH;
#ifdef BPTVMS
#ifndef BPTALPHA
   char      *fileFormatName;
#endif
#endif

   /* Create directory with permission 744 */

   if(utIsNullString(subDirectory)) {
      pathName = utAssignString(parentDirectory);
   } else {
      pathName = utMakeSubDirectoryName(parentDirectory,
                                        subDirectory);
   }

#ifdef BPTPC
   status = mkdir(pathName);
#else
   status = mkdir(pathName,mode);
#endif
   if(status != 0) {
      perror(pathName);
      directoryCreated = utFalse;
   } else {
#ifdef BPTVMS
#ifndef BPTALPHA
      fileFormatName = utGetDirectoryInFilenameFormat(pathName);
      status = chmod(fileFormatName,mode);
      if(status != 0) {
         perror(fileFormatName);
         directoryCreated = utFalse;
      }
      utFreeBytes((pVoid)fileFormatName);
#endif
#endif
   }
   utFreeBytes((pVoid)pathName);

   return(directoryCreated);
}


#ifdef __STDC__
void utGetFileTree(char *directory,
                   pSarray fileTree,
                   utFilePermission filePermission)
#else
void utGetFileTree(directory,
                   fileTree,
                   filePermission)
char             *directory;
pSarray           fileTree;
utFilePermission  filePermission;
#endif
{
   char    *currentDirectory = utAssignString(directory);
   pSarray  dirList;
   pSarray  fileList;
   int      i1,nFiles,nDirectories;
   char    *subDirectory;
   char    *subDirectoryPath;
   char    *fileName;
   char    *filePath;

   fileList = utDirectoryListRegularFiles(currentDirectory,filePermission);
   nFiles = utGetCountSarray(fileList);
   for(i1=0 ; i1<nFiles ; i1++) {
      fileName = utGetCstringAtPositionInSarray(fileList,i1);
      filePath = utMakeFileName(currentDirectory,fileName,"");
      utAddToSarray(fileTree,filePath);
      utFreeBytes((pVoid)filePath);
   }
   utFreeSarray(&fileList);

   dirList = utDirectoryListDirectories(currentDirectory,filePermission);
   nDirectories = utGetCountSarray(dirList);
   for(i1=0 ; i1<nDirectories ; i1++) {
      subDirectory = utGetCstringAtPositionInSarray(dirList,i1);
      if((strcmp(subDirectory,".") != 0) &&
         (strcmp(subDirectory,"..") != 0)) {
         subDirectoryPath = utMakeSubDirectoryName(currentDirectory,
                                                   subDirectory);
         utAddToSarray(fileTree,subDirectoryPath);
         utGetFileTree(subDirectoryPath,fileTree,filePermission);
         utFreeBytes((pVoid)subDirectoryPath);
      }
   }
   utFreeSarray(&dirList);
   utFreeBytes((pVoid)currentDirectory);
}


#ifdef __STDC__
utLogical utRemoveFileTree(char *directory,
                           utFilePermission filePermission)
#else
utLogical utRemoveFileTree(directory,
                           filePermission)
char             *directory;
utFilePermission  filePermission;
#endif
{
   utLogical  fileTreeRemoved = utTrue;
   pSarray    fileTree = utCreateSarray();
   int        i1,nFiles;
   char      *filePathName;

   utAddToSarray(fileTree,directory);
   utGetFileTree(directory,
                 fileTree,
                 filePermission);
   nFiles = utGetCountSarray(fileTree);
   for(i1=nFiles-1 ; i1>=0 ; i1--) {
      filePathName = utGetCstringAtPositionInSarray(fileTree,i1);
      if(utIsFileTypeDirectory(filePathName)) {
         if(!utRemoveDirectory(filePathName))
            fileTreeRemoved = utFalse;
      } else {
         if(!utRemoveFile(filePathName))
            fileTreeRemoved = utFalse;
      }
   }
   utFreeSarray(&fileTree);

   return(fileTreeRemoved);
}


#ifdef __STDC__
utLogical utCopyAsciiFile(char *originalFile,
                          char *destinationFile)
#else
utLogical utCopyAsciiFile(originalFile,
                          destinationFile)
char *originalFile;
char *destinationFile;
#endif
{
   utLogical  fileCopied = utTrue;
   FILE      *fpOriginal;
   FILE      *fpDestination;
   int        fdOriginal;
   int        fdDestination;
   int        nRead;
   char       buf[FILEBUFFERSIZE+1];

   if((fpOriginal = utFileOpen(originalFile,FileOpenStatusRead)) != NULL) {
      fdOriginal = fileno(fpOriginal);
      if((fpDestination = utFileOpen(destinationFile,FileOpenStatusWrite)) != NULL) {
         fdDestination = fileno(fpDestination);
         while((nRead = read(fdOriginal,buf,FILEBUFFERSIZE)) > 0) {
            if(write(fdDestination,buf,nRead) != nRead) {
               perror(destinationFile);
               fileCopied = utFalse;
               break;
            }
         }
         utFileClose(fpDestination);
      } else
         fileCopied = utFalse;
      utFileClose(fpOriginal);
   } else
      fileCopied = utFalse;

   return(fileCopied);
}


#ifdef __STDC__
utLogical utConcatenateAsciiFile(char *originalFile,
                                 FILE *fpDestination)
#else
utLogical utConcatenateAsciiFile(originalFile,
                                 fpDestination)
char *originalFile;
FILE *fpDestination;
#endif
{
   utLogical  fileConcatenated = utTrue;
   FILE      *fpOriginal;
   int        fdOriginal;
   int        fdDestination;
   int        nRead;
   char       buf[FILEBUFFERSIZE+1];

   if((fpOriginal = utFileOpen(originalFile,FileOpenStatusRead)) != NULL) {
      fdOriginal = fileno(fpOriginal);
      fdDestination = fileno(fpDestination);
      while((nRead = read(fdOriginal,buf,FILEBUFFERSIZE)) > 0) {
/*       if(write(fdDestination,buf,nRead) != nRead) {
            perror(originalFile);
            fileConcatenated = utFalse;
            break;
         }
*/
         buf[nRead] = '\0';
         fprintf(fpDestination,"%s",buf);
      }
      utFileClose(fpOriginal);
   } else
      fileConcatenated = utFalse;

   return(fileConcatenated);
}


#ifdef __STDC__
char *utFileToString(char *fileName)
#else
char *utFileToString(fileName)
char *fileName;
#endif
{
   long  fileLength;
   char *fileString = NULL;
   FILE *fp;

   assert(fileName != NULL);

   if((fp = utFileOpen(fileName,FileOpenStatusRead)) != NULL) {
      fileLength = utGetFileSize(fileName);
      if(fileLength > 0) {
         fileString = (char *)utGetBytes(fileLength+1);
         if(fileString != NULL) {
            fread(fileString,sizeof(char),fileLength,fp);
            fileString[fileLength] = '\0';
         }
      }
      utFileClose(fp);
   }

   return(fileString);
}


#ifdef __STDC__
char *utGetCurrentWorkingDirectory()
#else
char *utGetCurrentWorkingDirectory()
#endif
{
   char  buf[MAX_PATH_LENGTH+1];
   char *currentWorkingDirectory;

   getcwd(buf,MAX_PATH_LENGTH);
   currentWorkingDirectory = utAssignString(buf);

   return(currentWorkingDirectory);
}


#ifdef __STDC__
utLogical utRenameFile(char *oldPathName,
                       char *newPathName)
#else
utLogical utRenameFile(oldPathName,
                       newPathName)
char *oldPathName;
char *newPathName;
#endif
{
   utLogical renameOK = utTrue;
   int       status;
#ifdef BPTVMS
   char      *oldDirectoryFileFormatName;
   char      *newDirectoryFileFormatName;
#endif

#ifdef BPTVMS
   if(utIsFileTypeDirectory(oldPathName)) {
      oldDirectoryFileFormatName = utGetDirectoryInFilenameFormat(oldPathName);
      newDirectoryFileFormatName = utGetDirectoryInFilenameFormat(newPathName);
      status = rename(oldDirectoryFileFormatName,newDirectoryFileFormatName);
      utFreeBytes((pVoid)oldDirectoryFileFormatName);
      utFreeBytes((pVoid)newDirectoryFileFormatName);
   } else {
      status = rename(oldPathName,newPathName);
   }
#else
   status = rename(oldPathName,newPathName);
#endif
   if(status != 0) {
      perror(oldPathName);
      renameOK = utFalse;
   }

   return(renameOK);
}


#ifdef __STDC__
utLogical utArchiveDirectoryTreeIntoFile(char *directory,
                                         utFilePermission filePermission,
                                         char *archivedFilePathName)
#else
utLogical utArchiveDirectoryTreeIntoFile(directory,
                                         filePermission,
                                         archivedFilePathName)
char             *directory;
utFilePermission  filePermission;
char             *archivedFilePathName;
#endif
{
/*
   utLogical  fileTreeArchived = utTrue;
   pSarray    fileTree = utCreateSarray();
   int        i1,nFiles;
   char      *filePathName;
   FILE      *fpArchivedFile;
   FILE      *fpOriginalFile;
   int        fdArchivedFile;
   int        fdOriginalFile;
   int        nRead,nReadTotal;
   char       buf[FILEBUFFERSIZE+1];
   long       fileSize;
   char      *fileHeaderString;
   char      *fileTypeDirectoryString = utIntToString((int)FileTypeDirectory);
   char      *fileTypeRegularString = utIntToString((int)FileTypeRegular);
   char      *fileSizeString;
   int        stringLength;
   char      *stringLengthString;
   char      *paddedString;
   char      *universalFilePath;
#ifdef BPTPC
   int        originalFmode = _fmode;
#endif

#ifdef BPTPC
   _fmode = _O_BINARY;
#endif
   if((fpArchivedFile = utFileOpen(archivedFilePathName,FileOpenStatusWrite)) != NULL) {
      fdArchivedFile = fileno(fpArchivedFile);
      utAddToSarray(fileTree,directory);
      utGetFileTree(directory,
                    fileTree,
                    filePermission);
      nFiles = utGetCountSarray(fileTree);
      for(i1=0 ; i1<nFiles ; i1++) {
         filePathName = utGetCstringAtPositionInSarray(fileTree,i1);
         if(!utIsFileAnExecutableFile(filePathName) &&
            !utIsFileAnObjectFile(filePathName) &&
            !utIsFileALibraryFile(filePathName)) {
            universalFilePath = utNativeToUniversalFilePath(filePathName);
            if(utIsFileTypeDirectory(filePathName)) {
               fileHeaderString = utCatCStringsWithDelimiter(ARCHIVEDFILEHEADERDELIMITER,
                                                             universalFilePath,
                                                             fileTypeDirectoryString,
                                                             "0",
                                                             "\n","");
               stringLength = utStringLength(fileHeaderString);
               stringLengthString = utIntToString(stringLength);
               paddedString = utPadStringToLength(stringLengthString,HEADBUFFERSIZE);
               if(write(fdArchivedFile,paddedString,HEADBUFFERSIZE) != HEADBUFFERSIZE) {
                  perror(archivedFilePathName);
                  fileTreeArchived = utFalse;
                  break;
               }
               if(write(fdArchivedFile,fileHeaderString,stringLength) != stringLength) {
                  perror(archivedFilePathName);
                  fileTreeArchived = utFalse;
                  break;
               }
               utFreeBytes((pVoid)paddedString);
               utFreeBytes((pVoid)stringLengthString);
               utFreeBytes((pVoid)fileHeaderString);
            } else {
               fileSize = utGetFileSize(filePathName);
               fileSizeString = utLongToString(fileSize);
               fileHeaderString = utCatCStringsWithDelimiter(ARCHIVEDFILEHEADERDELIMITER,
                                                             universalFilePath,
                                                             fileTypeRegularString,
                                                             fileSizeString,
                                                             "\n","");
               stringLength = utStringLength(fileHeaderString);
               stringLengthString = utIntToString(stringLength);
               paddedString = utPadStringToLength(stringLengthString,HEADBUFFERSIZE);
               if(write(fdArchivedFile,paddedString,HEADBUFFERSIZE) != HEADBUFFERSIZE) {
                  perror(archivedFilePathName);
                  fileTreeArchived = utFalse;
                  break;
               }
               if(write(fdArchivedFile,fileHeaderString,stringLength) != stringLength) {
                  perror(archivedFilePathName);
                  fileTreeArchived = utFalse;
                  break;
               }
               utFreeBytes((pVoid)paddedString);
               utFreeBytes((pVoid)stringLengthString);
               utFreeBytes((pVoid)fileHeaderString);
               utFreeBytes((pVoid)fileSizeString);
               if((fpOriginalFile = utFileOpen(filePathName,FileOpenStatusRead)) != NULL) {
                  fdOriginalFile = fileno(fpOriginalFile);
                  nReadTotal = 0;
                  while((nRead = read(fdOriginalFile,buf,FILEBUFFERSIZE)) > 0) {
                     nReadTotal += nRead;
                     if(write(fdArchivedFile,buf,nRead) != nRead) {
                        perror(archivedFilePathName);
                        fileTreeArchived = utFalse;
                        break;
                     }
                  }
                  if(nReadTotal != fileSize) {
                     utConsolePrint(" File size error: %s\n   %d   %d\n",filePathName,
                                                                         fileSize,
                                                                         nReadTotal);
                     nRead = fileSize-nReadTotal;
                     if(nRead > 0) {
                        paddedString = utPadStringToLength(NULL,nRead);
                        write(fdArchivedFile,paddedString,nRead);
                        utFreeBytes((pVoid)paddedString);
                     } else
                        fileTreeArchived = utFalse;
                  }
                  utFileClose(fpOriginalFile);
               } else
                  fileTreeArchived = utFalse;
            }
            utFreeBytes((pVoid)universalFilePath);
         }
         if(!fileTreeArchived)
            break;
      }
      utFreeSarray(&fileTree);
      utFileClose(fpArchivedFile);
   } else
      fileTreeArchived = utFalse;

   utFreeBytes((pVoid)fileTypeRegularString);
   utFreeBytes((pVoid)fileTypeDirectoryString);
#ifdef BPTPC
   _fmode = originalFmode;
#endif

   return(fileTreeArchived);
*/
}


#ifdef __STDC__
utLogical utRetrieveDirectoryTreeArchive(char *archivedFilePathName,
                                         char *directoryPath)
#else
utLogical utRetrieveDirectoryTreeArchive(archivedFilePathName,
                                         directoryPath)
char *archivedFilePathName;
char *directoryPath;
#endif
{
/*
   utLogical   fileTreeRetrieved = utTrue;
   char       *originalDirectoryPath = NULL;
   char       *destinationDirectoryPath = utAssignString(directoryPath);
   FILE       *fpArchivedFile;
   FILE       *fpDestinationFile;
   int         fdArchivedFile;
   int         fdDestinationFile;
   int         nRead;
   char        buf[FILEBUFFERSIZE+1];
   char       *fileSizeString;
   long        fileSize;
   char       *fileTypeString;
   utFileType  fileType;
   int         stringLength;
   char       *originalPathName;
   char       *newPathName;
   int         nReadTry,nRemaining;
   char       *universalFilePath;
   char       *locSemicolon;
#ifdef BPTVMS
   char       *locBracket;
#endif
#ifdef BPTPC
   int         originalFmode = _fmode;
#endif

#ifdef BPTPC
   _fmode = _O_BINARY;
#endif
#ifdef BPTVMS
   locBracket = strchr(destinationDirectoryPath,']');
   if(locBracket != NULL)
      *locBracket = '\0';
#endif
   if((fpArchivedFile = utFileOpen(archivedFilePathName,FileOpenStatusRead)) != NULL) {
      fdArchivedFile = fileno(fpArchivedFile);
      while(((nRead = read(fdArchivedFile,buf,HEADBUFFERSIZE)) == HEADBUFFERSIZE) && fileTreeRetrieved) {
         stringLength = utStringToInt(buf);
         if((nRead = read(fdArchivedFile,buf,stringLength)) != stringLength) {
            perror(archivedFilePathName);
            fileTreeRetrieved = utFalse;
            break;
         } else {
            universalFilePath = utGetDelimitedField(buf,ARCHIVEDFILEHEADERDELIMITER,1);
            fileTypeString    = utGetDelimitedField(buf,ARCHIVEDFILEHEADERDELIMITER,2);
            fileSizeString    = utGetDelimitedField(buf,ARCHIVEDFILEHEADERDELIMITER,3);
            originalPathName = utUniversalToNativeFilePath(universalFilePath);
            if(utIsNullString(originalDirectoryPath)) {
               originalDirectoryPath = utAssignString(originalPathName);
#ifdef BPTVMS
               locBracket = strchr(originalDirectoryPath,']');
               if(locBracket != NULL)
                  *locBracket = '\0';
#endif
            }
            newPathName = utSubstituteSubstringInString(originalPathName,
                                                        originalDirectoryPath,
                                                        destinationDirectoryPath);
#ifdef BPTVMS
            utSubstituteCharacterInString(newPathName,'/','.');
#endif
#ifdef BPTPC
            utSubstituteCharacterInString(newPathName,'/','\\');
#endif
#ifndef BPTVMS
            if(utStringContainsSubstring(newPathName,";")) {
               locSemicolon = strchr(newPathName,';');
               if(locSemicolon != NULL)
                  *locSemicolon = '\0';
            }
#endif
            fileType = (utFileType)utStringToInt(fileTypeString);
            fileSize = utStringToLong(fileSizeString);
            switch(fileType) {
               case FileTypeDirectory:
                  if(!utCreateSubDirectory(newPathName,"")) {
                     fileTreeRetrieved = utFalse;
                  }
                  break;
               case FileTypeRegular:
                  if((fpDestinationFile = utFileOpen(newPathName,FileOpenStatusWrite)) != NULL) {
                     fdDestinationFile = fileno(fpDestinationFile);
                     nRemaining = fileSize;
                     while(nRemaining > 0) {
                        nReadTry = MIN(nRemaining,FILEBUFFERSIZE);
                        nRead = read(fdArchivedFile,buf,nReadTry);
                        if(write(fdDestinationFile,buf,nRead) != nRead) {
                           perror(newPathName);
                           fileTreeRetrieved = utFalse;
                           break;
                        }
                        nRemaining -= nRead;
                     }
                     utFileClose(fpDestinationFile);
                  } else
                     fileTreeRetrieved = utFalse;
                  break;
            }

            utFreeBytes((pVoid)newPathName);
            utFreeBytes((pVoid)fileSizeString);
            utFreeBytes((pVoid)fileTypeString);
            utFreeBytes((pVoid)originalPathName);
            utFreeBytes((pVoid)universalFilePath);
         }
      }
      utFileClose(fpArchivedFile);
   } else
      fileTreeRetrieved = utFalse;

   utFreeBytes((pVoid)originalDirectoryPath);
   utFreeBytes((pVoid)destinationDirectoryPath);
#ifdef BPTPC
   _fmode = originalFmode;
#endif

   return(fileTreeRetrieved);
*/
}


#ifdef __STDC__
FILE *utFileOpen(char *filePathName,
                 utFileOpenStatus fileOpenStatus)
#else
FILE *utFileOpen(filePathName,
                 fileOpenStatus)
char             *filePathName;
utFileOpenStatus  fileOpenStatus;
#endif
{
   FILE *fp = NULL;

   switch(fileOpenStatus) {
      case FileOpenStatusRead:
         fp = fopen(filePathName,"rb");
         break;
      case FileOpenStatusWrite:
         fp = fopen(filePathName,"wb");
         break;
      case FileOpenStatusReadWrite:
         fp = fopen(filePathName,"wb+");
         break;
      case FileOpenStatusAppend:
         fp = fopen(filePathName,"ab");
         break;
   }
#ifdef DEBUGFileOpen
   if(fp == NULL)
      perror(filePathName);
#endif

   return(fp);
}


#ifdef __STDC__
utLogical utFileClose(FILE *fp)
#else
utLogical utFileClose(fp)
FILE *fp;
#endif
{
   utLogical fileClosed = utTrue;
   int       status;

   if(fp != NULL) {
      status = fclose(fp);
      if(status != 0) {
         fileClosed = utFalse;
         perror("");
      }
   }

   return(fileClosed);
}


#ifdef BPTUNIX
#ifdef __STDC__
char *utNativeToUniversalFilePath(char *filePath)
#else
char *utNativeToUniversalFilePath(filePath)
char *filePath;
#endif
{
   char *universalPathName = NULL;
   char *directoryName = NULL;
   char *baseName = NULL;
   char *extension = NULL;
   char *drive = utAssignString(" ");

   if(utIsFileTypeDirectory(filePath)) {
      universalPathName = utCatCStringsWithDelimiter(UNIVERSALPATHDELIMITER,
                                                     drive,
                                                     filePath,
                                                     " ",
                                                     " ",
                                                     "");
   } else {
      directoryName = utGetDirectoryFromFile(filePath);
      baseName = utGetBaseFromFile(filePath);
      extension = utAssignString(utGetExtensionFromFile(filePath));
      if(utIsNullString(extension)) {
         utFreeBytes((pVoid)extension);
         extension = utAssignString(" ");
      }
      universalPathName = utCatCStringsWithDelimiter(UNIVERSALPATHDELIMITER,
                                                     drive,
                                                     directoryName,
                                                     baseName,
                                                     extension,
                                                     "");
      utFreeBytes((pVoid)extension);
      utFreeBytes((pVoid)baseName);
      utFreeBytes((pVoid)directoryName);
   }
   utFreeBytes((pVoid)drive);

   return(universalPathName);
}


#ifdef __STDC__
char *utUniversalToNativeFilePath(char *filePath)
#else
char *utUniversalToNativeFilePath(filePath)
char *filePath;
#endif
{
   char *nativePathName = NULL;
   char *field;
   char *directoryName;
   char *baseName;
   char *extension;
   char *drive;

   field = utGetDelimitedField(filePath,UNIVERSALPATHDELIMITER,1);
   if(utHasAllBlanks(field)) {
      drive = utAssignString("");
   } else {
      drive = utCatStringPlusString(field,"",":");
   }
   utFreeBytes((pVoid)field);

   directoryName = utGetDelimitedField(filePath,UNIVERSALPATHDELIMITER,2);

   field = utGetDelimitedField(filePath,UNIVERSALPATHDELIMITER,3);
   if(utHasAllBlanks(field)) {
      baseName = utAssignString("");
   } else {
      baseName = utCatStringPlusString("/","",field);
   }
   utFreeBytes((pVoid)field);

   field = utGetDelimitedField(filePath,UNIVERSALPATHDELIMITER,4);
   if(utHasAllBlanks(field)) {
      extension = utAssignString("");
   } else {
      extension = utCatStringPlusString(".","",field);
   }
   utFreeBytes((pVoid)field);

   nativePathName = utCatCStringsWithDelimiter("",
                                               drive,
                                               directoryName,
                                               baseName,
                                               extension,
                                               "");

   utFreeBytes((pVoid)extension);
   utFreeBytes((pVoid)baseName);
   utFreeBytes((pVoid)directoryName);
   utFreeBytes((pVoid)drive);

   return(nativePathName);
}
#endif

#ifdef BPTVMS
#ifdef __STDC__
char *utNativeToUniversalFilePath(char *filePath)
#else
char *utNativeToUniversalFilePath(filePath)
char *filePath;
#endif
{
   char *universalPathName = NULL;
   char *driveDirectory;
   char *directoryName = NULL;
   char *baseName = NULL;
   char *extension = NULL;
   char *drive = NULL;

   driveDirectory = utGetDirectoryFromFile(filePath);
   if(utStringContainsSubstring(driveDirectory,":")) {
      drive = utGetDelimitedField(driveDirectory,":",1);
      directoryName = utGetDelimitedField(driveDirectory,":",2);
   } else {
      drive = utAssignString(" ");
      directoryName = driveDirectory;
      driveDirectory = NULL;
   }
   utFreeBytes((pVoid)driveDirectory);

   utSubstituteCharacterInString(directoryName,'[',' ');
   utSubstituteCharacterInString(directoryName,'.','/');
   utSubstituteCharacterInString(directoryName,']',' ');
   utStripBlanks(directoryName);

   if(utIsFileTypeDirectory(filePath)) {
      universalPathName = utCatCStringsWithDelimiter(UNIVERSALPATHDELIMITER,
                                                     drive,
                                                     directoryName,
                                                     " ",
                                                     " ",
                                                     "");
   } else {
      baseName = utGetBaseFromFile(filePath);
      extension = utAssignString(utGetExtensionFromFile(filePath));
      if(utIsNullString(extension)) {
         utFreeBytes((pVoid)extension);
         extension = utAssignString(" ");
      }
      universalPathName = utCatCStringsWithDelimiter(UNIVERSALPATHDELIMITER,
                                                     drive,
                                                     directoryName,
                                                     baseName,
                                                     extension,
                                                     "");
      utFreeBytes((pVoid)extension);
      utFreeBytes((pVoid)baseName);
   }
   utFreeBytes((pVoid)directoryName);
   utFreeBytes((pVoid)drive);

   return(universalPathName);
}


#ifdef __STDC__
char *utUniversalToNativeFilePath(char *filePath)
#else
char *utUniversalToNativeFilePath(filePath)
char *filePath;
#endif
{
   char *nativePathName = NULL;
   char *field;
   char *universalDirectoryName;
   char *nativeDirectoryName;
   char *baseName;
   char *extension;
   char *drive;

   field = utGetDelimitedField(filePath,UNIVERSALPATHDELIMITER,1);
   if(utHasAllBlanks(field)) {
      drive = utAssignString("");
   } else {
      drive = utCatStringPlusString(field,"",":");
   }
   utFreeBytes((pVoid)field);

   universalDirectoryName = utGetDelimitedField(filePath,UNIVERSALPATHDELIMITER,2);
   nativeDirectoryName = utCatCStringsWithDelimiter("",
                                                    "[",
                                                    universalDirectoryName,
                                                    "]",
                                                    "","");
   utFreeBytes((pVoid)universalDirectoryName);
   utSubstituteCharacterInString(nativeDirectoryName,'/','.');

   field = utGetDelimitedField(filePath,UNIVERSALPATHDELIMITER,3);
   if(utHasAllBlanks(field)) {
      baseName = utAssignString("");
   } else {
      baseName = utAssignString(field);
   }
   utFreeBytes((pVoid)field);

   field = utGetDelimitedField(filePath,UNIVERSALPATHDELIMITER,4);
   if(utHasAllBlanks(field)) {
      extension = utAssignString("");
   } else {
      extension = utCatStringPlusString(".","",field);
   }
   utFreeBytes((pVoid)field);

   nativePathName = utCatCStringsWithDelimiter("",
                                               drive,
                                               nativeDirectoryName,
                                               baseName,
                                               extension,
                                               "");

   utFreeBytes((pVoid)extension);
   utFreeBytes((pVoid)baseName);
   utFreeBytes((pVoid)nativeDirectoryName);
   utFreeBytes((pVoid)drive);

   return(nativePathName);
}
#endif

#ifdef BPTPC
#ifdef __STDC__
char *utNativeToUniversalFilePath(char *filePath)
#else
char *utNativeToUniversalFilePath(filePath)
char *filePath;
#endif
{
   char *universalPathName = NULL;
   char *directoryName = NULL;
   char *baseName = NULL;
   char *extension = NULL;
   char *drive = NULL;
   char *driveDirectory;

   if(utStringContainsSubstring(filePath,":")) {
      drive = utGetDelimitedField(filePath,":",1);
      driveDirectory = utGetDelimitedField(filePath,":",2);
   } else {
      drive = utAssignString(" ");
      driveDirectory = utAssignString(filePath);
   }
   if(utIsFileTypeDirectory(filePath)) {
      directoryName = driveDirectory;
      driveDirectory = NULL;
   } else
      directoryName = utGetDirectoryFromFile(driveDirectory);
   utFreeBytes((pVoid)driveDirectory);

   utSubstituteCharacterInString(directoryName,'\\','/');
   utStripBlanks(directoryName);

   if(utIsFileTypeDirectory(filePath)) {
      universalPathName = utCatCStringsWithDelimiter(UNIVERSALPATHDELIMITER,
                                                     drive,
                                                     directoryName,
                                                     " ",
                                                     " ",
                                                     "");
   } else {
      baseName = utGetBaseFromFile(filePath);
      extension = utAssignString(utGetExtensionFromFile(filePath));
      if(utIsNullString(extension)) {
         utFreeBytes((pVoid)extension);
         extension = utAssignString(" ");
      }
      universalPathName = utCatCStringsWithDelimiter(UNIVERSALPATHDELIMITER,
                                                     drive,
                                                     directoryName,
                                                     baseName,
                                                     extension,
                                                     "");
      utFreeBytes((pVoid)extension);
      utFreeBytes((pVoid)baseName);
   }
   utFreeBytes((pVoid)directoryName);
   utFreeBytes((pVoid)drive);

   return(universalPathName);
}


#ifdef __STDC__
char *utUniversalToNativeFilePath(char *filePath)
#else
char *utUniversalToNativeFilePath(filePath)
char *filePath;
#endif
{
   char *nativePathName = NULL;
   char *field;
   char *nativeDirectoryName;
   char *baseName;
   char *extension;
   char *drive;

   field = utGetDelimitedField(filePath,UNIVERSALPATHDELIMITER,1);
   if(utHasAllBlanks(field)) {
      drive = utAssignString("");
   } else {
      drive = utCatStringPlusString(field,"",":");
   }
   utFreeBytes((pVoid)field);

   nativeDirectoryName = utGetDelimitedField(filePath,UNIVERSALPATHDELIMITER,2);
   utSubstituteCharacterInString(nativeDirectoryName,'/','\\');

   field = utGetDelimitedField(filePath,UNIVERSALPATHDELIMITER,3);
   if(utHasAllBlanks(field)) {
      baseName = utAssignString("");
   } else {
      baseName = utCatStringPlusString("\\","",field);
   }
   utFreeBytes((pVoid)field);

   field = utGetDelimitedField(filePath,UNIVERSALPATHDELIMITER,4);
   if(utHasAllBlanks(field)) {
      extension = utAssignString("");
   } else {
      extension = utCatStringPlusString(".","",field);
   }
   utFreeBytes((pVoid)field);

   nativePathName = utCatCStringsWithDelimiter("",
                                               drive,
                                               nativeDirectoryName,
                                               baseName,
                                               extension,
                                               "");

   utFreeBytes((pVoid)extension);
   utFreeBytes((pVoid)baseName);
   utFreeBytes((pVoid)nativeDirectoryName);
   utFreeBytes((pVoid)drive);

   return(nativePathName);
}
#endif


#ifdef __STDC__
void utSaveUniversalFilePath(char *universalFilePath,
                             FILE *fp)
#else
void utSaveUniversalFilePath(universalFilePath,
                             fp)
char *universalFilePath;
FILE *fp;
#endif
{
   utWritelnFortranString(fp,universalFilePath);
}


#ifdef __STDC__
char *utLoadUniversalFilePath(FILE *fp)
#else
char *utLoadUniversalFilePath(fp)
FILE *fp;
#endif
{
   char *universalFilePath;
   char  buf[MAX_STRING_LENGTH+1];
   char *testDrive;

   utReadFortranString(fp,buf,MAX_STRING_LENGTH);
   testDrive = utExtractString(buf,0,0);
   if(utEqualStrings(testDrive,UNIVERSALPATHDELIMITER))
      universalFilePath = utCatStringPlusString(" ","",buf);
   else
      universalFilePath = utAssignString(buf);
   utFreeBytes((pVoid)testDrive);

   return(universalFilePath);
}


#ifdef __STDC__
utLogical utCopyDirectoryTree(char *originalDirectory,
                              utFilePermission filePermission,
                              char *destinationDirectory)
#else
utLogical utCopyDirectoryTree(originalDirectory,
                              filePermission,
                              destinationDirectory)
char             *originalDirectory;
utFilePermission  filePermission;
char             *destinationDirectory;
#endif
{
   utLogical  fileTreeCopied = utTrue;
   pSarray    fileTree = utCreateSarray();
   int        i1,nFiles;
   char      *originalFilePathName;
   char      *destinationFilePathName;
   char      *originalString    = utAssignString(originalDirectory);
   char      *replacementString = utAssignString(destinationDirectory);
#ifdef BPTVMS
   char      *locBracket;
#endif

#ifdef BPTVMS
   locBracket = strchr(originalString,']');
   if(locBracket != NULL)
      *locBracket = '\0';
   locBracket = strchr(replacementString,']');
   if(locBracket != NULL)
      *locBracket = '\0';
#endif
   utAddToSarray(fileTree,originalDirectory);
   utGetFileTree(originalDirectory,
                 fileTree,
                 filePermission);
   nFiles = utGetCountSarray(fileTree);
   for(i1=0 ; i1<nFiles ; i1++) {
      originalFilePathName = utGetCstringAtPositionInSarray(fileTree,i1);
      destinationFilePathName = utSubstituteSubstringInString(originalFilePathName,
                                                              originalString,
                                                              replacementString);
      if(utIsFileTypeDirectory(originalFilePathName)) {
         if(!utCreateSubDirectory(destinationFilePathName,""))
            fileTreeCopied = utFalse;
      } else {
         if(!utCopyAsciiFile(originalFilePathName,destinationFilePathName))
            fileTreeCopied = utFalse;
      }
      utFreeBytes((pVoid)destinationFilePathName);
      if(!fileTreeCopied)
         break;
   }
   utFreeBytes((pVoid)replacementString);
   utFreeBytes((pVoid)originalString);
   utFreeSarray(&fileTree);

   return(fileTreeCopied);
}


#ifdef BPTUNIX
#ifdef __STDC__
char *utGetUniqueFileName(char *directory,
                          char *fileNamePrefix)
#else
char *utGetUniqueFileName(directory,
                          fileNamePrefix)
char *directory;
char *fileNamePrefix;
#endif
{
   char *uniqueFileName = NULL;
   char *tempFileName = tempnam(directory,fileNamePrefix);

   if(!utIsNullString(tempFileName)) {
      uniqueFileName = utAssignString(tempFileName);
      free(tempFileName);
   }

   return(uniqueFileName);
}
#endif

#ifdef BPTVMS
#ifdef __STDC__
char *utGetUniqueFileName(char *directory,
                          char *fileNamePrefix)
#else
char *utGetUniqueFileName(directory,
                          fileNamePrefix)
char *directory;
char *fileNamePrefix;
#endif
{
   char *uniqueFileName = NULL;
   char *template = utAssignString("XXXXXX");

   mktemp(template);
   uniqueFileName = utMakeFileName(directory,fileNamePrefix,template);
   utFreeBytes((pVoid)template);

   return(uniqueFileName);
}
#endif

#ifdef BPTPC
#ifdef __STDC__
char *utGetUniqueFileName(char *directory,
                          char *fileNamePrefix)
#else
char *utGetUniqueFileName(directory,
                          fileNamePrefix)
char *directory;
char *fileNamePrefix;
#endif
{
   char *uniqueFileName = NULL;
   char *tempFileName = _tempnam(directory,fileNamePrefix);

   if(!utIsNullString(tempFileName)) {
      uniqueFileName = utAssignString(tempFileName);
      free(tempFileName);
   }

   return(uniqueFileName);
}
#endif


#ifdef __STDC__
utLogical utIsFileAnExecutableFile(char *filePathName)
#else
utLogical utIsFileAnExecutableFile(filePathName)
char *filePathName;
#endif
{
   utLogical  isFileAnExecutable;
   char      *fileExtension = utGetExtensionFromFile(filePathName);

   isFileAnExecutable = utDoesStringMatchPattern(fileExtension,
                                                 EXECUTABLEFILEEXTENSION,utFalse);

   return(isFileAnExecutable);
}


#ifdef __STDC__
utLogical utIsFileAnObjectFile(char *filePathName)
#else
utLogical utIsFileAnObjectFile(filePathName)
char *filePathName;
#endif
{
   utLogical  isFileAnExecutable;
   char      *fileExtension = utGetExtensionFromFile(filePathName);

   isFileAnExecutable = utDoesStringMatchPattern(fileExtension,
                                                 OBJECTFILEEXTENSION,utFalse);

   return(isFileAnExecutable);
}


#ifdef __STDC__
utLogical utIsFileALibraryFile(char *filePathName)
#else
utLogical utIsFileALibraryFile(filePathName)
char *filePathName;
#endif
{
   utLogical  isFileAnExecutable;
   char      *fileExtension = utGetExtensionFromFile(filePathName);

   isFileAnExecutable = utDoesStringMatchPattern(fileExtension,
                                                 LIBRARYFILEEXTENSION,utFalse);

   return(isFileAnExecutable);
}


#ifdef __STDC__
pFilePosition utCreateFilePosition()
#else
pFilePosition utCreateFilePosition()
#endif
{
   pFilePosition filePosition = (pFilePosition)utGetBytes(sizeof(FilePosition));

   return(filePosition);
}


#ifdef __STDC__
void utFreeFilePosition(pFilePosition *filePosition)
#else
void utFreeFilePosition(filePosition)
pFilePosition *filePosition;
#endif
{
   if(*filePosition == NULL)
      return;

   utFreeBytes((pVoid)*filePosition);
   *filePosition = NULL;
}


#ifdef __STDC__
pFilePosition utAssignFilePosition(pFilePosition filePosition)
#else
pFilePosition utAssignFilePosition(filePosition)
pFilePosition filePosition;
#endif
{
   pFilePosition newFilePosition = utCreateFilePosition();

   memcpy(newFilePosition,filePosition,sizeof(FilePosition));
   
   return(newFilePosition);
}


#ifdef __STDC__
pFilePosition utGetFilePosition(FILE *fp)
#else
pFilePosition utGetFilePosition(fp)
FILE *fp;
#endif
{
   pFilePosition filePosition = utCreateFilePosition();

   if(fgetpos(fp,filePosition) != 0)
      utFreeFilePosition(&filePosition);

   return(filePosition);
}


#ifdef __STDC__
utLogical utRecordFilePosition(FILE *fp,
                               pFilePosition filePosition)
#else
utLogical utRecordFilePosition(fp,
                               filePosition)
FILE          *fp;
pFilePosition  filePosition;
#endif
{
   utLogical filePositionRecorded = utTrue;

   if(fgetpos(fp,filePosition) != 0)
      filePositionRecorded = utFalse;

   return(filePositionRecorded);
}


#ifdef __STDC__
utLogical utSetFilePosition(FILE *fp,
                            pFilePosition filePosition)
#else
utLogical utSetFilePosition(fp,
                            filePosition)
FILE          *fp;
pFilePosition  filePosition;
#endif
{
   utLogical filePositionSet = utTrue;

   if(fsetpos(fp,filePosition) != 0)
      filePositionSet = utFalse;

   return(filePositionSet);
}


