/*
   $RCSfile: utiarryu.h,v $       $Revision: 1.5 $
   $State: V7_1 $                  $Date: 2004/11/03 16:18:11 $
*/
#ifndef _UTIARRYU_H
#define _UTIARRYU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <stdio.h>

#include "uttypesu.h"

#define STRUCTTYPE_IARRAY 1006

typedef struct {
   int  StructType;
   int  nValues;
   int  nMaxSize;
   int *values;
} Iarray, *pIarray;

#ifdef __STDC__
   extern pIarray utCreateIarray();
   extern void utInitializeIarray(pIarray iarray);
   extern pIarray utCreateIarrayOfSize(int nMaxSize);
   extern pIarray utAssignIarray(pIarray iarray);
   extern void utAddToIarray(pIarray iarray,
                             int value);
   extern void utInsertInIarray(pIarray iarray,
                                int ith,
                                int value);
   extern void utDeleteFromIarray(pIarray iarray,
                                  int ith);
   extern void utRemoveFromIarray(pIarray iarray,
                                  int value);
   extern void utEmptyIarray(pIarray iarray);
   extern void utFreeIarray(pIarray *iarray);
   extern int utCompareInts(pConstVoid d1,
                            pConstVoid d2);
   extern void utSortIarray(pIarray iarray);
   extern utLogical utEqualIarrays(pIarray iarray1,
                                   pIarray iarray2);
   extern void utDumpIarray(FILE *fp,
                            pIarray iarray);
   extern pIarray utCreateIarrayFromArray(int nCount,
                                          int **array);
   extern int utGetCountIarray(pIarray iarray);
   extern int utGetIntAtPositionInIarray(pIarray iarray,
                                         int position);
   extern pIarray utGetUniqueIarray(pIarray iarray);
   extern void utMergeIarrays(pIarray iarray1,
                              pIarray iarray2);
   extern utLogical utIntIsInIarray(int iValue,
                                    pIarray iarray);
   extern int utIntPositionInIarray(int iValue,
                                    pIarray iarray);
   extern int utGetNumberOfRepeatsInIarray(pIarray iarray,
                                           int value);
   extern void utSaveIarray(pIarray iarray,
                            FILE *fp);
   extern pIarray utLoadIarray(FILE *fp);
   extern void utSetIntAtPositionInIarray(pIarray iarray,
                                          int position,
                                          int value);
   extern pIarray utLocateCharacterInString(char *string,
                                            char searchCharacter);
#else
   extern pIarray utCreateIarray();
   extern void utInitializeIarray();
   extern pIarray utCreateIarrayOfSize();
   extern pIarray utAssignIarray();
   extern void utAddToIarray();
   extern void utInsertInIarray();
   extern void utDeleteFromIarray();
   extern void utRemoveFromIarray();
   extern void utEmptyIarray();
   extern void utFreeIarray();
   extern int utCompareInts();
   extern void utSortIarray();
   extern utLogical utEqualIarrays();
   extern void utDumpIarray();
   extern pIarray utCreateIarrayFromArray();
   extern int utGetCountIarray();
   extern int utGetIntAtPositionInIarray();
   extern pIarray utGetUniqueIarray();
   extern void utMergeIarrays();
   extern utLogical utIntIsInIarray();
   extern int utIntPositionInIarray();
   extern int utGetNumberOfRepeatsInIarray();
   extern void utSaveIarray();
   extern pIarray utLoadIarray();
   extern void utSetIntAtPositionInIarray();
   extern pIarray utLocateCharacterInString();
#endif

#ifdef __cplusplus
   }
#endif

#endif
