/*
   $RCSfile: utlarryu.h,v $       $Revision: 1.4 $
   $State: V7_1 $                  $Date: 2004/11/03 16:18:12 $
*/
#ifndef _UTLARRYU_H
#define _UTLARRYU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <stdio.h>

#include "uttypesu.h"

#define STRUCTTYPE_LARRAY 1008

typedef struct {
   int   StructType;
   int   nValues;
   int   nMaxSize;
   long *values;
} Larray, *pLarray; 

#ifdef __STDC__
   extern pLarray utCreateLarray();
   extern void utInitializeLarray(pLarray larray);
   extern pLarray utCreateLarrayOfSize(int nMaxSize);
   extern pLarray utAssignLarray(pLarray larray);
   extern void utAddToLarray(pLarray larray,
                             long value);
   extern void utInsertInLarray(pLarray larray,
                                int ith,
                                long value);
   extern void utDeleteFromLarray(pLarray larray,
                                  int ith);
   extern void utRemoveFromLarray(pLarray larray,
                                  long value);
   extern void utEmptyLarray(pLarray larray);
   extern void utFreeLarray(pLarray *larray);
   extern int utCompareLongs(pConstVoid d1,
                             pConstVoid d2);
   extern void utSortLarray(pLarray larray);
   extern int utLongPositionInLarray(long value,pLarray larray);
   extern void utDumpLarray(FILE *fp,
                            pLarray larray);
   extern pLarray utCreateLarrayFromArray(int nCount,
                                          long **array);
   extern int utGetCountLarray(pLarray larray);
   extern long utGetLongAtPositionInLarray(pLarray larray,
                                           int position);
   extern void utSetLongAtPositionInLarray(pLarray larray,
                                           int i,
                                           long value);
   extern pLarray utGetUniqueLarray(pLarray larray);
   extern void utSaveLarray(pLarray larray,
                            FILE *fp);
   extern pLarray utLoadLarray(FILE *fp);
#else
   extern pLarray utCreateLarray();
   extern void utInitializeLarray();
   extern pLarray utCreateLarrayOfSize();
   extern pLarray utAssignLarray();
   extern void utAddToLarray();
   extern void utInsertInLarray();
   extern void utDeleteFromLarray();
   extern void utRemoveFromLarray();
   extern void utEmptyLarray();
   extern void utFreeLarray();
   extern int utCompareLongs();
   extern void utSortLarray();
   extern int utLongPositionInLarray();
   extern void utDumpLarray();
   extern pLarray utCreateLarrayFromArray();
   extern int utGetCountLarray();
   extern long utGetLongAtPositionInLarray();
   extern void utSetLongAtPositionInLarray();
   extern pLarray utGetUniqueLarray();
   extern void utSaveLarray();
   extern pLarray utLoadLarray();
#endif

#ifdef __cplusplus
   }
#endif

#endif
