/*
   $RCSfile: utlicenu.h,v $       $Revision: 1.7 $
   $State: Exp $                  $Date: 2002/07/12 17:24:32 $
*/
#ifndef _UTLICENU_H
#define _UTLICENU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include "uttypesu.h"

#ifdef BPTUNIX
#define BASICDATASUBDIRECTORY         "Basic"
#define STANDARDDATASUBDIRECTORY      "Standard"
#define ADVANCEDDATASUBDIRECTORY      "Advanced"
#endif
#ifdef BPTVMS
#define BASICDATASUBDIRECTORY         "BASIC"
#define STANDARDDATASUBDIRECTORY      "STANDARD"
#define ADVANCEDDATASUBDIRECTORY      "ADVANCED"
#endif
#ifdef BPTPC
#define BASICDATASUBDIRECTORY         "Basic"
#define STANDARDDATASUBDIRECTORY      "Standard"
#define ADVANCEDDATASUBDIRECTORY      "Advanced"
#endif

typedef enum {
   FunctionalityLicenseUnknown              = 0,
   FunctionalityLicenseBasic                = 1,
   FunctionalityLicenseStandard             = 2,
   FunctionalityLicenseAdvanced             = 3,
   FunctionalityLicenseShuttlenet           = 4,
   FunctionalityLicenseAcademic             = 5,
   FunctionalityLicenseReactor              = 6,
   FunctionalityLicenseDistillation         = 7,
   FunctionalityLicenseReactiveDistillation = 8
} utFunctionalityLicense;

typedef enum {
   ExecutionLicenseUnknown = 0,
   ExecutionLicenseDemo    = 1,
   ExecutionLicenseRunTime = 2,
   ExecutionLicenseFull    = 3
} utExecutionLicense;

typedef enum {
   PropertyPackageLicenseUnknown    = 0,
   PropertyPackageLicenseBPTUniquac = 1,
   PropertyPackageLicensePPDS       = 2,
   PropertyPackageLicenseSEAPkg     = 3
} utPropertyPackageLicense;

#ifdef __STDC__
   extern char *utGetSerialNumber();
   extern utLogical utIsValidLicenseFile();
   extern utLogical utCheckOutInterfaceLicense();
   extern utLogical utIsLicenseAlive();
   extern utLogical utIsLicenseExpired();
   extern utLogical utCheckInInterfaceLicense();
   extern utLogical utIsDemoVersion();
   extern utLogical utIsRunTimeVersion();
   extern utLogical utIsFullVersion();
   extern utExecutionLicense utGetExecutionLicenseType();
   extern utLogical utIsBasic();
   extern utLogical utIsStandard();
   extern utLogical utIsAdvanced();
   extern utLogical utIsShuttlenet();
   extern utLogical utIsAcademic();
   extern utLogical utIsReactor();
   extern utLogical utIsDistillation();
   extern utLogical utIsReactiveDistillation();
   extern utFunctionalityLicense utGetFunctionalityLicenseType();
   extern utLogical utIsBPTUniquac();
   extern utLogical utIsPPDS();
   extern utLogical utIsSEAPkg();
   extern utPropertyPackageLicense utGetPropertyPackageLicenseType();
   extern utLogical utIsAnimationFeatureAllowed();
   extern char *utGetBAT_DATALicenseDirectory();
   extern utLogical utCheckOutBHIRoom2License();
   extern utLogical utCheckInBHIRoom2License();
#else
   extern char *utGetSerialNumber();
   extern utLogical utIsValidLicenseFile();
   extern utLogical utCheckOutInterfaceLicense();
   extern utLogical utIsLicenseAlive();
   extern utLogical utIsLicenseExpired();
   extern utLogical utCheckInInterfaceLicense();
   extern utLogical utIsDemoVersion();
   extern utLogical utIsRunTimeVersion();
   extern utLogical utIsFullVersion();
   extern utExecutionLicense utGetExecutionLicenseType();
   extern utLogical utIsBasic();
   extern utLogical utIsStandard();
   extern utLogical utIsAdvanced();
   extern utLogical utIsShuttlenet();
   extern utLogical utIsAcademic();
   extern utLogical utIsReactor();
   extern utLogical utIsDistillation();
   extern utLogical utIsReactiveDistillation();
   extern utFunctionalityLicense utGetFunctionalityLicenseType();
   extern utLogical utIsBPTUniquac();
   extern utLogical utIsPPDS();
   extern utLogical utIsSEAPkg();
   extern utPropertyPackageLicense utGetPropertyPackageLicenseType();
   extern utLogical utIsAnimationFeatureAllowed();
   extern char *utGetBAT_DATALicenseDirectory();
   extern utLogical utCheckOutBHIRoom2License();
   extern utLogical utCheckInBHIRoom2License();
#endif

#ifdef __cplusplus
   }
#endif

#endif
