/*
  $RCSfile: utlistiu.h,v $       $Revision: 1.2 $
  $State: V6_2 $                  $Date: 1999/06/15 16:38:30 $
*/
#ifndef _UTLISTIU_H
#define _UTLISTIU_H

#ifdef __cplusplus
extern "C" {
#endif

#define STRUCTTYPE_CNODE_I    1009
#define STRUCTTYPE_CPLEX_I    1010
#define STRUCTTYPE_LISTOFINTS 1011

typedef struct _CNode_I {
   int              StructType;
   struct _CNode_I *pNext;
   struct _CNode_I *pPrev;
   int              data;
} CNode_I;

typedef struct _CPlex_I {
   int              StructType;
   struct _CPlex_I *pNext;
} CPlex_I;
 
typedef struct {
   int      StructType;
   int      m_nCount;
   CNode_I *m_pNodeHead;
   CNode_I *m_pNodeTail;
   CNode_I *m_pNodeFree;
   CPlex_I *m_pBlocks;
   int      m_nBlockSize;
} ListOfInts, *pListOfInts;

#ifndef DEFAULT_BLOCK_SIZE
#define DEFAULT_BLOCK_SIZE 20
#endif

#ifdef __STDC__
   extern pListOfInts utCreateListOfInts(int nBlockSize);
   extern void utDestroyListOfInts(pListOfInts list);
   extern int utGetCountListOfInts(pListOfInts list);
   extern pVoid utGetHeadPosListOfInts(pListOfInts list);
   extern pVoid utGetTailPosListOfInts(pListOfInts list);
   extern pVoid utGetPrevPosListOfInts(pVoid pos);
   extern pVoid utGetNextPosListOfInts(pVoid pos);
   extern void utRemoveAtListOfInts(pListOfInts list, 
                                    pVoid position);
   extern int utGetHeadListOfInts(pListOfInts list);
   extern int utGetTailListOfInts(pListOfInts list);
   extern int utGetNextListOfInts(pVoid* pos);
   extern int utGetPrevListOfInts(pVoid* pos);
   extern int utGetDataListOfInts(pVoid pos);
   extern pVoid utAddHeadListOfInts(pListOfInts list, 
                                    int newElement);
   extern pVoid utAddTailListOfInts(pListOfInts list,
                                    int newElement);
   extern void utAddListToHeadListOfInts(pListOfInts list, 
                                         pListOfInts pNewList);
   extern void utAddListToTailListOfInts(pListOfInts list, 
                                         pListOfInts pNewList);
   extern void utRemoveHeadListOfInts(pListOfInts list);
   extern void utRemoveTailListOfInts(pListOfInts list);
   extern pVoid utInsertBeforeListOfInts(pListOfInts list, 
                                         pVoid position, int newElement);
   extern pVoid utInsertAfterListOfInts(pListOfInts list, 
                                        pVoid position, int newElement);
   extern pVoid utGetAtListOfInts(pListOfInts list, int nIndex);
   extern pVoid utFindItemListOfInts(pListOfInts list, 
                                     pVoid startAfter, int searchValue);
#else
   extern pListOfInts utCreateListOfInts();
   extern void utDestroyListOfInts();
   extern int utGetCountListOfInts();
   extern pVoid utGetHeadPosListOfInts();
   extern pVoid utGetTailPosListOfInts();
   extern pVoid utGetPrevPosListOfInts();
   extern pVoid utGetNextPosListOfInts();
   extern void utRemoveAtListOfInts();
   extern int utGetHeadListOfInts();
   extern int utGetTailListOfInts();
   extern int utGetNextListOfInts();
   extern int utGetPrevListOfInts();
   extern int utGetDataListOfInts();
   extern pVoid utAddHeadListOfInts();
   extern pVoid utAddTailListOfInts();
   extern void utAddListToHeadListOfInts();
   extern void utAddListToTailListOfInts();
   extern void utRemoveHeadListOfInts();
   extern void utRemoveTailListOfInts();
   extern pVoid utInsertBeforeListOfInts();
   extern pVoid utInsertAfterListOfInts();
   extern pVoid utGetAtListOfInts();
   extern pVoid utFindItemListOfInts();
#endif

#ifdef __cplusplus
  }
#endif

#endif
