/*
  $RCSfile: utlistlu.h,v $       $Revision: 1.2 $
  $State: V6_2 $                  $Date: 1999/06/15 16:38:34 $
*/
#ifndef _UTLISTLU_H
#define _UTLISTLU_H

#ifdef __cplusplus
extern "C" {
#endif

#define STRUCTTYPE_CNODE_L     1012
#define STRUCTTYPE_CPLEX_L     1013
#define STRUCTTYPE_LISTOFLONGS 1014

typedef struct _CNode_L {
   int              StructType;
   struct _CNode_L *pNext;
   struct _CNode_L *pPrev;
   long             data;
} CNode_L;

typedef struct _CPlex_L {
   int              StructType;
   struct _CPlex_L *pNext;
} CPlex_L;
 
typedef struct {
   int      StructType;
   int      m_nCount;
   CNode_L *m_pNodeHead;
   CNode_L *m_pNodeTail;
   CNode_L *m_pNodeFree;
   CPlex_L *m_pBlocks;
   int      m_nBlockSize;
} ListOfLongs, *pListOfLongs;

#ifndef DEFAULT_BLOCK_SIZE
#define DEFAULT_BLOCK_SIZE 20
#endif

#ifdef __STDC__
   extern pListOfLongs utCreateListOfLongs(int nBlockSize);
   extern void utDestroyListOfLongs(pListOfLongs list);
   extern int utGetCountListOfLongs(pListOfLongs list);
   extern pVoid utGetHeadPosListOfLongs(pListOfLongs list);
   extern pVoid utGetTailPosListOfLongs(pListOfLongs list);
   extern pVoid utGetPrevPosListOfLongs(pVoid pos);
   extern pVoid utGetNextPosListOfLongs(pVoid pos);
   extern void utRemoveAtListOfLongs(pListOfLongs list, 
                                     pVoid position);
   extern long utGetHeadListOfLongs(pListOfLongs list);
   extern long utGetTailListOfLongs(pListOfLongs list);
   extern long utGetNextListOfLongs(pVoid* pos);
   extern long utGetPrevListOfLongs(pVoid* pos);
   extern long utGetDataListOfLongs(pVoid pos);
   extern pVoid utAddHeadListOfLongs(pListOfLongs list, 
                                     long newElement);
   extern pVoid utAddTailListOfLongs(pListOfLongs list,
                                     long newElement);
   extern void utAddListToHeadListOfLongs(pListOfLongs list, 
                                          pListOfLongs pNewList);
   extern void utAddListToTailListOfLongs(pListOfLongs list, 
                                          pListOfLongs pNewList);
   extern void utRemoveHeadListOfLongs(pListOfLongs list);
   extern void utRemoveTailListOfLongs(pListOfLongs list);
   extern pVoid utInsertBeforeListOfLongs(pListOfLongs list, 
                                          pVoid position, long newElement);
   extern pVoid utInsertAfterListOfLongs(pListOfLongs list, 
                                         pVoid position, long newElement);
   extern pVoid utGetAtListOfLongs(pListOfLongs list, int nIndex);
   extern pVoid utFindItemListOfLongs(pListOfLongs list, 
                                      pVoid startAfter, long searchValue);
#else
   extern pListOfLongs utCreateListOfLongs();
   extern void utDestroyListOfLongs();
   extern int utGetCountListOfLongs();
   extern pVoid utGetHeadPosListOfLongs();
   extern pVoid utGetTailPosListOfLongs();
   extern pVoid utGetPrevPosListOfLongs();
   extern pVoid utGetNextPosListOfLongs();
   extern void utRemoveAtListOfLongs();
   extern long utGetHeadListOfLongs();
   extern long utGetTailListOfLongs();
   extern long utGetNextListOfLongs();
   extern long utGetPrevListOfLongs();
   extern long utGetDataListOfLongs();
   extern pVoid utAddHeadListOfLongs();
   extern pVoid utAddTailListOfLongs();
   extern void utAddListToHeadListOfLongs();
   extern void utAddListToTailListOfLongs();
   extern void utRemoveHeadListOfLongs();
   extern void utRemoveTailListOfLongs();
   extern pVoid utInsertBeforeListOfLongs();
   extern pVoid utInsertAfterListOfLongs();
   extern pVoid utGetAtListOfLongs();
   extern pVoid utFindItemListOfLongs();
#endif

#ifdef __cplusplus
  }
#endif

#endif
