/*
  $RCSfile: utlistpu.h,v $       $Revision: 1.2 $
  $State: V6_2 $                  $Date: 1999/06/15 16:38:38 $
*/
#ifndef _UTLISTPU_H
#define _UTLISTPU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include "uttypesu.h"

#define STRUCTTYPE_CNODE_P    1015
#define STRUCTTYPE_CPLEX_P    1016
#define STRUCTTYPE_LISTOFPTRS 1017

typedef struct _CNode_P {
   int              StructType;
   struct _CNode_P *pNext;
   struct _CNode_P *pPrev;
   pVoid            data;
} CNode_P;

typedef struct _CPlex_P {
   int              StructType;
   struct _CPlex_P *pNext;
} CPlex_P;
 
typedef struct {
   int      StructType;
   int      m_nCount;
   CNode_P *m_pNodeHead;
   CNode_P *m_pNodeTail;
   CNode_P *m_pNodeFree;
   CPlex_P *m_pBlocks;
   int      m_nBlockSize;
} ListOfPtrs, *pListOfPtrs;

#ifndef DEFAULT_BLOCK_SIZE
#define DEFAULT_BLOCK_SIZE 20
#endif

#ifdef __STDC__
   extern pListOfPtrs utCreateListOfPtrs(int nBlockSize);
   extern void utDestroyListOfPtrs(pListOfPtrs list);
   extern int utGetCountListOfPtrs(pListOfPtrs list);
   extern pVoid utGetHeadPosListOfPtrs(pListOfPtrs list);
   extern pVoid utGetTailPosListOfPtrs(pListOfPtrs list);
   extern pVoid utGetPrevPosListOfPtrs(pVoid pos);
   extern pVoid utGetNextPosListOfPtrs(pVoid pos);
   extern void utRemoveAtListOfPtrs(pListOfPtrs list, 
                                    pVoid position);
   extern pVoid utGetHeadListOfPtrs(pListOfPtrs list);
   extern pVoid utGetTailListOfPtrs(pListOfPtrs list);
   extern pVoid utGetNextListOfPtrs(pVoid* pos);
   extern pVoid utGetPrevListOfPtrs(pVoid* pos);
   extern pVoid utGetDataListOfPtrs(pVoid pos);
   extern pVoid utAddHeadListOfPtrs(pListOfPtrs list, 
                                    pVoid newElement);
   extern pVoid utAddTailListOfPtrs(pListOfPtrs list,
                                    pVoid newElement);
   extern void utAddListToHeadListOfPtrs(pListOfPtrs list, 
                                         pListOfPtrs pNewList);
   extern void utAddListToTailListOfPtrs(pListOfPtrs list, 
                                         pListOfPtrs pNewList);
   extern void utRemoveHeadListOfPtrs(pListOfPtrs list);
   extern void utRemoveTailListOfPtrs(pListOfPtrs list);
   extern pVoid utInsertBeforeListOfPtrs(pListOfPtrs list, 
                                         pVoid position,
                                         pVoid newElement);
   extern pVoid utInsertAfterListOfPtrs(pListOfPtrs list, 
                                        pVoid position,
                                        pVoid newElement);
   extern pVoid utGetAtListOfPtrs(pListOfPtrs list, int nIndex);
   extern pVoid utFindItemListOfPtrs(pListOfPtrs list, 
                                     pVoid startAfter,
                                     pVoid searchValue);
   extern utLogical utRemoveItemListOfPtrs(pListOfPtrs list,
                                           pVoid item);
   extern pVoid utGetPtrAtPositionInListOfPtrs(pListOfPtrs list,
                                               int nIndex);
#else
   extern pListOfPtrs utCreateListOfPtrs();
   extern void utDestroyListOfPtrs();
   extern int utGetCountListOfPtrs();
   extern pVoid utGetHeadPosListOfPtrs();
   extern pVoid utGetTailPosListOfPtrs();
   extern pVoid utGetPrevPosListOfPtrs();
   extern pVoid utGetNextPosListOfPtrs();
   extern void utRemoveAtListOfPtrs();
   extern pVoid utGetHeadListOfPtrs();
   extern pVoid utGetTailListOfPtrs();
   extern pVoid utGetNextListOfPtrs();
   extern pVoid utGetPrevListOfPtrs();
   extern pVoid utGetDataListOfPtrs();
   extern pVoid utAddHeadListOfPtrs();
   extern pVoid utAddTailListOfPtrs();
   extern void utAddListToHeadListOfPtrs();
   extern void utAddListToTailListOfPtrs();
   extern void utRemoveHeadListOfPtrs();
   extern void utRemoveTailListOfPtrs();
   extern pVoid utInsertBeforeListOfPtrs();
   extern pVoid utInsertAfterListOfPtrs();
   extern pVoid utGetAtListOfPtrs();
   extern pVoid utFindItemListOfPtrs();
   extern utLogical utRemoveItemListOfPtrs();
   extern pVoid utGetPtrAtPositionInListOfPtrs();
#endif

#ifdef __cplusplus
   }
#endif

#endif
