/*
  $RCSfile: utlistsu.h,v $       $Revision: 1.2 $
  $State: V6_2 $                  $Date: 1999/06/15 16:38:42 $
*/
#ifndef _UTLISTSU_H
#define _UTLISTSU_H

#ifdef __cplusplus
extern "C" {
#endif

#define STRUCTTYPE_CNODE_S    1018
#define STRUCTTYPE_CPLEX_S    1019
#define STRUCTTYPE_LISTOFSTRS 1020

typedef struct _CNode_S {
   int              StructType;
   struct _CNode_S *pNext;
   struct _CNode_S *pPrev;
   char            *data;
} CNode_S;

typedef struct _CPlex_S {
   int              StructType;
   struct _CPlex_S *pNext;
} CPlex_S;
 
typedef struct {
   int      StructType;
   int      m_nCount;
   CNode_S *m_pNodeHead;
   CNode_S *m_pNodeTail;
   CNode_S *m_pNodeFree;
   CPlex_S *m_pBlocks;
   int      m_nBlockSize;
} ListOfStrs, *pListOfStrs;

#ifndef DEFAULT_BLOCK_SIZE
#define DEFAULT_BLOCK_SIZE 20
#endif

#ifdef __STDC__
   extern pListOfStrs utCreateListOfStrs(int nBlockSize);
   extern void utDestroyListOfStrs(pListOfStrs list);
   extern int utGetCountListOfStrs(pListOfStrs list);
   extern pVoid utGetHeadPosListOfStrs(pListOfStrs list);
   extern pVoid utGetTailPosListOfStrs(pListOfStrs list);
   extern pVoid utGetPrevPosListOfStrs(pVoid pos);
   extern pVoid utGetNextPosListOfStrs(pVoid pos);
   extern void utRemoveAtListOfStrs(pListOfStrs list, 
                                    pVoid position);
   extern char* utGetHeadListOfStrs(pListOfStrs list);
   extern char* utGetTailListOfStrs(pListOfStrs list);
   extern char* utGetNextListOfStrs(pVoid* pos);
   extern char* utGetPrevListOfStrs(pVoid* pos);
   extern char* utGetDataListOfStrs(pVoid pos);
   extern pVoid utAddHeadListOfStrs(pListOfStrs list, 
                                    char* newElement);
   extern pVoid utAddTailListOfStrs(pListOfStrs list,
                                    char* newElement);
   extern void utAddListToHeadListOfStrs(pListOfStrs list, 
                                         pListOfStrs pNewList);
   extern void utAddListToTailListOfStrs(pListOfStrs list, 
                                         pListOfStrs pNewList);
   extern void utRemoveHeadListOfStrs(pListOfStrs list);
   extern void utRemoveTailListOfStrs(pListOfStrs list);
   extern pVoid utInsertBeforeListOfStrs(pListOfStrs list, 
                                         pVoid position, char* newElement);
   extern pVoid utInsertAfterListOfStrs(pListOfStrs list, 
                                        pVoid position, char* newElement);
   extern pVoid utGetAtListOfStrs(pListOfStrs list, int nIndex);
   extern pVoid utFindItemListOfStrs(pListOfStrs list, 
                                     pVoid startAfter, char* searchValue);
#else
   extern pListOfStrs utCreateListOfStrs();
   extern void utDestroyListOfStrs();
   extern int utGetCountListOfStrs();
   extern pVoid utGetHeadPosListOfStrs();
   extern pVoid utGetTailPosListOfStrs();
   extern pVoid utGetPrevPosListOfStrs();
   extern pVoid utGetNextPosListOfStrs();
   extern void utRemoveAtListOfStrs();
   extern char* utGetHeadListOfStrs();
   extern char* utGetTailListOfStrs();
   extern char* utGetNextListOfStrs();
   extern char* utGetPrevListOfStrs();
   extern char* utGetDataListOfStrs();
   extern pVoid utAddHeadListOfStrs();
   extern pVoid utAddTailListOfStrs();
   extern void utAddListToHeadListOfStrs();
   extern void utAddListToTailListOfStrs();
   extern void utRemoveHeadListOfStrs();
   extern void utRemoveTailListOfStrs();
   extern pVoid utInsertBeforeListOfStrs();
   extern pVoid utInsertAfterListOfStrs();
   extern pVoid utGetAtListOfStrs();
   extern pVoid utFindItemListOfStrs();
#endif

#ifdef __cplusplus
  }
#endif

#endif
