/*
  $RCSfile: utmapspu.h,v $       $Revision: 1.2 $
  $State: V6_2 $                  $Date: 1999/06/15 16:39:07 $
*/
#ifndef _UTMAPSPU_H
#define _UTMAPSPU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include "uttypesu.h"

#define STRUCTTYPE_CASSOC_SP   1036
#define STRUCTTYPE_CPLEX_SP    1037
#define STRUCTTYPE_MAPSTRTOPTR 1038

typedef struct _CAssoc_SP {
   int                StructType;
   struct _CAssoc_SP *pNext;
   char              *key;
   pVoid              value;
} CAssoc_SP;

typedef struct _CPlex_SP {
   int               StructType;
   struct _CPlex_SP *pNext;
} CPlex_SP;

typedef struct {
   int         StructType;
   CAssoc_SP **Map;
   int         MapSize;
   int         Count;
   CAssoc_SP  *FreeList;
   CPlex_SP   *Blocks;
   int         BlockSize;
} MapStrToPtr, *pMapStrToPtr;

/******************
 * public interface 
 ******************/

#ifndef DEFAULT_NHASHBUCKET
#define DEFAULT_NHASHBUCKET     10
#endif
#ifndef DEFAULT_HASHBUCKETSIZE
#define DEFAULT_HASHBUCKETSIZE  20
#endif

#ifdef __STDC__
   extern pMapStrToPtr utCreateMapStrToPtr(int nSize, int nBlockSize);
   extern void utSetMapStrToPtr(pMapStrToPtr map,
                                char* key, pVoid value);
   extern utLogical utRemoveKeyFromMapStrToPtr(pMapStrToPtr map,
                                               char* key);
   extern void utDestroyMapStrToPtr(pMapStrToPtr map);
   extern utLogical utLookupMapStrToPtr(pMapStrToPtr map,
                                        char* key, pVoid* rValue);
#else
   extern pMapStrToPtr utCreateMapStrToPtr();
   extern void utSetMapStrToPtr();
   extern utLogical utLookupMapStrToPtr();
   extern void utDestroyMapStrToPtr();
   extern utLogical utRemoveKeyFromMapStrToPtr();
#endif

#ifdef __cplusplus
   }
#endif

#endif
