/*
  $RCSfile: utmemryu.c,v $       $Revision: 1.9 $
  $State: V7_1 $                  $Date: 2004/11/05 11:24:19 $
*/
#include <ctype.h>

#include "utmacrou.h"
#include "uttypesu.h"
#include "utmemryu.h"
#include "utlistpu.h"
#include "utstrngu.h"
#include "utprntfu.h"

static utLogical   utmemryMemoryTrackingOn = utFalse;
static pListOfPtrs utmemryMemoryStackList = NULL;
static utLogical   utmemryMemoryStackFirstTime = utTrue;
static utLogical   utmemryMemoryStackTrack = utFalse;
static long        utmemryMemoryStackSize = 0;
static long        utmemryMemoryStackMaximumSize = 0;
static long        utmemryMemoryStackReportedSize = 0;
static long        utmemryTotalBytesAllocated = 0;

#define            utmemryMemoryStackGrowBySize  99

#ifdef __STDC__
pVoid utGetBytes(size_t nSize)
#else
pVoid utGetBytes(nSize)
size_t nSize;
#endif
{
   pVoid memoryBlock = (pVoid)NULL;
/* pVoid node; */

   assert(nSize >= 0);

   if(nSize == 0)
      return(memoryBlock);

   memoryBlock = (pVoid)calloc(1,nSize);
   assert(memoryBlock != NULL);

   if(utmemryMemoryTrackingOn) {
/*
      utmemryTotalBytesAllocated += nSize;
      if(utmemryMemoryStackFirstTime) {
         utmemryMemoryStackFirstTime = utFalse;
         utmemryMemoryStackTrack = utFalse;
         utmemryMemoryStackList = utCreateListOfPtrs(utmemryMemoryStackGrowBySize+1);
         utmemryMemoryStackTrack = utTrue;
      }
      if(utmemryMemoryStackTrack) {
         utmemryMemoryStackSize++;
         utmemryMemoryStackMaximumSize = MAX(utmemryMemoryStackMaximumSize,utmemryMemoryStackSize);
         if(utmemryMemoryStackSize > (utmemryMemoryStackReportedSize+utmemryMemoryStackGrowBySize)) {
            utmemryMemoryStackReportedSize = utmemryMemoryStackSize;
         }
         utmemryMemoryStackTrack = utFalse;
         utAddHeadListOfPtrs(utmemryMemoryStackList,memoryBlock);
         utmemryMemoryStackTrack = utTrue;
      }
*/
   }

   return(memoryBlock);
}


#ifdef __STDC__
void utFreeBytes(pVoid memoryBlock)
#else
void utFreeBytes(memoryBlock)
pVoid memoryBlock;
#endif
{
   pVoid node;

   if(memoryBlock == (pVoid)NULL)
      return;

   if(utmemryMemoryTrackingOn) {
      if(utmemryMemoryStackTrack) {
/*
         node = utFindItemListOfPtrs(utmemryMemoryStackList,
                                     NULL,memoryBlock);
         assert(node != NULL);
         utmemryMemoryStackSize--;
         if(utmemryMemoryStackSize < (utmemryMemoryStackReportedSize-utmemryMemoryStackGrowBySize)) {
            utmemryMemoryStackReportedSize = utmemryMemoryStackSize;
         }
         utmemryMemoryStackTrack = utFalse;
         utRemoveAtListOfPtrs(utmemryMemoryStackList,node);
         utmemryMemoryStackTrack = utTrue;
*/
      }
   }

   free(memoryBlock);
}


#ifdef __STDC__
void utSetMemoryTrackingOn()
#else
void utSetMemoryTrackingOn()
#endif
{
   utmemryMemoryTrackingOn = utTrue;
}


#ifdef __STDC__
void utSetMemoryTrackingOff()
#else
void utSetMemoryTrackingOff()
#endif
{
   utmemryMemoryTrackingOn = utFalse;
}


#ifdef __STDC__
void utReportAllocatedBlocks(char *label)
#else
void utReportAllocatedBlocks(label)
char *label;
#endif
{
   if(utmemryMemoryTrackingOn) {
      utConsolePrint(" %s: %ld of Maximum %ld\n",label,
                                                 utmemryMemoryStackSize,
                                                 utmemryMemoryStackMaximumSize);
      utConsolePrint(" %s: %ld Total Bytes Allocated\n",label,
                                                        utmemryTotalBytesAllocated);
   }
}


#ifdef __STDC__
void utReportAllocatedBlockPointers(char *label)
#else
void utReportAllocatedBlockPointers(label)
char *label;
#endif
{
   int             i1,nBlocks;
   pVoid           pointer;
   char           *cString;
   int             c;
   int            *integer;
   double         *doubleValue;
   pGenericStruct  genericStruct; 

   if(utmemryMemoryTrackingOn) {
      if(utmemryMemoryStackList != NULL) {
/*
         nBlocks = utGetCountListOfPtrs(utmemryMemoryStackList);
         if(nBlocks > 0) {
            utConsolePrint(" %s\n",label);
            for(i1=0 ; i1<nBlocks ; i1++) {
               pointer = utGetPtrAtPositionInListOfPtrs(utmemryMemoryStackList,i1);
               cString = (char *)pointer;
               c = cString[0];
               if(isprint(c))
                  utConsolePrint(" %x  %s\n",pointer, cString);
               else {
                  integer = (int *)pointer;
                  doubleValue = (double *)pointer;
                  genericStruct = (pGenericStruct)pointer;
                  utConsolePrint(" %x  :%c:%d:%g:StructType = %d\n",pointer,
                                                    c,
                                                    *integer,
                                                    *doubleValue,
                                                    genericStruct->StructType);
               }
            }
         }
*/
      }
   }
}


#ifdef __STDC__
#ifdef BPTVMS
void utCommandLineMemoryArguments(int *argc,
                                  char **argv)
#else
void utCommandLineMemoryArguments(unsigned int *argc,
                                  char **argv)
#endif
#else
#ifdef BPTVMS
void utCommandLineMemoryArguments(argc,
                                  argv)
int   *argc;
char **argv;
#else
void utCommandLineMemoryArguments(argc,
                                  argv)
unsigned int  *argc;
char         **argv;
#endif
#endif
{
   char *commandLineArgument;
   int   nArguments = *argc;
   int   i1,i2;

   for(i1=1 ; i1<nArguments ; i1++) {
      commandLineArgument = argv[i1];
      if(utEqualStrings(commandLineArgument,"-memcheck")) {
         utSetMemoryTrackingOn();
         argv[i1] = NULL;
         for(i2=i1 ; i2<nArguments-1 ; i2++)
            argv[i2] = argv[i2+1];
         nArguments--;
         break;
      }
   }
   *argc = nArguments;
}


