/*
  $RCSfile: utsarryu.h,v $       $Revision: 1.10 $
  $State: V7_1 $                  $Date: 2004/12/14 12:50:41 $
*/
#ifndef _UTSARRYU_H
#define _UTSARRYU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <stdio.h>
#include <string.h>

#include "uttypesu.h"

#define STRUCTTYPE_SARRAY 1046

typedef struct {
   int    StructType;
   int    nStrings;
   int    nMaxSize;
   char **strings;
} Sarray, *pSarray; 

#ifdef __STDC__
   extern pSarray utCreateSarray();
   extern void utInitializeSarray(pSarray sarray);
   extern pSarray utCreateSarrayOfSize(int nMaxSize);
   extern pSarray utAssignSarray(pSarray sarray);
   extern void utAddToSarray(pSarray sarray,
                             char *cstring);
   extern void utInsertInSarray(pSarray sarray,
                                int ith,
                                char *cstring);
   extern void utDeleteFromSarray(pSarray sarray,
                                  int ith);
   extern void utRemoveFromSarray(pSarray sarray,
                                  char *value);
   extern void utEmptySarray(pSarray sarray);
   extern void utFreeSarray(pSarray *sarray);
   extern void utSortSarray(pSarray sarray);
   extern utLogical utStringIsInSarray(char *cstring,
                                       pSarray sarray);
   extern int utStringPositionInSarray(char *cString,
                                       pSarray sarray);
   extern pSarray utGetUniqueSarray(pSarray sarray);
   extern int utCompareStrings(pConstVoid s1,
                               pConstVoid s2);
   extern int utGetCountSarray(pSarray sarray);
   extern pSarray utCreateSarrayFromCstringArray(int nCount,
                                                 char ***cStringArray);
   extern char *utGetCstringAtPositionInSarray(pSarray sarray,
                                               int position);
   extern void utSetCstringAtPositionInSarray(pSarray sarray,
                                              int position,
                                              char *cString);
   extern void utMergeSarrays(pSarray sarray1,
                              pSarray sarray2);
   extern void utSubtractSarrayFromSarray(pSarray sarray1,
                                          pSarray sarray2);
   extern pSarray utIntersectSarrays(pSarray sarray1,
                                     pSarray sarray2);
   extern int utGetLongestStringSizeInSarray(pSarray sarray);
   extern pSarray utAdjoinSarrays(pSarray sarray1,
                                  int widthSarray1,
                                  pSarray sarray2,
                                  int widthSarray2,
                                  pSarray sarray3,
                                  int widthSarray3,
                                  pSarray sarray4,
                                  int widthSarray4,
                                  pSarray sarray5,
                                  int widthSarray5);
   extern void utCleaveSarrays(pSarray sarray,
                               pSarray *sarray1,
                               int widthSarray1,
                               pSarray *sarray2,
                               int widthSarray2,
                               pSarray *sarray3,
                               int widthSarray3,
                               pSarray *sarray4,
                               int widthSarray4,
                               pSarray *sarray5,
                               int widthSarray5);
   extern utLogical utEqualSarrays(pSarray sarray1,
                                   pSarray sarray2);
   extern char *utCreateSingleStringFromSarray(pSarray sarray,
                                               char *delimiter);
   extern pSarray utCreateSarrayFromSingleString(char *string,
                                                 char *delimiter);
   extern void utDumpSarray(pSarray sarray,
                            FILE *fp);
   extern void utSaveSarray(pSarray sarray,
                            FILE *fp);
   extern pSarray utLoadSarray(FILE *fp);
   extern void utApendStringAtPositionInSarray(pSarray sarray,
                                               int position,
                                               char *cString,
                                               char *delimiter);
   extern pSarray utMatchStringsInSarray(pSarray sarray,
                                         char *patternString);
   extern pSarray utGetUniqueMatchedList(pSarray list,
                                         pSarray choiceList,
                                         utLogical sortList);
   extern void utWriteFormattedSarray(pSarray sarray,
                                      int firstLineInitialOffset,
                                      int initialOffset,
                                      int stringWidth,
                                      int stringsPerLine,
                                      FILE *fp);
   extern void utWriteSarrayToTXTFile(pSarray sarray,
                                      int stringsPerLine,
                                      int increment,
                                      FILE *fp);
#else
   extern pSarray utCreateSarray();
   extern void utInitializeSarray();
   extern pSarray utCreateSarrayOfSize();
   extern pSarray utAssignSarray();
   extern void utAddToSarray();
   extern void utInsertInSarray();
   extern void utDeleteFromSarray();
   extern void utRemoveFromSarray();
   extern void utEmptySarray();
   extern void utFreeSarray();
   extern void utSortSarray();
   extern utLogical utStringIsInSarray();
   extern int utStringPositionInSarray();
   extern pSarray utGetUniqueSarray();
   extern int utCompareStrings();
   extern int utGetCountSarray();
   extern pSarray utCreateSarrayFromCstringArray();
   extern char *utGetCstringAtPositionInSarray();
   extern void utSetCstringAtPositionInSarray();
   extern void utMergeSarrays();
   extern void utSubtractSarrayFromSarray();
   extern pSarray utIntersectSarrays();
   extern int utGetLongestStringSizeInSarray();
   extern pSarray utAdjoinSarrays();
   extern void utCleaveSarrays();
   extern utLogical utEqualSarrays();
   extern char *utCreateSingleStringFromSarray();
   extern pSarray utCreateSarrayFromSingleString();
   extern void utDumpSarray();
   extern void utSaveSarray();
   extern pSarray utLoadSarray();
   extern void utApendStringAtPositionInSarray();
   extern pSarray utMatchStringsInSarray();
   extern pSarray utGetUniqueMatchedList();
   extern void utWriteFormattedSarray();
   extern void utWriteSarrayToTXTFile();
#endif

#ifdef __cplusplus
   }
#endif

#endif
