/*
  $RCSfile: utstckpu.c,v $       $Revision: 1.2 $
  $State: V7_1 $                  $Date: 2004/11/03 16:18:22 $
*/
#include "uttypesu.h"
#include "utlistpu.h"
#include "utstckpu.h"
#include "utmemryu.h"

#ifdef __STDC__
pStackOfPtrs utCreateStackOfPtrs()
#else
pStackOfPtrs utCreateStackOfPtrs()
#endif
{
   pStackOfPtrs stack;

   stack = (pStackOfPtrs)utGetBytes(sizeof(StackOfPtrs));
   stack->StructType = STRUCTTYPE_STACKOFPTRS;
   stack->m_pList    = utCreateListOfPtrs(DEFAULT_BLOCK_SIZE);

   return(stack);
}


#ifdef __STDC__
void utDestroyStackOfPtrs(pStackOfPtrs stack)
#else
void utDestroyStackOfPtrs(stack)
pStackOfPtrs stack;
#endif
{
   assert(stack->m_pList != NULL);

   utDestroyListOfPtrs(stack->m_pList);
   utFreeBytes((pVoid)stack);
}


#ifdef __STDC__
void utPushStackOfPtrs(pStackOfPtrs stack,
                       pVoid newElement)
#else
void utPushStackOfPtrs(stack,
                       newElement)
pStackOfPtrs stack;
pVoid        newElement;
#endif
{
   utAddHeadListOfPtrs(stack->m_pList,newElement);
}


#ifdef __STDC__
pVoid utPopStackOfPtrs(pStackOfPtrs stack)
#else
pVoid utPopStackOfPtrs(stack)
pStackOfPtrs stack;
#endif
{
   pVoid pElement;

   assert(utSizeOfStackOfPtrs(stack) != 0);

   pElement = utGetHeadListOfPtrs(stack->m_pList);
   utRemoveHeadListOfPtrs(stack->m_pList);

   return(pElement);
}


#ifdef __STDC__
void utEmptyStackOfPtrs(pStackOfPtrs stack)
#else
void utEmptyStackOfPtrs(stack)
pStackOfPtrs stack;
#endif
{
   while(utGetCountListOfPtrs(stack->m_pList) > 0)
      utRemoveHeadListOfPtrs(stack->m_pList);
}


#ifdef __STDC__
pVoid utShowNextStackOfPtrs(pStackOfPtrs stack)
#else
pVoid utShowNextStackOfPtrs(stack)
pStackOfPtrs stack;
#endif
{
   assert(utSizeOfStackOfPtrs(stack) != 0);

   return(utGetHeadListOfPtrs(stack->m_pList));
}


#ifdef __STDC__
int utSizeOfStackOfPtrs(pStackOfPtrs stack)
#else
int utSizeOfStackOfPtrs(stack)
pStackOfPtrs stack;
#endif
{
   assert(stack != NULL);

   return(utGetCountListOfPtrs(stack->m_pList));
}


#ifdef __STDC__
int utIsEmptyStackOfPtrs(pStackOfPtrs stack)
#else
int utIsEmptyStackOfPtrs(stack)
pStackOfPtrs stack;
#endif
{
   assert(stack != NULL);

   return(utGetCountListOfPtrs(stack->m_pList) == 0);
}


