/*
   $RCSfile: utstriou.h,v $       $Revision: 1.6 $
   $State: Exp $                  $Date: 2002/09/04 18:16:44 $
*/
#ifndef _UTSTRIOU_H
#define _UTSTRIOU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <stdio.h>

#include "uttypesu.h"

typedef enum {
   ReadTerminateCharacterUnknown,
   ReadTerminateCharacterEOF,
   ReadTerminateCharacterEOL,
   ReadTerminateCharacterTab
} utReadTerminateCharacter;

#ifdef BPTUNIX
#define EOLSTRING "\n"
#endif
#ifdef BPTVMS
#define EOLSTRING "\r\n"
#endif
#ifdef BPTPC
#define EOLSTRING "\r\n"
#endif

#ifdef __STDC__
   extern utLogical utReadLine(FILE *fp,
                               char *buf,
                               int bufSize);
   extern char *utReadUnlimitedLine(FILE *fp);
   extern void utReadFortranString(FILE *fp,
                                   char *string,
                                   int maximumLength);
	extern void utWriteCSVFieldString(FILE *fp, char *buf);
   extern void utWriteFortranString(FILE *fp, char *buf);
   extern void utWritelnFortranString(FILE *fp, char *buf);
   extern utLogical utIsNextFieldFortranString(FILE *fp);
   extern void utPeekAtFortranString(FILE *fp,
                                     char *string,
                                     int maximumLength);
   extern utReadTerminateCharacter utReadUntilChar(FILE *fp,
                                                   char *string,
                                                   int limit);
   extern int utSkipLines(FILE *fp,
                          int nLines);
   extern utLogical utSkipLinesUntil(FILE *fp,
                                     char *string);
   extern utLogical utIsSequentialEOF(FILE *fp);
#else
   extern utLogical utReadLine();
   extern char *utReadUnlimitedLine();
   extern void utReadFortranString();
	extern void utWriteCSVFieldString();
   extern void utWriteFortranString();
   extern void utWritelnFortranString();
   extern utLogical utIsNextFieldFortranString();
   extern void utPeekAtFortranString();
   extern utReadTerminateCharacter utReadUntilChar();
   extern int utSkipLines();
   extern utLogical utSkipLinesUntil();
   extern utLogical utIsSequentialEOF();
#endif

#ifdef __cplusplus
   }
#endif

#endif
