/*
   $RCSfile: utstrngu.h,v $       $Revision: 1.12 $
   $State: V7_1 $                  $Date: 2005/01/06 18:07:11 $
*/
#ifndef _UTSTRNGU_H
#define _UTSTRNGU_H

#ifdef __cplusplus
   extern "C" {
#endif

#include <string.h>

#include "uttypesu.h"

#ifdef __STDC__
   extern int utStringLength(char *string);
   extern utLogical utEqualStrings(char *s1,
                                   char *s2);
   extern utLogical utIsNullString(char *s);
   extern utLogical utHasAllBlanks(char *s);
   extern char *utAssignString(char *buf);
   extern void utClearString(char *s);
   extern void utCatToString(char *s1,
                             char *s2,
                             int nSpace);
   extern char *utCatStringPlusString(char *s1,
                                      char *delimiter,
                                      char *s2);
   extern char *utCatCStringsWithDelimiter(char *delimiter,
                                           char *s1,char *s2,
                                           char *s3,char *s4,char *s5);
   extern void utGetNextColumn(char *parseString,
                               int nLength,
                               char *buf);
   extern void utStripTrailingBlanks(char *buf);
   extern void utStripLeadingBlanks(char *s);
   extern void utStripBlanks(char *s);
   extern char *utCreateNullString();
   extern void utMakeAllBlanks(char *s,
                               int size);
   extern void utMakeAllCharacter(char *s,
                                  int size,
                                  char character);
   extern char *utSearchString(char *string,
                               char *searchFor,
                               int position,
                               utCaseType caseType,
                               utSearchType searchType);
   extern char *utReverseSearchString(char *string,
                                      char *searchFor,
                                      int position,
                                      utCaseType caseType);
   extern char *utForwardSearchString(char *string,
                                      char *searchFor,
                                      int position,
                                      utCaseType caseType);
   extern int utUpper(char c);
   extern int utLower(char c);
   extern int utStrCmpNoCase(char *s,
                             char *t);
   extern int utStrNCmpNoCase(char *s,
                              char *t,
                              int compareLength);
   extern void utStringToUpper(char *s);
   extern void utStringToLower(char *s);
   extern void utFreeCstringArray(char **cstringarray,
                                  int nStrings);
   extern void utCopyColumnFromCstring(char *cstring,
                                       char *column,
                                       int iColumn,
                                       int *columnSizes);
   extern void utAddColumnToCstring(char *cstring,
                                    char *column,
                                    int iColumn,
                                    int *columnSizes);
   extern utLogical utDoesStringMatchPattern(char *string,
                                             char *pattern,
                                             utLogical ignoreCase);
   extern char *utGetDelimitedField(char *string,
                                    char *delimiters,
                                    int fieldNumber);
   extern char *utGetBracketedField(char *string,
                                    char *leadingBracket,
                                    char *trailingBracket);
   extern int utCountCharacterInString(char *string,
                                       char character);
   extern utLogical utStringContainsCharacter(char *string,
                                              char character);
   extern void utSubstituteCharacterInString(char *string,
                                             char characterBefore,
                                             char characterAfter);
   extern utLogical utStringContainsSubstring(char *string,
                                              char *substring);
   extern char *utSubstituteSubstringInString(char *string,
                                              char *subStringBefore,
                                              char *subStringAfter);
   extern void utSubstituteAllStringsInString(char **buf,
                                              char *stringBefore,
                                              char *stringAfter);
   extern void utReplaceAllStringsInString(char *buf,
                                           int nBuf,
                                           char *stringBefore,
                                           char *stringAfter);
   extern char *utStripWhiteSpace(char *string);
   extern char *utPadStringToLength(char *string,
                                    int paddedLength);
   extern char *utCenterString(char *string,
                               int returnStringWidth);
   extern char *utCenterBracketedString(char *string,
                                        char *leadingBracket,
                                        char *trailingBracket,
                                        int returnStringWidth);
   extern utLogical utIsStringUpper(char *string);
   extern utLogical utIsStringLower(char *string);
   extern char *utCreateStringOfChar(char character,
                                     int length);
   extern char *utGetSingleQuotedCSVField(char *string,
                                          int fieldNumber);
   extern char *utGetDoubleQuotedCSVField(char *string,
                                          int fieldNumber);
   extern char *utGetSingleQuotedTXTField(char *string,
                                          int fieldNumber);
   extern char *utGetDoubleQuotedTXTField(char *string,
                                          int fieldNumber);
   extern char *utExtractString(char *string,
                                int startPosition,
                                int endPosition);
   extern utLogical utIsWildcardString(char *string);
   extern int utPositionOfSubstringInString(char *string,
                                            char *subString);
#else
   extern int utStringLength();
   extern utLogical utEqualStrings();
   extern utLogical utIsNullString();
   extern utLogical utHasAllBlanks();
   extern char *utAssignString();
   extern void utClearString();
   extern void utCatToString();
   extern char *utCatStringPlusString();
   extern char *utCatCStringsWithDelimiter();
   extern void utGetNextColumn();
   extern void utStripTrailingBlanks();
   extern void utStripLeadingBlanks();
   extern void utStripBlanks();
   extern char *utCreateNullString();
   extern void utMakeAllBlanks();
   extern void utMakeAllCharacter();
   extern char *utSearchString();
   extern char *utReverseSearchString();
   extern char *utForwardSearchString();
   extern int utUpper();
   extern int utLower();
   extern int utStrCmpNoCase();
   extern int utStrNCmpNoCase();
   extern void utStringToUpper();
   extern void utStringToLower();
   extern void utFreeCstringArray();
   extern void utCopyColumnFromCstring();
   extern void utAddColumnToCstring();
   extern utLogical utDoesStringMatchPattern();
   extern char *utGetDelimitedField();
   extern char *utGetBracketedField();
   extern int utCountCharacterInString();
   extern utLogical utStringContainsCharacter();
   extern void utSubstituteCharacterInString();
   extern utLogical utStringContainsSubstring();
   extern char *utSubstituteSubstringInString();
   extern void utSubstituteAllStringsInString();
   extern void utReplaceAllStringsInString();
   extern char *utStripWhiteSpace();
   extern char *utPadStringToLength();
   extern char *utCenterString();
   extern char *utCenterBracketedString();
   extern utLogical utIsStringUpper(char *string);
   extern utLogical utIsStringLower(char *string);
   extern char *utCreateStringOfChar();
   extern char *utGetSingleQuotedCSVField();
   extern char *utGetDoubleQuotedCSVField();
   extern char *utGetSingleQuotedTXTField();
   extern char *utGetDoubleQuotedTXTField();
   extern char *utExtractString();
   extern utLogical utIsWildcardString();
   extern int utPositionOfSubstringInString();
#endif

#ifdef __cplusplus
   }
#endif

#endif
