/*
  $RCSfile: utsysclu.c,v $       $Revision: 1.7 $
  $State: V7_0 $                  $Date: 2004/07/27 10:06:10 $
*/
#include "uttypesu.h"
#include "utmacrou.h"
#include "utmemryu.h"
#include "utstrngu.h"
#include "utsysclu.h"
#include "utfilesu.h"
#include "utlicenu.h"

#ifdef BPTUNIX
#include <sys/wait.h>

#ifdef __STDC__
int utSystemCall(char *systemCommand,
                 utLogical background,
                 utLogical rawstatus,
                 char *statusCodePath)
#else
int utSystemCall(systemCommand,
                 background,
                 rawstatus,
                 statusCodePath)
char      *systemCommand;
utLogical  background;
utLogical  rawstatus;
char      *statusCodePath;
#endif
{
   int statusCode;

   statusCode = system(systemCommand);
   if(!rawstatus)
      statusCode = WEXITSTATUS(statusCode);

   return(statusCode);
}
#endif


#ifdef BPTVMS
#include <descrip.h>
#include <clidef.h>
#include <ssdef.h>
#include <lib$routines.h>

#define WEXITSTATUS(statusCode)  ((statusCode == 1) ? 0 : 1)

#ifdef __STDC__
int utSystemCall(char *systemCommand,
                 utLogical background,
                 utLogical rawstatus,
                 char *statusCodePath)
#else
int utSystemCall(systemCommand,
                 background,
                 rawstatus,
                 statusCodePath)
char      *systemCommand;
utLogical  background;
utLogical  rawstatus;
char      *statusCodePath;
#endif
{
   static char    cmdStr[MAX_COMMAND_LENGTH];
   int            statusCode;
   $DESCRIPTOR(command,cmdStr);
   unsigned long  flags,vax_status;
   int           *command_status;

   strcpy(cmdStr,systemCommand);
   command.dsc$w_length = utStringLength(cmdStr);
   if(background) {
      flags = CLI$M_NOWAIT | CLI$M_NOTIFY;
      vax_status = lib$spawn(&command,0,0,&flags,0,0,
                             &command_status);
      if(vax_status != SS$_NORMAL) lib$stop(vax_status);
      statusCode = 1;
   } else {
      flags = 0;
      vax_status = lib$spawn(&command,0,0,0,0,0,
                             &command_status,0,0,0,0,0);
      if(vax_status != SS$_NORMAL) lib$stop(vax_status);
      statusCode = (int)command_status;
   }

   if(!rawstatus)
      statusCode = WEXITSTATUS(statusCode);

   return(statusCode);
}
#endif

#ifdef BPTPC
#include <windows.h>
#include <process.h>

#ifdef __STDC__
int utSystemCall(char *systemCommand,
                 utLogical background,
                 utLogical rawstatus,
                 char *statusCodePath)
#else
int utSystemCall(systemCommand,
                 background,
                 rawstatus,
                 statusCodePath)
char      *systemCommand;
utLogical  background;
utLogical  rawstatus;
char      *statusCodePath;
#endif
{
   int        statusCode;
   FILE      *fp;
   utLogical  fileRemoved;
   int        nAttempts = 0;

   statusCode = system(systemCommand);

   if(!rawstatus && !utIsNullString(statusCodePath)) {
      while(!utFileExist(statusCodePath) && (nAttempts < 5)) {
         Sleep(1000);
         nAttempts++;
      }
      if((fp = utFileOpen(statusCodePath,FileOpenStatusRead)) != NULL) {
         fscanf(fp," %d",&statusCode);
         utFileClose(fp);
      } else
         statusCode = 1;

      fileRemoved = utRemoveFile(statusCodePath);
   }

   return(statusCode);
}
#endif


#ifdef __STDC__
char *utGetEnvironmentVariable(char *variableName)
#else
char *utGetEnvironmentVariable(variableName)
char *variableName;
#endif
{
   char *environmentVariable = utCreateNullString();
   char *value = getenv(variableName);

   if(!utIsNullString(value)) {
      utFreeBytes((pVoid)environmentVariable);
      environmentVariable = utAssignString(value);
   }

   return(environmentVariable);
}


#ifdef __STDC__
char *utGetBPT_ROOTPath()
#else
char *utGetBPT_ROOTPath()
#endif
{
   char *BPT_ROOTPath = utGetEnvironmentVariable("BPT_ROOT");

   return(BPT_ROOTPath);
}

static char *utBAT_VERSN = NULL;

#ifdef __STDC__
char *utGetBAT_VERSN()
#else
char *utGetBAT_VERSN()
#endif
{
   return(utBAT_VERSN);
}


#ifdef __STDC__
void utSetBAT_VERSN(char *version)
#else
void utSetBAT_VERSN(version)
char *version;
#endif
{
   utFreeBytes((pVoid)utBAT_VERSN);

   if(!utIsNullString(version))
      utBAT_VERSN = utCatStringPlusString(BAT_VERSIONPREFIX,"",version);
}


#ifdef __STDC__
char *utGetBAT_VERSNPath()
#else
char *utGetBAT_VERSNPath()
#endif
{
   char *BPT_ROOTPath = utGetBPT_ROOTPath();
   char *BAT_ROOTPath;
   char *BAT_VERSNPath;

   assert(!utIsNullString(utBAT_VERSN));

   if(utStringContainsSubstring(BPT_ROOTPath,BATCHESDIRECTORY))
      BAT_VERSNPath = utMakeSubDirectoryName(BPT_ROOTPath,utBAT_VERSN);
   else {
      BAT_ROOTPath = utMakeSubDirectoryName(BPT_ROOTPath,BATCHESDIRECTORY);
      BAT_VERSNPath = utMakeSubDirectoryName(BAT_ROOTPath,utBAT_VERSN);
      utFreeBytes((pVoid)BAT_ROOTPath);
   }
   utFreeBytes((pVoid)BPT_ROOTPath);

   return(BAT_VERSNPath);
}


#ifdef __STDC__
char *utGetBAT_DATAPath()
#else
char *utGetBAT_DATAPath()
#endif
{
   char *BAT_VERSNPath = utGetBAT_VERSNPath();
   char *BAT_DATAPath = utMakeSubDirectoryName(BAT_VERSNPath,
                                               BAT_DATADIRECTORY);

   utFreeBytes((pVoid)BAT_VERSNPath);

   return(BAT_DATAPath);
}


#ifdef __STDC__
char *utGetBAT_DATAForLicensePath()
#else
char *utGetBAT_DATAForLicensePath()
#endif
{
   char *BAT_DATAForLicensePath = NULL;
   char *BAT_DATAPath = utGetBAT_DATAPath();
   char *subDirectory = "";

   BAT_DATAForLicensePath = utMakeSubDirectoryName(BAT_DATAPath,
                                                   subDirectory);
   utFreeBytes((pVoid)BAT_DATAPath);

   return(BAT_DATAForLicensePath);
}


#ifdef __STDC__
char *utGetBAT_DTESTPath()
#else
char *utGetBAT_DTESTPath()
#endif
{
   char *BAT_VERSNPath = utGetBAT_VERSNPath();
   char *BAT_DTESTPath = utMakeSubDirectoryName(BAT_VERSNPath,
                                                BAT_DTESTDIRECTORY);

   utFreeBytes((pVoid)BAT_VERSNPath);

   return(BAT_DTESTPath);
}


#ifdef __STDC__
char *utGetBAT_EXAMPLESPath()
#else
char *utGetBAT_EXAMPLESPath()
#endif
{
   char *BAT_VERSNPath = utGetBAT_VERSNPath();
   char *BAT_EXAMPLESPath = utMakeSubDirectoryName(BAT_VERSNPath,
                                                   BAT_EXAMPLESDIRECTORY);

   utFreeBytes((pVoid)BAT_VERSNPath);

   return(BAT_EXAMPLESPath);
}


#ifdef __STDC__
char *utGetBAT_EXECSPath()
#else
char *utGetBAT_EXECSPath()
#endif
{
   char *BAT_VERSNPath = utGetBAT_VERSNPath();
   char *BAT_EXECSPath = utMakeSubDirectoryName(BAT_VERSNPath,
                                                BAT_EXECSDIRECTORY);

   utFreeBytes((pVoid)BAT_VERSNPath);

   return(BAT_EXECSPath);
}


#ifdef __STDC__
char *utGetBAT_LIBSPath()
#else
char *utGetBAT_LIBSPath()
#endif
{
   char *BAT_VERSNPath = utGetBAT_VERSNPath();
   char *BAT_LIBSPath = utMakeSubDirectoryName(BAT_VERSNPath,
                                               BAT_LIBSDIRECTORY);

   utFreeBytes((pVoid)BAT_VERSNPath);

   return(BAT_LIBSPath);
}


#ifdef __STDC__
char *utGetBAT_SOURCEPath()
#else
char *utGetBAT_SOURCEPath()
#endif
{
   char *BAT_VERSNPath = utGetBAT_VERSNPath();
   char *BAT_SOURCEPath = utMakeSubDirectoryName(BAT_VERSNPath,   
                                                 BAT_SOURCEDIRECTORY);

   utFreeBytes((pVoid)BAT_VERSNPath);

   return(BAT_SOURCEPath);
}


#ifdef __STDC__
char *utGetBAT_PROPERTYDATAPath()
#else
char *utGetBAT_PROPERTYDATAPath()
#endif
{
   char *BAT_DATAPath = utGetBAT_DATAPath();
   char *BAT_PROPERTYDATAPath = utMakeSubDirectoryName(BAT_DATAPath,
                                                       BAT_PROPERTYDATADIRECTORY);

   utFreeBytes((pVoid)BAT_DATAPath);

   return(BAT_PROPERTYDATAPath);
}


#ifdef __STDC__
char *utGetCommandPath(char *command)
#else
char *utGetCommandPath(command)
char *command;
#endif
{
   char *commandPath;
   char *currentWorkingDirectory = utGetCurrentWorkingDirectory();
   char *BAT_EXECSPath;

   commandPath = utMakeFileName(currentWorkingDirectory,
                                command,"");
   if(!utFileExist(commandPath)) {
      utFreeBytes((pVoid)commandPath);
      BAT_EXECSPath = utGetBAT_EXECSPath();
      commandPath = utMakeFileName(BAT_EXECSPath,
                                   command,"");
      if(!utFileExist(commandPath)) {
         utFreeBytes((pVoid)commandPath);
         commandPath = utAssignString(command);
      }
      utFreeBytes((pVoid)BAT_EXECSPath);
   }
   utFreeBytes((pVoid)currentWorkingDirectory);

   return(commandPath);
}


