/*
  $RCSfile: uttypesu.h,v $       $Revision: 1.9 $
  $State: V7_1 $                  $Date: 2004/12/08 16:38:09 $
*/
#ifndef _UTTYPESU_H
#define _UTTYPESU_H

#ifdef __cplusplus
   extern "C" {
#endif

#ifdef __STDC__
typedef       void *pVoid;
typedef const void *pConstVoid;
#else
#include <sys/types.h>
typedef caddr_t pVoid;
#endif

#ifdef BPTPC
typedef __int64 utLongLong;
#else
typedef long long utLongLong;
#endif

typedef enum {
   utFalse = 0,
   utTrue  = 1
} utLogical;

typedef enum {
   utTriStateFalse = 0,
   utTriStateTrue  = 1,
   utTriStateMixed = 2
} utTriState;

typedef void      (*pVoidFunction)();
typedef pVoid     (*pFunctionReturningpVoid)();
typedef utLogical (*pFunctionReturningutLogical)();
typedef int       (*pFunctionReturningInt)();

typedef enum {
   CaseTypeSensitive   = 1,
   CaseTypeInsensitive = 2
} utCaseType;

typedef enum {
   SearchTypeForward = 1,
   SearchTypeReverse = 2
} utSearchType;

typedef enum {
   EditModeReadOnly  = 1,
   EditModeReadWrite = 2
} utEditMode;

#ifdef __STDC__
   extern utLogical utIsInteger(char *string);
   extern utLogical utIsPositiveInteger(char *string);
   extern utLogical utIsNonNegativeInteger(char *string);
   extern utLogical utIsNegativeInteger(char *string);
   extern utLogical utIsLong(char *string);
   extern utLogical utIsPositiveLong(char *string);
   extern utLogical utIsNonNegativeLong(char *string);
   extern utLogical utIsNegativeLong(char *string);
   extern utLogical utIsDouble(char *string);
   extern utLogical utIsPositiveDouble(char *string);
   extern utLogical utIsNonNegativeDouble(char *string);
   extern utLogical utIsNegativeDouble(char *string);
   extern utLogical utIsNumber(char *string);
   extern utLogical utIsDateTime(char *string);
#else
   extern utLogical utIsInteger();
   extern utLogical utIsPositiveInteger();
   extern utLogical utIsNonNegativeInteger();
   extern utLogical utIsNegativeInteger();
   extern utLogical utIsLong();
   extern utLogical utIsPositiveLong();
   extern utLogical utIsNonNegativeLong();
   extern utLogical utIsNegativeLong();
   extern utLogical utIsDouble();
   extern utLogical utIsPositiveDouble();
   extern utLogical utIsNonNegativeDouble();
   extern utLogical utIsNegativeDouble();
   extern utLogical utIsNumber();
   extern utLogical utIsDateTime();
#endif

#ifdef __cplusplus
   }
#endif

#endif
